#ifndef __LWIPOPTS_H__
#define	__LWIPOPTS_H__

void DBG(void);

#define	MEM_SIZE					8192

#define	MEMP_NUM_RAW_PCB			2
#define	MEMP_NUM_UDP_PCB			2		// Usando slo el API RAW
#define	MEMP_NUM_TCP_PCB			0		// Usando slo el API RAW
#define	MEMP_NUM_TCP_PCB_LISTEN		0
#define	MEMP_NUM_NETBUF				0		// Usando slo el API RAW
#define	PBUF_LINK_HLEN				14		// 14 es para ethernet... PPP?
#define	ARP_TABLE_SIZE				2		// Se usa con PPP?
#define	ARP_QUEUEING				0
#define	TCP_QUEUE_OOSEQ				0
#define	LWIP_STATS_DISPLAY			1
#define	RAW_STATS					1

#define	PPP_SUPPORT					1
#define	MD5_SUPPORT					1
#define	CHAP_SUPPORT				1

#define	LWIP_DEBUG
#define	DBG_TYPES_ON				(DBG_TRACE/*|DBG_STATE*/)

#define	NETIF_DEBUG					DBG_ON
#define	API_LIB_DEBUG				DBG_ON
#define	API_MSG_DEBUG				DBG_ON
#define	INET_DEBUG					DBG_ON
#define	IP_DEBUG					DBG_ON
#define	RAW_DEBUG					DBG_ON
#define	MEM_DEBUG					DBG_ON
#define	MEMP_DEBUG					DBG_ON
#define	SYS_DEBUG					DBG_ON
#define	TCP_DEBUG					DBG_ON
#define	UDP_DEBUG					DBG_ON
#define	TCPIP_DEBUG					(DBG_TYPES_ON | DBG_ON)
#define	PPP_DEBUG					DBG_ON

#endif