
#ifndef _EFC_h
#define _EFC_h

//#include "TypesDef.h"
#define u32 unsigned 
#define u8  unsigned char 
//  -   FLASH 
//    /   EFC_PAGE_SIZE


// AT91SAM7S256
//  0x00100000  0x00140000

#define EFC_PAGE_SIZE 256
#define EFC_PAGE_COUNT 1024
#define EFC_PagesInTheLockRegion 64


#define EFC_PAGE_SIZE_UINT (EFC_PAGE_SIZE/4) //  unsigned int


void EFC_Init(void);

// adr   0x00100000      EFC_PAGE_SIZE
// pbuf ..  EFC_PAGE_SIZE_UINT int
//    ,    - 10000 
//    .   ,  LOCK
//   FLASH  ,      :-)
//      ,      FLASH
//    ,  AT91F_disable_interrupt();EFC_WritePage();AT91F_enable_interrupt();
__ramfunc u32 EFC_WritePage(u32 adr, u32 *pbuf);

//    ,  , Reset
__ramfunc void EFCWrite(u32 adr, u8 *pbuf, u32 Len);


__ramfunc u32 EFC_WritePage(u32 adr, u32 *pbuf);


#endif



