/***********************************************************

                      ADC demonstration

      Connections:
        (ADC)
        ADVREF to +3.3V
        AD4 to ADJ0


        (LCD)
        PA0 to D4
        PA1 to D5
        PA2 to D6
        PA3 to D7
        PA4 to RS
        PA5 to E
        CONTRAST TO Vc
        +5V TO LGT

 ***********************************************************/

//#include <targets/AT91SAM7.h>
#include "Project.h"
//#include "lcd.h"
#include "delay.h"
#include "adc.h"
#define  CHANNEL 5

short int data;
unsigned char bar_pos, bar[16], temp;
char val[]="xxxx", testz[]="\x04\x01\x02\x03";
/*
//custom chars for HD44780 lcd driver
char chars[]={0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1f,   //1 px height bar
              0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1f, 0x1f,   //2 px height bar
              0x00, 0x00, 0x00, 0x00, 0x00, 0x1f, 0x1f, 0x1f,   //3 px height bar 
              0x00, 0x00, 0x00, 0x00, 0x1f, 0x1f, 0x1f, 0x1f,   //4 px height bar 
              0x00, 0x00, 0x00, 0x1f, 0x1f, 0x1f, 0x1f, 0x1f,   //5 px height bar 
              0x00, 0x00, 0x1f, 0x1f, 0x1f, 0x1f, 0x1f, 0x1f,   //6 px height bar 
              0x00, 0x1f, 0x1f, 0x1f, 0x1f, 0x1f, 0x1f, 0x1f,   //7 px height bar
              0x1f, 0x1f, 0x1f, 0x1f, 0x1f, 0x1f, 0x1f, 0x1f};  //8 px height bar
*/

int adctst(void)
{
//  AT91C_BASE_SYS->RSTC_MR |= 0xa5000001; // enable user reset

    AT91C_BASE_DBGU->DBGU_MR = AT91C_US_CHMODE_NORMAL;

  AT91C_BASE_SYS->PMC_PCER = 1 << 2; // Enable PIOA timer clock.
/*
  LcdInit();

  LcdWriteUserChars(chars); //write chars to lcd memory 

  LcdClear();
  LcdSetCursor(0x40);
  LcdPrint(" ADC Value=");
*/  
  //ADC_Init(channels, prescaler);
  ADC_Init(1<<CHANNEL, 10);

  while(1)
  {
    ADC_StartConversion(); //start the convertion
    while (!(ADC_DataReady(CHANNEL))); //wait till conversion ends
    data = ADC_ReadChannel(CHANNEL); //read sampled data
    
    //do oscilloscope-like effect
    bar[bar_pos] = data/128; //update bar
    temp = 16;
//    LcdSetCursor(0x00);
//    while (temp--) LcdPrintChar(bar[(16-temp+bar_pos)%16]);

    if (++bar_pos == 16)
      bar_pos = 0;

    //print sampled data

    val[3] = data%10 + '0'; data/=10;
    val[2] = data%10 + '0'; data/=10;
    val[1] = data%10 + '0'; data/=10;
    val[0] = data%10 + '0';
//    LcdSetCursor(0x4B);
//    LcdPrint(val);

    delay(100000);
  }

  return 0;    
}


