/*----------------------------------------------------------------------------
/* extern void AT91F_enable_interrupt(void);
/* Enable Core interrupt
/*----------------------------------------------------------------------------*/

void  AT91F_Enable_Interrupt()
{ asm("mrs r0,CPSR");
  asm("bic r0,r0,#(I_BIT | F_BIT)");
  asm("msr CPSR_c,r0");
}


/*----------------------------------------------------------------------------
/* extern void AT91F_disable_interrupt(void);
/* Disable Core interrupt
/*----------------------------------------------------------------------------*/

void AT91F_Disable_Interrupt()
{
asm("mrs r0,CPSR");
asm("orr r0,r0,#(I_BIT | F_BIT)");
asm("msr CPSR_c,r0");
asm("mrs r0,CPSR");
asm("ands r0,r0,#(I_BIT | F_BIT)");
asm("beq AT91F_Disable_Interrupt");
}
