128 CONSTANT TC/L

CREATE CMGRBUF 161 ALLOT
CREATE TTIB TC/L ALLOT
VARIABLE ATIB 
VARIABLE #TIB
VARIABLE >IN
VARIABLE T>IN_WORD
\ VARIABLE ER>IN
VARIABLE &S-ID


\ VARIABLE SAVEERR?
: >IN_WORD_ T>IN_WORD ;

: C/L_ TC/L ;

: TIB ATIB @ ;

: SOURCE TIB #TIB @ ;

: SOURCE! ( c-addr u -- ) 
\   c-addr u   (,   - PARSE-AREA)
  #TIB ! ATIB ! ;

0 [IF]
: SAVEERR
	DUP SAVEERR? @ AND
	IF  SOURCE ERRTIB $! T>IN_WORD @ ER>IN ! SAVEERR? OFF
	THEN
;

[THEN]

: EndOfChunk ( -- flag )
 >IN @ SOURCE NIP < 0=        \ >IN  ,   
;

: IsDelimiter ( char -- flag )
 BL 1+ < ;

: CharAddr ( -- c-addr )
  SOURCE DROP >IN @ +
;

: PeekChar ( -- char )
  CharAddr C@       \     >IN
;

: GetChar ( -- char flag )
	EndOfChunk
	IF 0 FALSE
	ELSE PeekChar TRUE THEN ;

: OnDelimiter ( -- flag )
	GetChar SWAP IsDelimiter AND ;

: SkipDelimiters ( -- ) \   
	BEGIN	OnDelimiter
	WHILE	>IN 1+!
	REPEAT >IN @   T>IN_WORD ! ;

: OnNotDelimiter ( -- flag )
  GetChar SWAP IsDelimiter 0= AND ;

: SkipWord ( -- ) \   
 BEGIN	OnNotDelimiter
 WHILE	>IN 1+!
 REPEAT ;

: CharAddr ( -- c-addr )
 SOURCE DROP >IN @ + ;

: ParseWord ( -- c-addr u )
 CharAddr >IN @  SkipWord
 >IN @ - NEGATE ;

: PARSE-NAME ( -- c-addr u )
  SkipDelimiters
  ParseWord
  >IN @ 1+ #TIB @ MIN >IN !   \    spf3.16
;

: SkipUpTo ( char -- ) \    char
  BEGIN
    DUP GetChar >R <> R> AND
  WHILE
    >IN 1+!
  REPEAT DROP
;

: PARSE ( char "ccc<char>" -- c-addr u ) \ 94 CORE EXT
  CharAddr >IN @
  ROT SkipUpTo
  >IN @ - NEGATE
  >IN 1+!
;

