\ W
1 CONSTANT SVSFG

\ ' CATCH THERE? 0= [IF]
 : CATCH EXECUTE 0 ; \ [THEN]
\ ' THROW THERE? 0= [IF]
  : THROW DROP ; \ [THEN]

VARIABLE ?AT
VARIABLE ?OK
VARIABLE ERROR?
VARIABLE ?USSD
VARIABLE GPRMCSEC
VARIABLE VCAOUT
VARIABLE ALARM?
VARIABLE ALARMQ?
VARIABLE ?SLEEP
VARIABLE &GPS-WAKE
VARIABLE GPSDOWN_TIME 
VARIABLE SGTIME
VARIABLE &TRACKEND
VARIABLE TEST_DATA
VARIABLE ?ACCPARK
VARIABLE AUTOREST_TIME
VARIABLE NSatellites 
VARIABLE PPPVseconds

: ?STACK ( -> ) \   " ",     
  SP@ S0 @ SWAP U< IF -4 THROW THEN
;

: SINTERPRET ( -> ) \   
 CR  ." S=" \ SOURCE TYPE
\  SAVEERR? ON
  BEGIN
	PARSE-NAME  ." <" 2DUP TYPE ." >"  DEPTH 2 - .
 DUP
  WHILE
 SFIND \ CR ." SS" 2DUP H. H. 
    IF  [CHAR] * EMIT  EXECUTE
    ELSE [CHAR] # EMIT  ?SLITERAL0
    THEN
\    ?STACK
  DEPTH 0< IF SP@ S0 ! THEN

  REPEAT  2DROP
  DEPTH 0< IF SP@ S0 ! THEN

\ CR ." YY"
;

VARIABLE  &INTERPRET

: INTERPRET &INTERPRET @ EXECUTE ;

: EVALUATE-WITH ( i*x c-addr u xt -- j*x )
   SOURCE 2>R &S-ID @ >R  >IN @ >R >IN 0!
  >R  SOURCE!  -1 &S-ID !
  R> ( ['] INTERPRET) CATCH
\  NR> RESTORE-SOURCE
  R> ." IN=" DUP H. >IN !
  R> &S-ID !
  2R>
  SOURCE!
  THROW ;

: EVALUATE ( i*x c-addr u -- j*x ) \ 94
  ['] INTERPRET EVALUATE-WITH ;

: GEVALUATE ( i*x c-addr u -- j*x ) \ 94
  ['] GINTERPRET EVALUATE-WITH ;


VARIABLE TIME_CREG


: GPS_SLEEP
 BEGIN 
CR ." GPS_SLEEP<"
	GPS_SW_OFF	2 SECS
	BEGIN PINPUT?	
	WHILE PINPUT EMIT
	REPEAT			2 SECS
	PINPUT? 0=
  UNTIL	." >GPS_SLEEP"
\ EXTPGPS_OFF
;


: GPSRESET_
 CR ." GPSRESET_"
 GPS_SLEEP 1 SECS GPS_INIT \ !!!!!! EXTPGPS_OFF
;
2VARIABLE GTIME
2VARIABLE GDATA
XVARIABLE Glong
XVARIABLE Glat
XVARIABLE GSPED
XVARIABLE Gcourse


VARIABLE TIME_GPS_RESET
VARIABLE NGPSS
VARIABLE ?MQUIT
VARIABLE ?STT

\ mins -> amins

: STT_WORCH
	INPUT? IF   INPUT #START CR ." #in=" 2DUP H. H.  =
		IF	-1 ?STT +!
		ELSE	1 ?STT !
		THEN
	." stt=" ?STT @ .
	  THEN

;

VARIABLE ICOUNT

: GREFILL ( -- flag )
\ WDT_CHOP
 #TIB 0! >IN 0!
\ ivanov
\ DO_GSM PERFORM
\ ivanov

GINPUT? 0=
?PPP @ -1 = OR IF GPS-STEP DROP 0 EXIT THEN

    CR ." GR DL"
 BEGIN 
\ KEY? IF -1 EXIT THEN
 GINPUT
 DUP [CHAR] I = IF 1 ICOUNT +!
		ELSE ICOUNT 0! 
		THEN
   ICOUNT @ 4 = IF DROP 0 EXIT THEN

\ DUP  [CHAR] $ EMIT H.
 DUP  0x20 U< 0= 
 WHILE TC/L #TIB C@ U> 
	IF SOURCE + C! #TIB 1+!
	ELSE DROP
	THEN      3 aseconds @ +
	BEGIN STT_WORCH  ?STT  @ 0< IF ." GREFILL>stt" R@ H.  2DROP 0 EXIT THEN
   DUP aseconds @  - 0<
		IF DROP CR ." GREFILL TIMEOUT={" SOURCE HEXTYPE ." }"
  0 EXIT THEN     6 GTICS \ WDT_CHOP
	GINPUT?
	UNTIL   DROP
 REPEAT DROP
 TRUE ;

: GQUIT ( -- )
  SOURCE 2>R >IN @ >R  TTIB ATIB !
  BEGIN
\	3 GTICS \ 1 TICS
        STT_WORCH
        ?STT  @ 0< IF WDT_CHOP ?MQUIT ON R> >IN ! 2R> SOURCE!
." GQUIT>stt" R@ H.
 EXIT THEN
      GREFILL
  WHILE      SINTERPRET
  REPEAT 
 R> >IN !
 2R> SOURCE!
\ ." GQUIT>E" R@ H.
;


: ATE0 S" ATE0" GTYPE GCR  ;  \ ECHO OFF
: ATE1 S" ATE1" GTYPE GCR  ;  \ ECHO OFF

: AATT S" AT" GTYPE GCR  ;

: YYY S" ATZ" GTYPE GCR
S" AT+CMGF=1" GTYPE GCR
 ATE0 ;

VARIABLE NSMS
VARIABLE GTIB		90  ALLOT
VARIABLE GPRMC[]	90  ALLOT
VARIABLE VPRMC[]	90  ALLOT
\ VARIABLE ATDBUF	100 ALLOT

(
: DELETE-SMS S" AT+CMGD=" GTYPE GEMIT GCR ;
: 10+DELETE-SMS S" AT+CMGD=1" GTYPE GEMIT GCR ;

: DELETE-20SMS
 
 CR ." SMSDELS=" 
  0x30
  BEGIN 1+ DUP DUP EMIT SPACE DELETE-SMS DUP 0x39 =
  UNTIL DROP

  0x2F
  BEGIN 1+ DUP ." 1"  DUP EMIT SPACE 10+DELETE-SMS DUP 0x39 =
  UNTIL DROP
  
;
)



VARIABLE CMGL_BUF 6 ALLOT
VARIABLE CMGL  \  +CMGL


: TIMEOKERR ( n -- )
 DUP \ ????
 SP@ 4 + >R
 ?OK OFF   ERROR? OFF \ 2 ?STT !
aseconds @ + >R
CR  ." TIKR " 
	BEGIN   GQUIT R@ aseconds @  -
		11 OVER  1 = IF DROP 1 THEN TICS
		 DUP . 0< 
		?OK @ OR
		ERROR? @ OR
	UNTIL   
." END TKR " CR 

RDROP
 R> SP!
 DROP
 ." TIMEOK>#" R@ H.
 ;

:  AT+CMGDA   S" AT+CMGDA=" GTYPE
 [CHAR] " GEMIT
  S" DEL ALL" GTYPE
 [CHAR] " GEMIT
 GCR
;

: DELETE-SMS-L
        AT+CMGDA
        5 TIMEOKERR
;

\ BEGIN	CMGL OFF .GSM
\	S" AT+CMGL=" GTYPE
\	[CHAR] " GEMIT	S" ALL" GTYPE
\	[CHAR] " GEMIT	GCR
\ CMGL @ 0=
\ UNTIL


: GPRMC1
 S" GPRMC,111911.0,A,6001.26268,N,03022.12904,E,000.0,163.2,081005,08.1,E,A*3C"
  GPRMC[] $! ;

: GSM_INIT
 GPRMC[] 0!
  S' AT+CPMS="SM","SM","SM"' GTYPE GCR
   5 TIMEOKERR
\  DELETE-20SMS 	.GSM
  DELETE-SMS-L ;

: READ-SMS S" AT+CMGR=" GTYPE
  NSMS C@ GEMIT
  NSMS 1+ C@ ?DUP IF GEMIT THEN
 GCR ;


DALIGN
CREATE TNUM 20 ALLOT
DALIGN
CREATE layer_BUFF 0x100 ALLOT


0 [IF]
: UXTYPE16 ( c-addr1 u --- )
\ Output the string starting at c-addr and length u to the terminal.
   OVER + SWAP BEGIN 2DUP -
 WHILE DUP C@
    DUP 192 <
    IF	S" 00"
    ELSE 176 - S" 04"
    THEN XTYPE
   0 (D.) DROP 2 XTYPE
 CHAR+ REPEAT 2DROP ;

[THEN]


10 CONSTANT \number

\number 5 M_* CONSTANT baza_SIZE

HDALIGN
CREATE baza[] baza_SIZE ALLOT
HDALIGNED
CREATE Number[] \number 3 M_* ALLOT
HVARIABLE TIME_SLEEP
HVARIABLE &INTIMEOUT
HVARIABLE KVIOL
HVARIABLE VTST
HVARIABLE VTRACK
HVARIABLE VVOICE
HVARIABLE VGPSPIT
HVARIABLE TIME_STOP
HVARIABLE SPEED_STOP
HVARIABLE TIME_MOVE
HVARIABLE SPEED_MOVE
HVARIABLE TIME_GPSACC
HVARIABLE SPEED_GPSACC
HVARIABLE MSEK
HVARIABLE SSEK
HVARIABLE SPEED_TST
HVARIABLE ANGLE_ROTATE
HVARIABLE SPEED_ROTATE
HVARIABLE PANGLE_ROTATE
HVARIABLE PSPEED_ROTATE
HVARIABLE VWDT_SAVE
HVARIABLE NPDU?
HVARIABLE ?GPSUP
\ HVARIABLE V7777
HVARIABLE ADCDEL
HVARIABLE SLADCDEL
HVARIABLE RADCDEL
HVARIABLE RSLADCDEL
HVARIABLE GPSADCDEL
HVARIABLE GPSSLADCDEL
HVARIABLE ADCWAIT
HVARIABLE UDPADDR 2 ALLOT
HVARIABLE UDPPORT
HVARIABLE UDP_PERIOD
HVARIABLE VUDP_TIME
HVARIABLE IMEIADDN?
HVARIABLE VWIATUP?
HVARIABLE NGPRSSMS
HVARIABLE GPSBAUD
HVARIABLE PROC_FLAGS



DHERE baza[] - CONSTANT FL_SIZE


0x2B000 CONSTANT Fbaza[]
Fbaza[]		\number 5 M_* + CONSTANT Fnumber[]
Fnumber[]	\number 3 M_* + CONSTANT FTIME_SLEEP
HDALIGNED
FTIME_SLEEP
2+ DUP CONSTANT FINTIMOUT
2+ DUP CONSTANT FKVIOL
2+ DUP CONSTANT FTST
2+ DUP CONSTANT FTRACK
2+ DUP CONSTANT FVOICE
2+ DUP CONSTANT FGPSPIT
2+ DUP CONSTANT FTIME_STOP
2+ DUP CONSTANT FSPEED_STOP  
2+ DUP CONSTANT FTIME_MOVE   
2+ DUP CONSTANT FSPEED_MOVE
2+ DUP CONSTANT FTIME_GPSACC
2+ DUP CONSTANT FSPEED_GPSACC
2+ DUP CONSTANT FMSEK
2+ DUP CONSTANT FSSEK
2+ DUP CONSTANT FSPEED_TST
2+ DUP CONSTANT FANGLE_ROTATE
2+ DUP CONSTANT FSPEED_ROTATE
2+ DUP CONSTANT FPANGLE_ROTATE
2+ DUP CONSTANT FPSPEED_ROTATE
2+ DUP CONSTANT FWDT_SAVE
2+ DUP CONSTANT FNPDU?
2+ DUP CONSTANT F?GPSUP
\ 2+ DUP CONSTANT FV7777
2+ DUP CONSTANT FADCDEL
2+ DUP CONSTANT FSLADCDEL
2+ DUP CONSTANT FRADCDEL
2+ DUP CONSTANT FRSLADCDEL
2+ DUP CONSTANT FGPSADCDEL
2+ DUP CONSTANT FGPSSLADCDEL
2+ DUP CONSTANT FADCWAIT
2+ DUP CONSTANT FUDPADDR 2+
2+ DUP CONSTANT FUDPPORT
2+ DUP CONSTANT FUDP_PERIOD
2+ DUP CONSTANT FUDP_TIME
2+ DUP CONSTANT FIMEIADDN?
2+ DUP CONSTANT FWIATUP?
2+ DUP CONSTANT FNGPRSSMS
2+ DUP CONSTANT FGPSBAUD
2+ DUP CONSTANT FPROC_FLAGS

DROP

\ \number 5 2+ M_* 2+ 2+ 2+ 2+ 2+ 2+ 2+ 2+ 2+ 2+


HVARIABLE WIATUP?

VARIABLE PANGLE_ROTATEAL
VARIABLE PSPEED_ROTATEAL

Fbaza[] 0x200 + CONSTANT layer_BLOCK0

: FL_SAVE
  baza[] Fbaza[] FL_SIZE FCMOVE
;

: GSM_SLEEP
\ GSM_SW
	BEGIN
        .GSM
        -GCR
	VCTS @ IF GSM_SW ELSE S" AT+CPOWD=1" _GTYPE GCR THEN
       
       ."  GSM_SLEEP>" CR
       1 SECS        .GSM
	AATT 1 SECS GINPUT?
	WHILE .GSM
	REPEAT
       4 SECS
        .GSM
;

: deregister
\ DELETE-20SMS CR ." del20sms" CR	 .GSM
\ ivanov
\ DELETE-SMS-L CR ." delsmsl" CR .GSM
\ ivanov
 GSM_SLEEP
\ S" AT+COPS=2" GTYPE GCR
;

: COUNT_GPS_KS 
 0  GTIB COUNT 4 -
 BOUNDS
 DO I C@ XOR LOOP 
;

: GPS_KS
  GTIB COUNT + 3 - 2
 BASE @ >R HEX
  S>NUM
 R> BASE !
;

: DO_GP
  COUNT_GPS_KS GPS_KS  ." KS=" 2DUP H. H. =
		IF	GTIB COUNT GEVALUATE
		THEN
;

: GPS-READ ( -- F )
  PINPUT
\ DUP EMIT
 DUP GTIB $C+!
  DUP 0xD = \ GPS_DO @ AND
  IF \ -1  GPS_DO !
	['] FALSE &GPS-STEP ! \ GPS_DO 0!
     GTIB 1+ S" GPRMC" TUCK COMPARE 0= 
	IF  COUNT_GPS_KS GPS_KS  ." KS=" 2DUP H. H. =
		IF
		GTIB COUNT GPRMC[] $!
		GTIB COUNT GEVALUATE
		THEN
	THEN

     GTIB 1+ S" GPGSV" TUCK COMPARE 0= \ FTST W@ AND
	IF  DO_GP
	THEN
     GTIB 1+ S" GPGGA" TUCK COMPARE 0= \ FTST W@ AND
	IF  DO_GP
	THEN

     GTIB 1+ S" NOOP" TUCK COMPARE 0= \ ." D=" DUP H.
	IF	GTIB COUNT  GEVALUATE
	THEN
	&GPS-WAKE @ &GPS-STEP ! \ GPS_DO 0!
  THEN GTIB C@ 0x7F AND GTIB C!
	amins @ TIME_GPS_RESET ! 
;

: GPS-WAKE
  PINPUT \ DUP EMIT
  DUP [CHAR] $ = 
  IF ['] GPS-READ  &GPS-STEP ! 0 GTIB C!
  THEN ;

ICREATE &IMEI  -1 I, -1 I,

: TRYIMEI
CR ." TY="
 9 TICS   GREFILL DUP . 0= IF 0 EXIT THEN
 SOURCE DUP . DUP 15 <> IF 2DROP 0 EXIT THEN
 S>DOUBLE 2DUP H. H.  &IMEI I2! -1
;

: GSN
 S" AT+GSN"
\ S" ATD*#06#"
 GTYPE GCR
 ;


: SETIMEI
 GSN   1 ?STT !   
   TRYIMEI IF EXIT THEN
   TRYIMEI IF EXIT THEN
   TRYIMEI IF EXIT THEN
   TRYIMEI IF EXIT THEN
   TRYIMEI IF EXIT THEN
   TRYIMEI IF EXIT THEN
   TRYIMEI IF EXIT THEN
   TRYIMEI DROP
;


VARIABLE CALL_READY?

: zregister
CR ." zregister"
 4 SECS
 .GSM CR
   S" AT+CMGF=1" GTYPE GCR
   5 TIMEOKERR
 GPRMC[] 0!
   ATE0
   5 TIMEOKERR

GSM_INIT

	&IMEI @ -1 =
	IF	4 aseconds @ + >R
		BEGIN   GQUIT R@ aseconds @  - 
		timecou  @ 0xF AND 0= IF DUP . THEN  0< 
		UNTIL   RDROP
		SETIMEI
	THEN

  ['] GPS-WAKE  &GPS-STEP !


\    number[] \number + \number +
\	DUP @ -1 <> IF DUP {SEND  S" GSM_ON" GPRMC} THEN DROP


;


: ATD_LEV
  S" ATD" _GTYPE S" +7" _GTYPE  number[] 11 _GTYPE
  S" ;" _GTYPE -GCR
		15 SECS S" ATH0" _GTYPE -GCR ;


: GPS-EMIT  ( -- c )
  PINPUT \ DUP EMIT
;

: GSM_ON
   BEGIN
	AATT
	5 TIMEOKERR ?OK @ 0=
   WHILE
	GSM_SW 3 SECS 
	STT_WORCH  ?STT  @ 0< IF ." GSM_ON>stt" EXIT THEN
   REPEAT
;

: REGISTER
  &GPS-STEP @ >R
   ['] GPS-EMIT  &GPS-STEP !
 BEGIN
CR ." register"


         CALL_READY? 0!   2 amins @ + >R
	BEGIN

ComClr1Tx ComClr1

         GSM_ON
	STT_WORCH  ?STT  @ 0< IF ." REGISTER>stt"  RDROP R> &GPS-STEP ! R@ H. EXIT THEN

 2 \ SECS
 aseconds @ +
 CR ." SECS="
		BEGIN   GQUIT DUP aseconds @  -
			11 OVER  1 = IF DROP 1 THEN TICS
		 	DUP . 0< ?STT @  0= OR
		UNTIL DROP 



  S" AT+CREG?" GTYPE GCR
 5 TIMEOKERR
	R@ amins @  - 0< CALL_READY? @ OR
	?STT @  0< OR
	UNTIL RDROP

        CALL_READY? @

CR ." CALL_READY?" DUP .

  0= 
	2 SECS
CR ." RO4R=A"
       .GSM
    AATT
	?AT OFF 
CR ." RO4R=AAA"
    2 TIMEOKERR
     ?OK @
CR ." RO4R=" 2DUP . .
 0= OR 
CR ." ?STT=" ?STT @ .

  ?STT @ 0> AND

 WHILE GSM_SLEEP 7 SECS
 REPEAT


R> &GPS-STEP !

    zregister

	WIATUP? W@ 0=  \ Borysych
	IF number[] W@ 0xFFFF <> 
		IF  CR ." ATDP"  ATD_LEV
		THEN
	THEN
;


VARIABLE ?GSM_SLEEP

: DEREGPAUSE
?GSM_SLEEP @ DUP
 IF deregister 20 SECS \ YYY
 THEN 0= ?GSM_SLEEP !
register ;



: ATCREG
	?PPP @ \ NGPRSSMS W@ 0= OR
	IF EXIT THEN

	FTST W@ IF EXIT THEN
	VCONNECT @ IF EXIT THEN

	amins @ TIME_CREG @ -    3 >
 	IF   S" AT" GTYPE GCR CR
		amins @ TIME_CREG ! 3 TIMEOKERR
		?OK @ 0= IF ." ATERR" DEREGPAUSE EXIT THEN
		." ATOK"
  S" AT+CREG?" GTYPE GCR  
		
	THEN ;


: ATCREGS
	amins @ TIME_CREG @ -    1 >
 	IF  S" AT+CREG?" GTYPE GCR
		amins @ TIME_CREG !
	THEN ;

: +7XX ( &BAZA[X] c-addr -- )
  2+  SWAP \number CMOVE
  FLCLR  FL_SAVE
;

: BAZAOFF ( &BAZA[X]  -- )
  DUP baza[] = IF DROP EXIT THEN
 0xFFFF SWAP W! FLCLR FL_SAVE
;

: BAZAALL ( -- )
  PARSE-NAME S" OFF" EUCOMPARE IF EXIT THEN
  baza[] baza_SIZE 0xFF FILL
  FLCLR  FL_SAVE 
;

: baza? ( -- flag )
  baza[] @
  baza[] \number	+ C@ AND
  baza[] \number 2*	+ C@ AND
  baza[] \number 3 *	+ C@ AND
  baza[] \number 4 *	+ C@ AND   0xFF = IF	TRUE EXIT THEN
  TNUM 3 + TNUM C@ 2 -
  2DUP baza[]		  10 COMPARE 0= IF 2DROP TRUE EXIT THEN
  2DUP baza[] \number	+ 10 COMPARE 0= IF 2DROP TRUE EXIT THEN
  2DUP baza[] \number 2*	+ 10 COMPARE 0= IF 2DROP TRUE EXIT THEN
  2DUP baza[] \number 3 *	+ 10 COMPARE 0= IF 2DROP TRUE EXIT THEN
  2DUP baza[] \number 4 *	+ 10 COMPARE 0= IF 2DROP TRUE EXIT THEN
  2DROP 0
;

: number?_
\  number[] W@
\  number[] \number + W@ AND   0xFFFF = IF	TRUE EXIT THEN

  TNUM 3 + TNUM C@ 2 -
  2DUP number[]		  10 COMPARE 0= IF 2DROP TRUE EXIT THEN
  2DUP number[] \number	+ 10 COMPARE 0= IF 2DROP TRUE EXIT THEN
  2DROP 0
;

0x372B CONSTANT '+7'
\ 0x464F CONSTANT 'OF'
\ 0x4C41 CONSTANT 'AL'

: bazaX ( n -- )
\ baza? 0= IF DROP #TIB @ >IN ! EXIT THEN
  \number * baza[] + 
  PARSE-NAME 
  IF	DUP 2C@ '+7' = IF	+7XX	EXIT THEN
	DUP 3 S" OFF" EUCOMPARE 0= IF DROP BAZAOFF	EXIT THEN
  THEN 2DROP ;

: NumberX ( n -- )
  baza? 0= IF DROP #TIB @ >IN ! EXIT THEN
  \number * Number[] + 
  PARSE-NAME 
  IF	DUP 2C@ '+7' = IF	+7XX	EXIT THEN
	DUP 3 S" OFF" EUCOMPARE 0= IF DROP BAZAOFF	EXIT THEN
  THEN 2DROP ;

\ $GPRMC,111911.0,A,6001.26268,N,03022.12904,E,000.0,163.2,081005,08.1,E,A*3C
\ $GPGGA,111912.0,6001.26270,N,03022.12903,E,1,04,2.62,00040,M,017,M,,*5B

 VARIABLE h_latitude
XVARIABLE l_latitude
XVARIABLE g_latitude
 VARIABLE h_longtitude
XVARIABLE l_longtitude
XVARIABLE g_longtitude
XVARIABLE latitude_L
XVARIABLE longtitude_L

VARIABLE ?NS
VARIABLE ?EW


: titude DUP titude_ DROP ;
: untitude DUP untitude_ DROP ;

: latitude ( -- X )
 h_latitude @  h_titude !
 l_latitude X@  XSWAP l_titude X!  titude
 g_titude X@ XSWAP
;

: longtitude ( -- X )
 h_longtitude @  h_titude !
 l_longtitude X@  XSWAP l_titude X!  titude
 g_titude X@ XSWAP
;

: SMSEMIT ( c -- )
  NPDU? W@ 0= IF
  BASE @ >R HEX
\  PDU-TAIL 1-!
  2 (.0) XTYPE
 R> BASE !
 EXIT
  THEN
 GEMIT
 ;

: SMSCR
 0xD SMSEMIT ;

: UXTYPE ( c-addr1 u --- )
\ Output the string starting at c-addr and length u to the terminal.
  BASE @ >R HEX
  CR ." UXTYPE=<"
   OVER + SWAP BEGIN 2DUP -
 WHILE DUP C@ 2 (.0)  XTYPE \ SMSEMIT \ 0 (D.) DROP 2 XTYPE
 CHAR+ REPEAT 2DROP
  ." >"
 R> BASE !
 ;

: SMSTYPE
  NPDU? W@ 0= IF UXTYPE EXIT THEN
  GTYPE ;

: CNVTYPE ( c-addr1 u --- )
\ Output the string starting at c-addr and length u to the terminal.
  2DUP + [CHAR] F SWAP C!
   OVER + SWAP BEGIN 2DUP - 1+
 WHILE DUP 1 XOR C@ XEMIT CHAR+ REPEAT 2DROP ;


VARIABLE &length(sms)
: length(sms) &length(sms) @ ;

: CPDU ( -- )
\  &length(sms) !
 BASE @ >R
 DECIMAL
\ S" 26" GTYPE
\  120 PDU-TAIL !
  length(sms) 21 + 0 (D.)  GTYPE

  length(sms) 21 + 1+ 2* PDU-TAIL !

 HEX
\ DUP 20 + 0 (D.) DROP 2 XTYPE
  XCR
 BEGIN GINPUT> ( DUP EMIT ) [CHAR] > = UNTIL
 S" 0041000B91"  XTYPE
\ 41 - 01=PDU Type: MTI=01 ->  SMS + data header
\ 0B -   -1
\ 91= /  
 TNUM 2+ 11 CNVTYPE 
 S" 0004"  XTYPE  
  length(sms) 8 + 0 <# # # #> XTYPE
\ 00=PID   
\ F8/08=DCS    /: 
\ DUP 8 + 0 (D.) DROP 2 XTYPE
 S" 060504141F141F"  XTYPE
\ 06   header
\ 05   (application port)
\ 04    
\ 0x141F=5151 
\   UXTYPE
\   0x1A XEMIT

CR ." PDU-TAIL=" PDU-TAIL @ . 

 R> BASE ! ;


: DO_DISCONNECT
	CR ." do_dis" CR
        1 SECS S" +++"	GTYPE
	3 SECS S" ATH"	GTYPE GCR
	2  TIMEOKERR S" AT+CGATT=0"	GTYPE GCR
	2  TIMEOKERR
	.GSM
	VCONNECT OFF
;

: SEND-SMS ( -- ) \ number of mt
 ?PPP @ -1 = IF 1 ?PPP ! 3 SECS S" +++"	GTYPE 2 TIMEOKERR 2 ?PPP ! THEN

  SMS_PERMIT OFF
  NPDU? W@ 0=
 IF  S" AT+CMGF=0" GTYPE GCR 3 TIMEOKERR
 THEN

 S" AT+CMGS=" GTYPE
  NPDU? W@ 0= IF CPDU EXIT THEN
  [CHAR] " GEMIT  TNUM COUNT GTYPE
  [CHAR] " GEMIT  GCR
  NPDU? W@ IF BEGIN GINPUT> [CHAR] > = UNTIL
  THEN
;

 0x001 CONSTANT PARK_FLG
 0x002 CONSTANT STOP_FLG
 0x004 CONSTANT MOVE_FLG
 0x008 CONSTANT STOP_FIX_FLG
 0x010 CONSTANT MOVE_FIX_FLG
 0x020 CONSTANT PULS_FLG
 0x040 CONSTANT ALARM_FLG
 0x080 CONSTANT ROTATE_FIX_FLG
 0x100 CONSTANT RPARK_FLG
 0x200 CONSTANT RAPARK_FLG
 0x400 CONSTANT TSTOP_FIX_FLG
 0x800 CONSTANT TMOVE_FIX_FLG
0x1000 CONSTANT OUT_FLG

VARIABLE RAD_PARK
VARIABLE RAD_PUL

: FLG_OFF  INVERT PROC_FLAGS  WAND! ;

: FLG_ON  PROC_FLAGS  WOR! ;

: FLG@	PROC_FLAGS W@ AND ; 


: TEST_PARK
 CR ." TT="
  PARK_FLG  FLG@ g_latitude X@ X0= 0= AND 0= IF 0 EXIT THEN 
  RAD_PARK @ latitude   g_latitude   X@ X- X>S ABS 2DUP . . U<
  RAD_PARK @ longtitude g_longtitude X@ X- X>S ABS 2DUP . . U< OR
\  RAD_PARK @ 0 latitude   g_latitude   X@ X- X<    !!!!!
\  RAD_PARK @ 0 longtitude g_longtitude X@ X- X< OR
 ;



VARIABLE PARK_NUM 17 ALLOT
VARIABLE RPARK_NUM 17 ALLOT


VARIABLE L_TIME_GPSACC
VARIABLE L_TIME_STOP
VARIABLE G_SPEED_

VARIABLE L_TIME_MOVE
VARIABLE L_TIME_TSTOP
VARIABLE L_TIME_TMOVE


VARIABLE L_ANGLE_ROTATE
VARIABLE CUR_ANGLE

VARIABLE L_TIME_PULS

VARIABLE layer_BLOCK
VARIABLE layer_addr
XVARIABLE erase_name

: MAX_layer &TRACKEND @ layer_BLOCK0 - 0x200 / 8 * ;
: MAX_layer1 MAX_layer 2* ;

: TOlayer
\	WDT_CHOP
 8 U/MOD 0x200 * layer_BLOCK0 + DUP layer_BLOCK !
	layer_BUFF 0x100 CMOVE
	32 * layer_BUFF + layer_addr ! ;


: layer_latitude1	layer_addr @ ;
: layer_longtitude1	layer_addr @ 4  + ;
: layer_latitude2	layer_addr @ 8  + ;
: layer_longtitude2	layer_addr @ 12 + ;
: layer_NAME		layer_addr @ 16 + ;

VARIABLE N0000 6 ALLOT

: S>N00
  S" 00000" N0000 $! 5 MIN N0000 $!
  N0000 1+ 5  S>DOUBLE ;

: #layer
	DUP TOlayer
	layer_NAME W@ 0xFFFF <> IF EXIT THEN
CR ." layer=" 
  [CHAR] : PARSE 1 MAX 15 MIN 2DUP TYPE layer_NAME $!
 $-TOKEN S>NUM DUP U.	h_latitude	W!	$-TOKEN 2DROP
 $-TOKEN 1- S>N00 DROP	l_latitude	X!	latitude layer_latitude1 X!
 $-TOKEN 2DROP
 $-TOKEN S>NUM DUP U.	h_longtitude	W!	$-TOKEN 2DROP
 $-TOKEN 1- S>N00 DROP	l_longtitude	X!	longtitude layer_longtitude1 X!
 $-TOKEN 2DROP
 $-TOKEN S>NUM DUP U.	h_latitude	W!	$-TOKEN 2DROP
 $-TOKEN 1- S>N00 DROP	l_latitude	X!	latitude layer_latitude2 X!
 $-TOKEN 2DROP
 $-TOKEN S>NUM DUP U.	h_longtitude	W!	$-TOKEN 2DROP
 $-TOKEN 1- S>N00 DROP	l_longtitude	X!	longtitude layer_longtitude2 X!
  layer_BUFF layer_BLOCK @ 0x100 FLCLR FCMOVE
 ." LAYER=" H.
 MAX_layer 1+ ;

: ?inside ( -- flg )
	layer_latitude1		X@ latitude    UX< 0=	IF 0 EXIT THEN
	layer_longtitude1	X@ longtitude  UX< 0=	IF 0 EXIT THEN 
	layer_latitude2		X@ latitude    UX< 	IF 0 EXIT THEN
	layer_longtitude2	X@ longtitude  UX<	IF 0 EXIT THEN
 TRUE
;

: ?inside_L
	layer_latitude1		X@ latitude_L   X@ UX< 0=	IF 0 EXIT THEN
	layer_longtitude1	X@ longtitude_L X@ UX< 0=	IF 0 EXIT THEN 
	layer_latitude2		X@ latitude_L   X@ UX< 		IF 0 EXIT THEN
	layer_longtitude2	X@ longtitude_L X@ UX<		IF 0 EXIT THEN
 TRUE
;

: ?TEST_border
	TOlayer
	layer_NAME W@ 0xFFFF = IF EXIT THEN
	?inside_L ?inside XOR
	IF 2DROP -1 0
	THEN
;

: TEST_border
	FTRACK W@ 0= IF 0 EXIT THEN
	0
	MAX_layer 1+
	BEGIN 1- DUP ?TEST_border DUP 0=
	UNTIL DROP ;

: ?TEST_ZONE ( n -- flg )
	TOlayer
	layer_NAME W@ 0xFFFF = IF EXIT THEN
	?inside
	IF 2DROP -1 0
	THEN
;

: TEST_ZONE ( -- FLAG )
	FTRACK W@ 0= IF 0 EXIT THEN
	0
	MAX_layer 1+
	BEGIN 1- DUP ?TEST_ZONE DUP 0=
	UNTIL DROP ;

: erase_all  
	32 MAX_layer * 2* 0x200 / 1+ 0x200 *  \ !!!!!!!
	BEGIN 0x200 - DUP layer_BLOCK0 +
        DUP ISFLASH EFC_PAGE_SIZE -1 FILL 0x100 +
        DUP ISFLASH EFC_PAGE_SIZE -1 FILL CR  H.
 DUP 0=
	UNTIL DROP FlashSave ;

: ?erase_layer
	TOlayer
	erase_name X@ layer_NAME COUNT EUCOMPARE 0=
	IF -1 layer_NAME ! layer_BUFF layer_BLOCK @ 0x100 FLCLR FCMOVE
	THEN  ;

: TEST_STOP
	CR ." TS="
	TIME_STOP W@ 0xFFFF = IF 0 EXIT THEN 
	G_SPEED_ @ SPEED_STOP W@ 2DUP . . U<
	MOVE_FIX_FLG AND MOVE_FIX_FLG FLG@ XOR
	IF	aseconds @ L_TIME_STOP !
	THEN
	TIME_STOP W@
	aseconds @ L_TIME_STOP @ - 2DUP . .  U< DUP
 	IF DROP MOVE_FIX_FLG FLG@
		MOVE_FIX_FLG FLG_ON
	  	aseconds @ L_TIME_STOP !
	THEN MOVE_FIX_FLG FLG@ .
;


: TEST_GPSACC
	TIME_GPSACC W@ 0xFFFF = IF 0 EXIT THEN 
	CR ." TSG="
	CACTL@ DUP .
	IF	aseconds @ L_TIME_GPSACC ! 0 EXIT
	THEN	
	SPEED_GPSACC W@ G_SPEED_ @ 2DUP . . U<
	IF	aseconds @ L_TIME_GPSACC ! 0 EXIT
	THEN
	TIME_GPSACC W@
	aseconds @ L_TIME_GPSACC @ - 2DUP . .  U<
;

\ : U<= U> 0= ;

: TEST_MOVE ( -- flg )
	CR ." TM="
	TIME_MOVE W@ 0xFFFF = IF 0 EXIT THEN 
	SPEED_MOVE W@ G_SPEED_ @ 2DUP . . U<
	STOP_FIX_FLG AND STOP_FIX_FLG FLG@ XOR
	IF	aseconds @ L_TIME_MOVE !
	THEN
	TIME_MOVE W@
	aseconds @ L_TIME_MOVE @ - 2DUP . .  U<  DUP
 	IF DROP STOP_FIX_FLG FLG@
		STOP_FIX_FLG FLG_ON
	  	aseconds @ L_TIME_MOVE !
	THEN STOP_FIX_FLG FLG@ . ;



: TEST_MSEK ( -- flg )
	CR ." SS="
	MSEK W@ 0xFFFF = FTRACK W@ OR IF 0 EXIT THEN 
	SPEED_TST W@ G_SPEED_ @ 2DUP . . U<
	TSTOP_FIX_FLG AND TSTOP_FIX_FLG FLG@ XOR
	IF	aseconds @ L_TIME_TMOVE !
	THEN
	MSEK W@
	aseconds @ L_TIME_TMOVE @ - 2DUP . .  U<  DUP
 	IF DROP TSTOP_FIX_FLG FLG@
		TSTOP_FIX_FLG FLG_ON
	  	aseconds @ L_TIME_TMOVE !
	THEN TSTOP_FIX_FLG FLG@ . ;

: TEST_SSEK
	CR ." SS="
	SSEK W@ 0xFFFF = FTRACK W@ OR IF 0 EXIT THEN 
	G_SPEED_ @ SPEED_TST W@ 2DUP . . U<
	TMOVE_FIX_FLG AND TMOVE_FIX_FLG FLG@ XOR
	IF	aseconds @ L_TIME_TSTOP !
	THEN
	SSEK W@
	aseconds @ L_TIME_TSTOP @ - 2DUP . .  U< DUP
 	IF DROP TMOVE_FIX_FLG FLG@
		TMOVE_FIX_FLG FLG_ON
	  	aseconds @ L_TIME_TSTOP !
	THEN TMOVE_FIX_FLG FLG@ .
;


: TEST_ROTATE ( -- flg )
	CR ." TR="
	ANGLE_ROTATE W@ CUR_ANGLE @ L_ANGLE_ROTATE @ - ABS . .
	ANGLE_ROTATE W@ 0xFFFF = IF 0 EXIT THEN 
	SPEED_ROTATE W@ G_SPEED_ @ 2DUP . . U>
	IF	0 EXIT
	THEN
        ANGLE_ROTATE W@ CUR_ANGLE @ L_ANGLE_ROTATE @ - ABS
	180 OVER U< IF 360 -  THEN ABS  U> 0=
	DUP
	IF
	DUP .
	THEN
;

: TEST_PROTATE ( -- flg )
	CR ." PR="
	PANGLE_ROTATE W@ CUR_ANGLE @ L_ANGLE_ROTATE @ - ABS . .
	PANGLE_ROTATE W@ 0xFFFF = IF 0 EXIT THEN 
	PSPEED_ROTATE W@ G_SPEED_ @  2DUP . . U>
	255 5 * G_SPEED_ @  U< OR
	IF	0 EXIT
	THEN
        PANGLE_ROTATE W@ 

	CUR_ANGLE @ L_ANGLE_ROTATE @ - ABS
	180 OVER U< IF 360 -  THEN ABS

	 U> ." PRF=" DUP .
;

: TEST_PROTATEAL ( -- flg )
	CR ." PRA="
	PANGLE_ROTATEAL @ CUR_ANGLE @ L_ANGLE_ROTATE @ - ABS . .
	PANGLE_ROTATEAL @ 0xFFFF = IF 0 EXIT THEN 
	PSPEED_ROTATEAL @ G_SPEED_ @  2DUP . . U>
	255 5 * G_SPEED_ @  U< OR
	IF	0 EXIT
	THEN
        PANGLE_ROTATE W@ 

	CUR_ANGLE @ L_ANGLE_ROTATE @ - ABS
	180 OVER U< IF 360 -  THEN ABS

	 U> ." PRF=" DUP .
;



VARIABLE &PROT_N

: TEST_RPARK  ( -- flg )
 CR ." TRP="
  RPARK_FLG FLG@ 0= IF 0 EXIT THEN
  TEST_PROTATE DUP
 IF
	&PROT_N @ 0xF AND 9 <>
	IF  1 &PROT_N +! DROP FALSE
	THEN 
 ELSE 0 &PROT_N !   CUR_ANGLE @ L_ANGLE_ROTATE  !
 THEN
;

VARIABLE &PROTA_N

: TEST_RPARKA  ( -- flg )
 CR ." TRAP="
  RAPARK_FLG FLG@ 0= IF 0 EXIT THEN
  TEST_PROTATEAL DUP
 IF
	&PROTA_N @ 0xF AND 9 <>
	IF  1 	&PROTA_N +! DROP FALSE
	THEN 
 ELSE   &PROTA_N 0!   CUR_ANGLE @ L_ANGLE_ROTATE  !
 THEN
;

: ?Out_off
	PULS_FLG FLG@ 0= IF EXIT THEN 
	RAD_PUL @ DUP 999 U> IF DROP EXIT THEN
\	CR ." TP="
	aseconds @ L_TIME_PULS @
\ 2DUP . .
 - U<
	IF	USER_OUT_OFF
		OUT_FLG FLG_OFF
		PULS_FLG FLG_OFF FLCLR  FL_SAVE
	THEN
;

: unlatitude  ( x -- )
 SWAP g_titude X! untitude
 h_titude @   h_latitude !   
 l_titude X@ SWAP l_latitude X! ;

: unlongtitude  ( d -- )
 SWAP g_titude X!   untitude
 h_titude @   h_longtitude !   
 l_titude X@ SWAP l_longtitude X! ;


: {SEND
   S" +7" TNUM $! \number TNUM $+!
 CR ." SEND=" TNUM COUNT TYPE \ !!!!!
   SEND-SMS
;

VARIABLE VCMGS
VARIABLE ESC_SMS_TYME
: ESC_SMS ( ADDR LEN -- )
\	NPDU? W@ 0= IF CPDU THEN
	
	SMSTYPE
	NPDU? W@ 0=
	IF	PDU-TAIL @ 2/ 0xFF AND
		BEGIN DUP H. S" 20" XTYPE  1- DUP 0=
		UNTIL DROP
	THEN
	NPDU? W@ IF GCR THEN
	26 GEMIT
	VCMGS 0!
	&GPS-STEP @ >R
	['] FALSE &GPS-STEP !  \   
	15  aseconds @ + >R
	BEGIN GQUIT
	ESC_SMS_TYME @ aseconds @ <>
	IF  CR ." GP=" aseconds @ . .GPS CR   aseconds @ ESC_SMS_TYME !
	THEN
	R@ aseconds @  - 0< VCMGS @ OR
	UNTIL RDROP
	R> &GPS-STEP !

  NPDU? W@ 0=
 IF  S" AT+CMGF=1" GTYPE GCR 3 TIMEOKERR
 THEN
 SMS_PERMIT ON

  ?PPP @ 2 =  IF S" ATO"	GTYPE GCR  THEN
  CR ." GPE="  .GPS CR

;

VARIABLE KPRMC_BUF  100 ALLOT

: >KIL  \   
 OVER [CHAR] K SWAP DUP >R C!
  GEVALUATE
 [CHAR] G R> C!
  KPRMC_BUF COUNT
;

\ : KIL2  MPRMC[] COUNT >KIL  CR TYPE ;

: G>KIL
   [CHAR] $ SMSEMIT GPRMC[] COUNT
    FKVIOL W@ 0= IF  >KIL THEN
;
 

: GPRMC}
 SMSTYPE SMSCR G>KIL ESC_SMS ;


: {ZONE} DUP 
	{SEND
	 ?inside IF S" Enter " ELSE S" Exit " THEN SMSTYPE
	layer_NAME COUNT SMSTYPE [CHAR] ; SMSEMIT SMSCR
        G>KIL
 ESC_SMS ;

: GWATCHDOG} ( -- addr len )
 S" WATCHDOG" SMSTYPE
 FWDT_SAVE W@ 0 HEX (D.) DECIMAL  GPRMC} ;


\ VARIABLE GPS_DO


: GPS-TST BEGIN GPS-STEP [CHAR] Q = UNTIL ;

: POLIT S" ZONE POLIT:6000.426N,03022.091E,6000.573N,03022.403E" EVALUATE ;

: TEHSEV S" ZONE TEHSEV:6001.818N,03021.77E,6001.966N,03022.026E" EVALUATE ;

: SVETOR S" ZONE SVETOR:6000.573N,03020.663E,6000.717N,03020.995E" EVALUATE ;

: RTC S" ZONE RTC:6001.115N,03022.0E,6001.305N,03022.403E" EVALUATE ;

: SPB S" ZONE spb:5946.54542N,2956.75903E,6007.42341N,3034.66187E" EVALUATE ;

: TERM_INIT
 TTIB ATIB ! 
\ GPRMC1
 ['] GPS-WAKE DUP &GPS-WAKE ! &GPS-STEP !
 ['] SINTERPRET &INTERPRET !
 Fbaza[] baza[] FL_SIZE CMOVE
 FTIME_SLEEP W@ TIME_SLEEP W!
 FKVIOL W@ KVIOL W!
\ S" NUMBER1 +79626963028" EVALUATE
\  POLIT TEHSEV SVETOR RTC
;


VARIABLE &TRKSEND

VARIABLE SSECS
VARIABLE SMINS
VARIABLE PSMINS

: SEND_ALARM
    number[]
	DUP W@ 0xFFFF <>  mins @ SMINS !
 IF DUP {SEND S" ALARM;" GPRMC} THEN DROP
    number[] \number +
	DUP W@ 0xFFFF <> mins @ SMINS !
 IF DUP {SEND S" ALARM;" GPRMC} THEN DROP
;

: ?SEND_ALARM

\  WASALARM @
\ IF	SEND_ALARM
\	WASALARM OFF
\	ALARM_FLG FLG_OFF
\	mins @ SMINS !
\ THEN

  mins @ SMINS @ = IF EXIT THEN
 GETALARM
IF  ALARM_FLG FLG_ON  aseconds @ SSECS ! EXIT THEN
\  ?SLEEP @  IF EXIT THEN
 

 ALARM_FLG FLG@ 0= IF EXIT THEN

  aseconds @ SSECS @ - FINTIMOUT W@ W>S 1+  < IF EXIT THEN
	CR ." AL="
 ?PPP @ 
 IF  13 &TRKSEND PERFORM
    NGPRSSMS W@ 0=
	IF  SEND_ALARM
	THEN
 ELSE	SEND_ALARM
 THEN
	       	ALARM_FLG FLG_OFF
                mins @ SMINS !
;


VARIABLE ADC5SUM
VARIABLE SADC5SUM
VARIABLE SADC5SUM2
VARIABLE GPSSADC5SUM
VARIABLE GPSSADC5SUM2
VARIABLE ADC5DEL
VARIABLE SLADC5SUM

VARIABLE ADC6SUM
VARIABLE SADC6SUM
VARIABLE SADC6SUM2
VARIABLE GPSSADC6SUM
VARIABLE GPSSADC6SUM2
VARIABLE ADC6DEL
VARIABLE SLADC6SUM


VARIABLE ADC7SUM
VARIABLE SADC7SUM
VARIABLE SADC7SUM2
VARIABLE GPSSADC7SUM
VARIABLE GPSSADC7SUM2
VARIABLE ADC7DEL
VARIABLE SLADC7SUM

VARIABLE &AUTOJUMP
VARIABLE &SLAUTOJUMP

VARIABLE &SEND_ADC
VARIABLE &SEND_SLADC


: ?ACSEL

  100 COUNT5 @ U< IF
  ADC5@ COUNT5 @ /  DUP
  SLADC5SUM @ 5 RSHIFT  -  SLADC5SUM +!
\    ADC5SUM @ 2 RSHIFT  -    ADC5SUM +!
  ADC5SUM !
  DATA5 0! COUNT5 0!
  THEN

  100 COUNT6 @ U< IF
  ADC6@ COUNT6 @ /  DUP
  SLADC6SUM @ 5 RSHIFT  -  SLADC6SUM +!
\    ADC6SUM @ 2 RSHIFT  -    ADC6SUM +!
 ADC6SUM !
  DATA6 0! COUNT6 0!
   THEN

  100 COUNT7 @ U< IF
  ADC7@ COUNT7 @ /  DUP
  SLADC7SUM @ 5 RSHIFT  -  SLADC7SUM +!
\    ADC7SUM @ 2 RSHIFT  -    ADC7SUM +!
 ADC7SUM !
  DATA7 0! COUNT7 0!
   THEN

 0
\   timecou @ 1 AND IF BREAK
['] NOOP DO_GPSADC @ <> IF CR ." ACD=" THEN

  ADCDEL W@ ADC5SUM @  SADC5SUM @  -
['] NOOP DO_GPSADC @ <> IF TAB DUP . THEN
  ABS  U<
  IF -1 OR THEN
  SADC5SUM @  SADC5SUM2  !
   ADC5SUM @  SADC5SUM  !

  ADCDEL W@ ADC6SUM @  SADC6SUM @  -
['] NOOP DO_GPSADC @ <> IF TAB DUP . THEN
  ABS  U<
  IF -1 OR THEN
  SADC6SUM @   SADC6SUM2 !
   ADC6SUM @   SADC6SUM  !


  ADCDEL W@ ADC7SUM @  SADC7SUM @  -
['] NOOP DO_GPSADC @ <> IF TAB DUP . THEN
  ABS  U<
  IF -1 OR THEN
  SADC7SUM @   SADC7SUM2 !
   ADC7SUM @   SADC7SUM  !

\	&AUTOJUMP @	DO_ADC @ = IF ." REST" THEN
\	&SEND_ADC @	DO_ADC @ = IF ." JMP" THEN
;


VARIABLE stimecou

VARIABLE SEND_ADC_COUNT

: ?COUNT.
['] NOOP DO_GPSADC @ <> IF
 CR ." COUNT="  DATA5 @ . COUNT5 @ . DATA6 @ . COUNT6 @ .  DATA7 @ . COUNT7 @ .
 THEN
;

: ?~_ADC
 
  DOADC5 DOADC6 DOADC7
\ CR ." ?~_ADC" DATA5 @ . DATA6 @ . DATA7 @ .
  TRUE
  timecou @ stimecou @ = IF EXIT THEN
  1 SEND_ADC_COUNT +!
                timecou @ stimecou !
	
  ?SLEEP @  IF EXIT THEN
  ?COUNT.
  ?ACSEL 0= IF EXIT THEN
 DROP FALSE
;

: ACSELDROP
 ?~_ADC DROP ;

: SEND_HPACC
    number[]
	DUP W@ 0xFFFF <>
 IF DUP {SEND S" High-pass accel" GPRMC} THEN DROP
    number[] \number +
	DUP W@ 0xFFFF <>
 IF DUP {SEND S" High-pass accel" GPRMC} THEN DROP
;

: ?SEND_ADC
  ?~_ADC  IF BREAK

   DO_ADC @ >R
   ['] ACSELDROP DO_ADC !

	DO_GPSADC	PERFORM
  
	CR ." AAAAAAAAAAAAAAAAAAAAA="
 ADC5SUM @ U.  SADC5SUM2 @ U.
 ADC6SUM @ U.  SADC6SUM2 @ U.
 ADC7SUM @ U.  SADC7SUM2 @ U.

  ?PPP @ 1+ 1 OR 1 =  \ PPP   -
 SMS_PERMIT @ AND
 IF	?PPP @ -1 =
	IF  9 &TRKSEND PERFORM
\	    NGPRSSMS W@ 0=
\		IF  SEND_HPACC
\		THEN
	ELSE	SEND_HPACC
	THEN
 THEN
   R> DO_ADC !

	        RADCDEL W@ 0xFFFF <>
		IF	&AUTOJUMP	@	DO_ADC !
			&SLAUTOJUMP	@	DO_SLADC !
		   aseconds @ AUTOREST_TIME !

		THEN
  ?ACCPARK @
		IF ['] ACSELDROP DUP	DO_ADC !	DO_SLADC !
			-1 -1  ADCDEL W!  SLADCDEL W!
			FLCLR  FL_SAVE
		THEN

                timecou @ stimecou !
;

VARIABLE SSLADC5SUM
VARIABLE SSLADC5SUM2
VARIABLE GPSSSLADC5SUM
VARIABLE GPSSSLADC5SUM2

VARIABLE SSLADC6SUM
VARIABLE SSLADC6SUM2
VARIABLE GPSSSLADC6SUM
VARIABLE GPSSSLADC6SUM2


VARIABLE SSLADC7SUM
VARIABLE SSLADC7SUM2
VARIABLE GPSSSLADC7SUM
VARIABLE GPSSSLADC7SUM2


: ?SACSEL
 CR ." SLO="
 0
  SLADCDEL W@  SLADC5SUM @  SSLADC5SUM @  -
 TAB DUP .
 ABS  U<
  IF -1 OR  THEN
  SSLADC5SUM @ SSLADC5SUM2 !
  SLADC5SUM @   SSLADC5SUM  !

  SLADCDEL W@  SLADC6SUM @  SSLADC6SUM @  -
 TAB DUP .
  ABS  U<
  IF -1 OR THEN
  SSLADC6SUM @   SSLADC6SUM2  !
  SLADC6SUM @   SSLADC6SUM  !

  SLADCDEL W@  SLADC7SUM @  SSLADC7SUM @  -
 TAB DUP .
  ABS  U<
  IF -1 OR THEN
  SSLADC7SUM @   SSLADC7SUM2  !
  SLADC7SUM @   SSLADC7SUM  !

	&SLAUTOJUMP @	DO_SLADC @ = IF ." REST" THEN
	&SEND_SLADC @	DO_SLADC @ = IF ." JMP" THEN
;

VARIABLE ssltimecou
VARIABLE GPSltimecou

VARIABLE SEND_SLADC_COUNT

: ?~_SLADC ( -- flag )
  TRUE
  timecou @ ssltimecou @ = IF EXIT THEN
  1 SEND_SLADC_COUNT +!
                timecou @ ssltimecou !
  timecou @ 0x1F AND IF EXIT THEN

  ?SLEEP @  IF EXIT THEN
  ?SACSEL 0=  IF EXIT THEN
  DROP FALSE
;

: SEND_LPACC
    number[]
	DUP W@ 0xFFFF <>  
 IF DUP {SEND S" Low-pass accel" GPRMC} THEN DROP
    number[] \number +
	DUP W@ 0xFFFF <>
 IF DUP {SEND S" Low-pass accel" GPRMC} THEN DROP
;


: ?SEND_SLADC
  ?~_SLADC  IF BREAK

   DO_SLADC @ >R
   ['] ACSELDROP DO_SLADC !

	DO_GPSADC	PERFORM  
	CR ." BBBBBBBBBBBBBBBBBBBBBBB="
 SLADC5SUM @ U.  SSLADC5SUM2 @ U.
 SLADC6SUM @ U.  SSLADC6SUM2 @ U.
 SLADC7SUM @ U.  SSLADC7SUM2 @ U.

  ?PPP @ 1+ 1 OR 1 =  \ PPP   -
 SMS_PERMIT @ AND
 IF
	?PPP @ -1 =
	IF  10 &TRKSEND PERFORM
\	    NGPRSSMS W@ 0=
\		IF  SEND_LPACC
\		THEN
	ELSE	SEND_LPACC
	THEN
 THEN
   R> DO_SLADC !

	        RADCDEL W@ 0xFFFF <>
		IF	&AUTOJUMP	@ DO_ADC !
			&SLAUTOJUMP	@ DO_SLADC !
		   aseconds @ AUTOREST_TIME !
		THEN

  ?ACCPARK @
		IF ['] ACSELDROP DUP	DO_ADC !	DO_SLADC !
			-1 -1  ADCDEL W!  SLADCDEL W!
			FLCLR  FL_SAVE
		THEN
                timecou @ ssltimecou !

;

: ADCDEL><
 RADCDEL W@ RSLADCDEL W@
 RADCDEL W! RSLADCDEL W!
;



: ?2AUTOJUMP ( flg -- )
  IF 
   ADCWAIT W@ aseconds @ AUTOREST_TIME @ - U<
	IF
	        ADCDEL W@ 0xFFFF =
	        IF   ['] ACSELDROP DUP
		ELSE ['] ?SEND_ADC ['] ?SEND_SLADC
		THEN  DO_SLADC !  DO_ADC !
	BREAK

  BREAK
   aseconds @ AUTOREST_TIME !
;

: ?AUTOJUMP
ADCDEL><
  ?~_ADC
ADCDEL><
  ?2AUTOJUMP
;

: ?SLAUTOJUMP
ADCDEL><
  ?~_SLADC
ADCDEL><
 ?2AUTOJUMP
;

: ?SGPSACSEL
 0                        

  timecou @ GPSltimecou @ <>

 IF     
  timecou @ DUP GPSltimecou !
  0x1F AND 0=
  IF
 CR ." GDC="
  GPSSLADCDEL W@  SLADC5SUM @  GPSSSLADC5SUM @  -
 TAB 2DUP . .
 ABS  U<
  IF -1 OR  THEN
  GPSSSLADC5SUM @ GPSSSLADC5SUM2 !
  SLADC5SUM @   GPSSSLADC5SUM  !

  GPSSLADCDEL W@  SLADC6SUM @  GPSSSLADC6SUM @  -
 TAB 2DUP . .
  ABS  U<
  IF -1 OR THEN
  GPSSSLADC6SUM @   GPSSSLADC6SUM2  !
  SLADC6SUM @   GPSSSLADC6SUM  !

  GPSSLADCDEL W@  SLADC7SUM @  GPSSSLADC7SUM @  -
 TAB 2DUP . .
  ABS  U<
  IF -1 OR THEN
  GPSSSLADC7SUM @   GPSSSLADC7SUM2  !
  SLADC7SUM @   GPSSSLADC7SUM  !

   THEN

  GPSADCDEL W@  ADC5SUM @  GPSSADC5SUM @  -
\ TAB  2DUP . .
 ABS  U<
  IF -1 OR  THEN
  GPSSADC5SUM @ GPSSADC5SUM2 !
  ADC5SUM @   GPSSADC5SUM  !

  GPSADCDEL W@  ADC6SUM @  GPSSADC6SUM @  -
\ TAB  2DUP . .
  ABS  U<
  IF -1 OR THEN
  GPSSADC6SUM @   GPSSADC6SUM2  !
  ADC6SUM @   GPSSADC6SUM  !

  GPSADCDEL W@  ADC7SUM @  GPSSADC7SUM @  -
\ TAB  2DUP . .
  ABS  U<
  IF -1 OR THEN
  GPSSADC7SUM @   GPSSADC7SUM2  !
  ADC7SUM @   GPSSADC7SUM  !

  THEN
;

: ?GPS_ADC
 ?SGPSACSEL 0=  IF BREAK
 ['] NOOP DO_GPSADC !
	DO_ADC		PERFORM
	DO_SLADC	PERFORM
	CR ." GGGGGGGGGGGGGGGG="
 GPSSSLADC5SUM @ U.  GPSSSLADC5SUM2 @ U.
 GPSSSLADC6SUM @ U.  GPSSSLADC6SUM2 @ U.
 GPSSSLADC7SUM @ U.  GPSSSLADC7SUM2 @ U.

   GPS_INIT
  aseconds @ L_TIME_GPSACC !
;


: GPS_RESET?  ( -- )
	['] ?GPS_ADC	DO_GPSADC @ = IF BREAK
	?GPSUP W@ 0= IF BREAK


	amins @ TIME_GPS_RESET @ - 2 >
	NGPSS @ 0= OR
 	IF   GPSRESET_
		amins @ TIME_GPS_RESET !
		5 NGPSS !
	THEN ;




: MQUIT ( -- )
  aseconds @ L_TIME_GPSACC !
  ?MQUIT OFF
  1 ?STT !
  FWDT_SAVE W@ 0xFFFF <>
  IF 
    number[] \number + \number +
	DUP W@ 0xFFFF <> IF DUP {SEND GWATCHDOG} THEN DROP

   0xFFFF VWDT_SAVE W! FL_SAVE
  THEN
(       SVSCTL  SVSFG AND
  IF 
    number[] \number + \number +
	DUP W@ 0xFFFF <> IF DUP {SEND S" SVSCTL" GPRMC} THEN DROP	
	SVSFG INVERT SVSCTL CAND!
  THEN
)

	amins @ TIME_CREG !
	amins @ TIME_GPS_RESET !

CR ." MQUIT0"
  
   GINPUT? IF  BEGIN
STT_WORCH  ?STT  @ 0< IF ." Mq>stt" R@ H.  EXIT THEN
 WDT_CHOP GINPUT 0xA = UNTIL THEN
CR ." MQUIT1"

     PINPUT?  IF  BEGIN
STT_WORCH  ?STT  @ 0< IF ." Mq>stt" R@ H.  EXIT THEN
 WDT_CHOP PINPUT 0xA = UNTIL THEN
CR ." MQUIT2"

  BEGIN	
      VCONNECT @ 0=
	IF
\ ivanov
      	?PPP @ 0= IF DO_GSM PERFORM THEN
\ DO_GSM PERFORM \ 4   gsm
\ ivanov             \      ()
      ATCREG
      GPS_RESET?     \   gps ()
	THEN
	DEPTH 64 > IF S0 @ SP! THEN
      GQUIT          \   
	?MQUIT @ IF EXIT THEN
	GPS-STEP DROP
 AGAIN ;


: #?SEND_PSWICH
	DUP W@ 0xFFFF <> IF DUP
	VCAOUT @
	IF    DROP \ S" PSWICH1"
	ELSE    
		{SEND  S" ACCUM;" GPRMC}
	THEN  THEN DROP ;

: SEND_PSWICH
	CR ." PS="  2 SECS
    number[]		#?SEND_PSWICH
    number[] \number +	#?SEND_PSWICH  aseconds @ 120 +  PSMINS !
;

#define CAOUT               0x01    \ Comp. A Output

VARIABLE PSSECS

: ?SEND_PSWICH
	aseconds @ PSMINS @ U< IF EXIT THEN

  CACTL@ VCAOUT @ <>  \   
 IF aseconds @  PSSECS @ - 0< IF EXIT THEN
	CACTL@ DUP  VCAOUT !   \ 2 
	0=
  IF
	

	 ?PPP @
	IF  VCAOUT @ 0= IF  14 &TRKSEND PERFORM THEN
		NGPRSSMS W@ 0=
		IF SEND_PSWICH THEN
	ELSE	SEND_PSWICH
	THEN
  THEN

 THEN

  aseconds @ 10 +  PSSECS !

;

: USER_OUT_PUL
 DEPTH >R
 SINTERPRET
 DEPTH R> - 1 <> IF S0 @ SP! 5 THEN \ !!!!
 RAD_PUL ! USER_OUT_ON
 aseconds @ L_TIME_PULS !
 PULS_FLG FLG_ON
;


VARIABLE SLEEP_WORK
VARIABLE TIME_GSM

\ aseconds
 amins
 CONSTANT _amins

VARIABLE ZZXX


: VPRMC}
   [CHAR] $ SMSEMIT VPRMC[] COUNT
    FKVIOL W@ 0= IF  >KIL THEN
 ESC_SMS ;
: #SEND_SLEEP
	DUP W@ 0xFFFF <> IF DUP {SEND
 ALARM? @ WASALARM @ OR  
 IF	S" ALARM 10M;"
	ALARM_FLG FLG_OFF
	mins @ SMINS !
 ELSE  PWSW @
	IF   S" PWSW10M;" aseconds @ 11 +  PSSECS !
	ELSE S" ACTIVE10M;"
	THEN
 THEN SMSTYPE SMSCR VPRMC} THEN DROP ;

\ S" ACTIVE10M;"
\ S" ALARM 10M;"
: SEND_SLEEP  ( -- flg )
    number[]           #SEND_SLEEP
    number[] \number + #SEND_SLEEP
\	2 TIMEOKERR	 ?OK @
	VCMGS @
;


VARIABLE &AV
VARIABLE &GREGOK

CODE DIP_DELAY
	STMDB	SP!,{LR}
	MOV	TR0, TOS 
	BL	' TmpUltraLowPowerMode
	ldr	TOS, [DSTK], #4  \ DROP
	LDMIA	SP!,{LR}
	NEXT
ASM_END

: SLEEP_IN
  GSM_SLEEP
  GPS_SLEEP
  AT91C_PIO_PA0 PACLEAR
;

: SLEEPP

\	TIME_SLEEP W@ _amins @ +
\	BEGIN	GPS-STEP DROP WDT_CHOP
\		DUP _amins @ 
\		DUP ZZXX @ XOR IF DUP ZZXX ! CR ." SL=" 2DUP . .
\		THEN    - 0<
\	UNTIL 	 DROP


(
	ALARM? OFF
	TIME_SLEEP W@ _amins @ +
	BEGIN	GPS-STEP DROP WDT_CHOP
		DUP _amins @ 
		DUP ZZXX @ XOR IF DUP ZZXX ! CR ." SL=" 2DUP . .
		THEN    -   0<
		GETALARM
		DUP
		IF ." SALARM"  ALARM? ON
		THEN OR
	UNTIL 	
	DROP
*)
\        UNHWINIT
\	POWER_ACC_OFF
	TIME_SLEEP W@ 1440 * DIP_DELAY
\	POWER_ACC_ON
	AT91C_PIO_PA27  PACLEAR

        GPS_INIT
	 AT91C_PIO_PA0 PASET
	2 SECS

	&AV 0!   

	register

CR ." reg=OK"

\	1 _amins @ +
\	BEGIN DUP _amins @  WDT_CHOP
\ DUP ZZXX @ XOR IF DUP ZZXX ! CR ." Sl=" 2DUP . . THEN
\  - 0<	UNTIL DROP

        \ GSM_INIT
        hours @ TIME_GSM !

        S" AT" GTYPE GCR          \  
	SP@ >R
        5 TIMEOKERR
	R> SP!
        ALARM? @ WASALARM @ OR
	IF
 number[]		{SEND S" Sleep Alarm" GPRMC}
 number[] \number +
	DUP W@ 0xFFFF <> IF DUP {SEND S" Sleep Alarm" GPRMC} THEN DROP
        THEN

	S" AT+CREG?" GTYPE GCR
         amins @ TIME_CREG ! &GREGOK OFF
	?MQUIT OFF 1 ?STT !

	5 amins @ + >R
	BEGIN 
         ATCREGS
         GQUIT
 WDT_CHOP \ ????
	?MQUIT @ IF CR ." ?MQUIT" RDROP EXIT THEN
         amins @ ZZXX @ XOR IF amins @ ZZXX ! CR ." sL=" amins @ . R@ . THEN

	
	&GREGOK @
	&AV C@ [CHAR] A = AND
	R@ amins @  - 0<  OR
	UNTIL   RDROP

CR ." number[]"

      SEND_SLEEP IF EXIT THEN
      SEND_SLEEP IF EXIT THEN
      SEND_SLEEP IF EXIT THEN
      SEND_SLEEP DROP
CR ." SSSSSSSS"
;


: SLEEP_IN
  GSM_SLEEP
  GPS_SLEEP
;

: ?SLEEP_WORK
  _amins @ SLEEP_WORK @
 OVER ZZXX @ XOR
 IF OVER ZZXX ! CR ." SW=" 2DUP . . THEN
 U<
;

: SLEEPPP
 ?SLEEP ON
 ?MQUIT OFF
  1 ?STT !
\    !!!!!!!!!
\  GPS_SW_OFF
	
 BEGIN SLEEPP
   ZZXX OFF
  10 _amins @ +  SLEEP_WORK !
	  BEGIN  GQUIT
		 ?MQUIT @ IF EXIT THEN
		 ?SLEEP_WORK 0=
	  UNTIL
	?SLEEP @ \ ?STT  @ 0> AND
 WHILE	SLEEP_IN
 REPEAT
;

: CSQ \ SIGNAL QUALITY REPORT
 S" AT+CSQ" \ CR 2DUP TYPE CR
 GTYPE
 GCR
 ; 

: PPP
	BEGIN C_PAUSE 
	      0	INPUT? IF INPUT  #START = OR THEN
	UNTIL
;

ICREATE READYBUF 'R' C, 'E' C, 'A' C, 'D' C, 'Y' C,
HERE CONSTANT READYBUFEND
VARIABLE READYBUFCT

:  CALLREADY?
  GINPUT?_
 IF GC_INPUT DUP EMIT 0x20 INVERT AND
   READYBUFCT @ C@   =
   IF READYBUFCT 1+!
   ELSE   READYBUF READYBUFCT !
   THEN  READYBUFEND READYBUFCT @ - .
 THEN
   READYBUFEND READYBUFCT @ =
;

 0x20 CONSTANT CALLREADYLOOPS

: CALLREADYWAITING
 CR ." CR ST" CR
  READYBUF READYBUFCT !
  CALLREADYLOOPS
 BEGIN DUP 0= IF
 CR ." CR LP" CR
  GSM_SW DROP CALLREADYLOOPS THEN
      1-  CALLREADY?
 UNTIL DROP
 
 CR ." CR END" CR
\ VCTSRESET 

;

ICREATE INETINITBUFF
-1 I, -1 I, -1 I, -1 I,    -1 I, -1 I, -1 I, -1 I,
-1 I, -1 I, -1 I, -1 I,    -1 I, -1 I, -1 I, -1 I,

-1 I, -1 I, -1 I, -1 I,    -1 I, -1 I, -1 I, -1 I,
-1 I, -1 I, -1 I, -1 I,    -1 I, -1 I, -1 I, -1 I,

ICREATE INETNUMBUFF
-1 I, -1 I, -1 I, -1 I,    -1 I, -1 I, -1 I, -1 I,
-1 I, -1 I, -1 I, -1 I,    -1 I, -1 I, -1 I, -1 I,

: GCLIENT
	1 SECS -GSM
	s" ATD" _GTYPE
        INETNUMBUFF @ -1 =
	IF S" *99#"
	ELSE INETNUMBUFF COUNT
	THEN _GTYPE -GCR
;

ICREATE CONNECTBUF 'C' C, 'O' C, 'N' C, 'N' C, 'E' C, 'C' C, 'T' C, 0xD C, 0xA C, 
HERE CONSTANT CONNECTBUFEND
VARIABLE CONNECTBUFCT

:  CONNECT?
  6 GTICS
  GINPUT?_
 IF GC_INPUT DUP EMIT 0x20 INVERT AND
   CONNECTBUFCT @ C@   =
   IF CONNECTBUFCT 1+!
   ELSE   CONNECTBUF CONNECTBUFCT !
   THEN  CONNECTBUFEND CONNECTBUFCT @ - .
 THEN
   CONNECTBUFEND CONNECTBUFCT @ =
;

 0x20 CONSTANT CONNECTLOOPS

: DO_GSMRESET
 GSM_SLEEP
\ EXTPGSM_OFF
\ EXTPGPS_OFF
1 SECS
\ 0 EXECUTE 
 REGISTER
;

VARIABLE CON_TRY

: CONNECTWAITING
 4 CON_TRY !
 A_BEGIN
  CON_TRY @ 0= IF BREAK
 BEGIN  INETINITBUFF @ -1 =
	IF S' AT+CGDCONT=1,"IP","internet.mts.ru","0.0.0.0",0,0'
	ELSE INETINITBUFF COUNT
	THEN _GTYPE -GCR
	2  TIMEOKERR ?OK @ 0=
 WHILE
             1 SECS S" AT" _GTYPE -GCR
	     2  TIMEOKERR
		?STT @ 0< IF EXIT THEN
	     ?OK @ 0=
	IF REGISTER 
	ELSE DO_DISCONNECT
	THEN
 REPEAT
 2 	                                    	
 CR ." CT ST" CR    GCLIENT
  CONNECTBUF CONNECTBUFCT !
  CONNECTLOOPS aseconds @ +

 BEGIN DUP aseconds @ - 0<      \  at     connect  carrier  20 
                                \  connect at   
                                \  ok  at  Gclient    connect
	IF	CR ." CT LP" CR
		?GSM_SLEEP @ DUP
		IF	GSM_SLEEP
		THEN
		0= ?GSM_SLEEP !
		REGISTER	
		A_AGAIN
(
		S" AT" _GTYPE -GCR
		2  TIMEOKERR
		?STT @ 0< IF EXIT THEN
 ?OK @ 0=
		IF
		THEN		
		GCLIENT
		DROP CONNECTLOOPS aseconds @ + )
	THEN
      CONNECT?
 UNTIL DROP
\ 2 SECS
 CR ." CT END" CR

;
: TASK_INIT
	C_STATUS FOLLOWER !
	TSKPOOL TSKDP !
	WAKE C_STATUS !
	MULTI          
;

: PPPLINK
\  CALL_READY? @ 0= IF CALLREADYWAITING THEN
 BEGIN
   BEGIN  TASK_INIT
	2 SECS
      CONNECTWAITING
	  CON_TRY @ 0= IF BREAK
		?STT @ 0< IF BREAK
	['] ComClr1Tx C_EXEC
	['] PPPMAIN C_EXEC
    NoCarFlg @ DUP IF CR ." NoCarFlg=1" THEN
    0=
  UNTIL
    S" AT" GTYPE GCR
	?AT OFF 
    2 TIMEOKERR
     ?OK @ 0=
 UNTIL
;

VARIABLE UDP_TOUT
VARIABLE UDP_TIME
0 [IF]

: PGTYPE ( addr -- )
 X@
 OVER 2 GTYPE  [CHAR] . GEMIT
 OVER 2 + 2 GTYPE
 SWAP 5 + SWAP 5 - GTYPE ;

: TGTYPE ( addr -- )
 X@
 OVER 3 GTYPE  [CHAR] . GEMIT
 OVER 3 + 2 GTYPE
 SWAP 6 + SWAP 6 - GTYPE ;
[THEN]


: ?GSM_RESET
	3 hours @ TIME_GSM @ - U<
\	3 amins @ TIME_GSM @ - U<
 	IF  CR ." >register=" hours @ TIME_GSM @ H. H.
		hours @ TIME_GSM !
\ ivanov
		amins @ TIME_CREG ! \  ஢ CREG

		DEREGPAUSE
CR ." Register>="
	THEN ;

: {SENDROT}
  DUP W@ 0xFFFF <> IF DUP {SEND  ." ROTATE" S" ROTATE;" GPRMC} THEN DROP ;

VARIABLE TRACKDELAY

0 [IF]
: FDELAY ( n -- )

 BEGIN
 100
 BEGIN  WDT_CHOP   
 1- DUP 0= UNTIL DROP
 1- DUP 0= UNTIL DROP ;
[THEN]


: GPSDOWN_WAKE
	GPSDOWN_TIME @ amins @  - 0<
  IF    GPS_SLEEP ['] NOOP DO_GPSDOWN !
	S" +7" TNUM $! Number[] \number TNUM $+!
	SEND-SMS S" GPS TIME OUT"  ESC_SMS

  THEN
;

\ TEST

: AAJJTST
 S" ZEROTSTOFF" EVALUATE
\ S"  NUMBER1 +79118423194" EVALUATE
 S"  NUMBER1 +79118249589" EVALUATE
 S" AUTOJUMP 210 66" EVALUATE
;

CREATE PPPBUFF 0x30 ALLOT

: PPPEMIT  
  PPPBUFF $C+!
;

: PPPWEMIT ( w -- )
            DUP  PPPEMIT
   8 RSHIFT      PPPEMIT ;

: PPPSEMIT ( n -- )
            DUP  PPPEMIT
   8 RSHIFT DUP  PPPEMIT
   8 RSHIFT     PPPWEMIT ;

layer_BUFF 0x10 + CONSTANT  ROT_BUFF

: ROT2PPP ( -- )
\ CR ." VV=" 
  PPPBUFF 0!
 0 \ !!!!!
 0xBB PPPEMIT
DUP \ KS
  PPPWEMIT DUP 8 RSHIFT +
  ROT_BUFF  8 + W@ DUP PPPWEMIT  2KS+           \ GTIME 2@ DROP 4 S>NUM

  ROT_BUFF 12 + C@ DUP PPPEMIT  +        \   TIP
  ROT_BUFF      X@ XDUP PPPSEMIT 4KS+    \ latitude
  ROT_BUFF 4 +  X@ XDUP PPPSEMIT 4KS+    \ longtitude
  ROT_BUFF 10 + C@ DUP PPPEMIT +        \ 
  ROT_BUFF 11 + C@ DUP PPPEMIT +        \ 
  PPPEMIT
  IMEIADDN? W@ 0=
  IF   0xCC PPPEMIT   &IMEI 2@ PPPSEMIT PPPSEMIT
  THEN 
;

CODE INETADDR
	STR	LR,[SP,#-4]!
	MOV	R0,TOS
	BL	' inet_addr
	MOV	TOS,R0
	LDR	PC,[SP],#4
ASM_END

ICREATE INET_LOGIN
-1 I, -1 I, 

ICREATE  INET_PASS 
-1 I, -1 I,


CODE  INETLOGPASS
	STR	LR,[SP,#-4]!
	MOV	R0,TOS
	dpop	R1
	BL	' InetLoginSet
	dpop	TOS
	LDR	PC,[SP],#4
ASM_END

: $DATACOMP
 [ NOWADAYS ] SLITERAL  ;

: Ready900
   CALL_READY? @ 0=
   IF
       -1  CALL_READY? !
	27 GEMIT GCR 
	SMS_PERMIT ON
	['] GPS-EMIT  &GPS-STEP @ <>
	IF  zregister
	THEN
   THEN
;


: GPSBAUDSET ( speed -- ) 
 DUP 600 / GPSBAUD W! FLCLR FL_SAVE 
 GPS_BAUD_RATE !
 Usart_init
;


\EOF




: BUN2BAS S"  9117039546"    ;

0041000B919712592493F0000809060504141F141F0041