( interactive debugger for )
( Mihail Maksimov 2006     )

VARIABLE &RANGE
VARIABLE &SPSR
VARIABLE &CPSR
VARIABLE &TCD
VARIABLE &RANGE_
VARIABLE &BREAK_C
VARIABLE &BREAK_P
VARIABLE CMASKA
VARIABLE RMASKA

CREATE &SPRP 2 CELLS ALLOT
CREATE &R0 17 CELLS ALLOT
: &TOS &R0  2 CELLS + ;
: &UR  &R0 10 CELLS + ;
: &DSP &R0 12 CELLS + ;
: &SP  &R0 13 CELLS + ;
: &LR  &R0 14 CELLS + ;
: &PC  &R0 15 CELLS + ;
VARIABLE &PC_S

VARIABLE INST_DOES

: DEB_SYS
  0  INST_DOES !
  BEGIN MAIN_STEP PERFORM
	INST_DOES @
  UNTIL
;

: TASOVKA ( 16 -- 0 )
  DUP
  IF  1- &R0 OVER 2DUP CELLS + >R  RMASKA @ XOR CELLS + @ >R  
     RECURSE
 R> R> ! THEN ;

: RANGE &RANGE @ ;

: GO
  &PC @ RANGE - 2 RSHIFT 2- 0x00FFFFFF AND 0xEA000000 OR RANGE !
  RMASKA 0!
;

: NST
  &PC @
  DUP @      \  CFA  N'
  &PC @ @ CMASKA @ XOR RANGE !
  8 &PC +!  &PC @ &PC_S !
;

: STEP  ( -- )
 &PC @ @ 0xFF000000 AND 0xEB000000 =
 IF   &PC @ @ 0x00FFFFFF AND \ ." S=" DUP H.
 0x00800000 XOR 0x00800000 - 2 LSHIFT \ DUP H.
      &PC @ + \ DUP H.
 RANGE -
	 2 RSHIFT 0x00FFFFFF AND 0xEB000000 OR RANGE !
  8 &PC +!  &PC @ &PC_S !
 ELSE NST
 THEN
;

: .FLAG ( N -- N )
 OVER AND IF ." 1 " ELSE ." 0 " THEN ;

: H.0 #H.0 OUTPUT DOUTPUT DOUTPUT ;

: 8H. 8 H.0 ."  " ;

: .REG ( ADDR -- ADDR1 )
   DUP @ 8H. CELL+ ;

: .RST
   &UR @ UP!
 CR ." R= "
    &SP @ 
    BEGIN DUP _R0 @ U<
    WHILE DUP @ H. CELL+
    REPEAT DROP ;

: .SST
   &UR @ UP!
 CR ." S=( "
	S0 @    
    BEGIN DUP &DSP @ U>
    WHILE  CELL- DUP @ H.
    REPEAT DROP
 	S0 @ CELL+ &DSP @ <> IF &TOS @ H. THEN ." )"
;

: INST   ( addr -- addr+cell )
 #INST OUTPUT
 DUP DOUTPUT
 DEB_SYS
 CELL+ CR
;

: MASKA-SET  ( -- )
 #MASKA OUTPUT
  DEB_SYS
;

: _TrDO
 CR ." ----" CR
 &PC @ DUP &PC_S @ =
 IF CELL- DUP &PC ! THEN 
      INST  MASKA-SET
  &PC @ @ CMASKA @ XOR RANGE !
      INST
      INST DROP
 &R0
." R0 =" .REG ."  R1 =" .REG ."  R2 =" .REG ."  R3 =" .REG CR
." R4 =" .REG ."  R5 =" .REG ."  R6 =" .REG ."  R7 =" .REG CR
." R8 =" .REG ."  R9 =" .REG ."  R10=" .REG ."  R11=" .REG CR
." R12=" .REG ."  SP =" .REG ."  LR =" .REG ."  PC =" .REG CR
." CPSR=" &CPSR @ H. ." SPSR=" &SPSR @ H.
.SST
\ ." CM=" CMASKA @ H. ." RM=" RMASKA @ H.
 CR
       DROP  CR 
  BEGIN  KEY 0x20 OR
     CASE
     [CHAR] g OF GO TRUE  ENDOF
     [CHAR] n OF NST   TRUE  ENDOF
     [CHAR] s OF STEP  TRUE  ENDOF
\     [CHAR] a OF ABORT       ENDOF
     [CHAR] r OF .RST FALSE  ENDOF
\     [CHAR] f OF eval_debug_statements TRUE  ENDOF
     ." Nest Step Go Abort Rstc" CR TRUE SWAP
	0 RANGE !
     ENDCASE
 UNTIL
  RANGE INST DROP
 CR
\  &PC @ 
\  DUP
\  DROP TRUE
;


: TrDO
 16 TASOVKA DROP
\ BEGIN
     _TrDO
\ UNTIL
 16 TASOVKA DROP
; 

: TBL_DO
\ CR ." TBL="
  &PC @ CELL- \ DUP H.
  &LR ! ;

: &TCOD
  &PC @ CELL- CELL-
;

: TB_DO
 CR ." TB=" 
  &TCOD  DUP @ 0x00FFFFFF AND 0x00800000 XOR 0x00800000 - 2+ CELLS
    2DUP H. H. 
+
 DUP H.

  &PC !  -1 &PC_S !

\ CR  ." LRB=" &LR @ DUP H. @ H.

;

: =:R{}
&R0 &TCD @ 0x000F0000 AND 16 RSHIFT CELLS + ! ;

: TSTM_DO
 CR  ." LR=" &LR @ DUP H. @ H.
 CR ." TSTM="
  &R0
 &TCOD @ DUP &TCD ! 0x000F0000 AND 16 RSHIFT CELLS +  DUP H. @ DUP H.
 &TCD @ 0x01B00000 2DUP H. H. AND DUP H.
 CR  ." LR=" &LR @ DUP H. @ H.
 CASE 
 0x01200000 OF \ STMDB	R13!,{R4,R5,R14}
	 0 15
	 DO  &TCD @ 1 I LSHIFT AND
		IF CELL-   &R0 I CELLS + @ OVER ! 
		THEN -1
	 +LOOP =:R{}
	
	CR ENDOF

 0x00B00000 OF \ LDMIA	R13!,{R4,R14}
	16 0
CR ." LDM="
	 DO  CR &TCD @ 1 I LSHIFT 2DUP H. H. AND
		IF DUP @  &R0 I CELLS +  2DUP H. H. ! CELL+ 
		THEN   ." LR=" &LR @ DUP H. @ H.
	 LOOP =:R{}
	ENDOF

   &TCOD @ RANGE ! &RANGE_ PERFORM
 ENDCASE
;

CODE $$$$$$$$$$$$$$$

CODL TSTM
	ldr LR, = &R0
	STMIA	LR,{R0-R13}
	ldr LR, = &SPRP
	LDMIA	LR,{DSTK,RSTK}

	BL	' TSTM_DO
	B	LL0

\	ldr LR, = &SPRP
\	STMIA	LR,{DSTK,RSTK}
	ldr LR, = &R0
        LDMIA   LR,{R0-R13}

CODL TBL
	ldr	LR, = &R0
	STMIA	LR,{R0-R13}
	ldr LR, = &SPRP
	LDMIA	LR,{DSTK,RSTK}

	BL	' TBL_DO

	B	LL2
CODL TB
	ldr	LR, = &R0
	STMIA	LR,{R0-R13}
	ldr LR, = &SPRP
	LDMIA	LR,{DSTK,RSTK}

LL2:	BL	' TB_DO

	B	LL0

CODL TRACE
	STMDB	SP!,{R0}
	ldr R0, = &R0 15 CELLS +
	STR	LR,[R0]	
        LDMIA   SP!,{R0}
	ldr LR, = &R0
    	STMIA	LR,{R0-R13}
	ldr LR, = &SPRP
	LDMIA	LR,{DSTK,RSTK}
  BEGIN,
	ldr R0, = &SPSR
	mrs     r1,spsr
	STR	R1,[R0]

	ldr R0, = &CPSR
	mrs     r1,cpsr
	STR	R1,[R0]

LL0:	BL  '  TrDO

	ldr R0, = &CPSR
	ldr	R1,[R0]
        msr     cpsr,r1

	ldr R0, = &SPSR
	ldr	R1,[R0]
	msr     spsr,r1
	ldr LR, = &SPRP
	STMIA	LR,{DSTK,RSTK}
CODL  RANGE_
	ldr LR, = &R0
        LDMIA   LR,{R0-R14}
CODL _RANGE
	B	LL1
LL1:	ldr LR, = &R0
	STMIA	LR,{R0-R13}
	ldr LR, = &SPRP
	LDMIA	LR,{DSTK,RSTK}
 AGAIN,
ASM_END


\ ' _RANGE &RANGE !

: DO_BREAK_P
  &BREAK_C @
  &BREAK_P @ DUP &PC ! !
;

CODE #BREAK_P
	SUB	RSTK,RSTK,#100
	RPUSH	LR
	ldr LR, = &R0
	STMIA	LR,{R0-R13}
	RPOP	LR
	ADD	RSTK,RSTK,#100
	ldr R0, = &SPSR
	mrs     r1,spsr
	STR	R1,[R0]
	ldr R0, = &CPSR
	mrs     r1,cpsr
	STR	R1,[R0]
	ldr	R0, =  &R0 14 CELLS + \ &LR
	STR	LR,[R0]
	BL	' DO_BREAK_P
	B	' RANGE_
ASM_END

CODE #DBG
	ldr	R0, =  &R0 14 CELLS + \ &LR
	STR	LR,[R0]
	MOV	LR, TOS
	DPOP	TOS
	B	' TRACE
ASM_END

\EOF TEST


 ' _RANGE &RANGE !
 ' RANGE_ &RANGE_ !

INST_DOES TO VINST_DOES
CMASKA TO VCMASKA
RMASKA TO VRMASKA
 &BREAK_C TO VBREAK_C
 &BREAK_P TO VBREAK_P
 &BREAK_P 0!

' TBL	RANGE - 2 RSHIFT 2- 0x00FFFFFF AND 0x01000000 OR TO VTBL
' TB	RANGE - 2 RSHIFT 2- 0x00FFFFFF AND TO VTB
' TSTM	RANGE - 2 RSHIFT 2- 0x00FFFFFF AND 0x0A000000 OR TO VTSTM

CMASKA 0!
RMASKA 0!

0x400 ALLOT DHERE &SPRP !
0x400 ALLOT DHERE &SPRP CELL+ !


CODE MMMM 
	ORR	R15,R15,R15
	ORR	R6,R15,R15
	MOV	R6,#9
	ldr	r6, = U0BASE	
	NEXT
ASM_END

: VVVV TRACE 5 AHEAD DUP THEN MMMM 3 ;
: IIII VVVV MMMM 7 8 9 ;
CODE ZZZZ
	STMDB	R13!,{R4,R5,R14}
	MOV	R4,#6
	MOV	R5,#7
	LDMIA	R13!,{R4,R5,R15}
ASM_END

: XXXX TRACE 4 5 + ZZZZ 7 8 9  ;



