REQUIRE [DEFINED] lib\include\tools.f
REQUIRE PLACE  ~mak\place.f 
\ REQUIRE [IF] ~MAK\CompIF.f
C" H." FIND NIP 0=
[IF] : H.  BASE @ HEX SWAP U. BASE !  ;
[THEN]

C" BOUNDS" FIND NIP 0=
[IF] : BOUNDS OVER + SWAP ;
[THEN]

[UNDEFINED] W>S
[IF]
: W>S ( w -- n )  \   16    32 
  0xFFFF AND    \     
 [ 0x7FFF INVERT ] LITERAL XOR 0x8000 + ;
[THEN]

[UNDEFINED] BLANK
[IF]
: BLANK         ( addr len -- )     \ fill addr for len with spaces (blanks)
                BL FILL ;
[THEN]

[UNDEFINED] (D.)
[IF]
: (D.)          ( d -- addr len )       TUCK DABS  <# #S ROT SIGN #> ;
[THEN]

[UNDEFINED] H.R
[IF]
: H.R    ( n1 n2 -- )    \ display n1 as a hex number right
                        \ justified in a field of n2 characters
          BASE @ >R HEX >R
          0 <# #S #> R> OVER - 0 MAX SPACES TYPE
          R> BASE ! ;
[THEN]

C" TAB" FIND NIP 0=
[IF]  : TAB 9 EMIT ;
[THEN]

C" H.N" FIND NIP 0=
[IF]
: H.N           ( n1 n2 -- )    \ display n1 as a HEX number of n2 digits
                BASE @ >R HEX >R
                0 <# R> 0 ?DO # LOOP #> TYPE
                R> BASE ! ;
[THEN]

0 VALUE 1RR
0 VALUE 2RR
0 VALUE 3RR
0 VALUE DMASKA
0 VALUE VTSTM
0 VALUE VTBL
0 VALUE VTB

: 0MASKA> ( -- MASKA1 MASKA2 )
\ CR ." Z=" 1RR H. 2RR H. 3RR H.
 0
 BEGIN
\ CR ." M="
	DUP  1RR XOR 14 = 
  	OVER 1RR XOR 15 = OR

  	OVER 2RR XOR 14 = OR
  	OVER 2RR XOR 15 = OR

  	OVER 3RR XOR 14 = OR
  	OVER 3RR XOR 15 = OR
 WHILE 1+
 REPEAT DUP  DMASKA * 
;

: BMASKA> ( -- MASKA1 MASKA2 )
  
 0  DMASKA
;

: XMASKA> ( -- MASKA1 MASKA2 )
  15 DUP TO 2RR TO 3RR
  0MASKA> \ F7_ED
 DROP DUP
 0x00001001 * 
 DMASKA XOR
;

VECT MASKA>

0 VALUE ADDR_OFF

MODULE: DISINF_MOD
: XX.  CR ." X=" 2DUP H. H. ;


: ?.NAME>S      ( CFA -- )
\ ELIMINATE " 0x"
	DUP ADDR_OFF + H.  \ 1 H.R>S SSPACE
	NEAR_NFA 
	>R DUP
	IF ."  ( " DUP COUNT TYPE 
	     NAME> R> - DUP
	     IF   DUP ." +" NEGATE H. \ >S
	     THEN DROP        ."  ) "
	ELSE RDROP DROP
	THEN ;


0 VALUE OP_NAME
0 VALUE OPCODE
VECT OP.

:  [|;] (  cod  cod1 cod2  <NAME>  -- )
   TO OP_NAME
   OPCODE = 
   IF OP. RDROP RDROP
   THEN ;

: |;
     LAST @  LIT,
     POSTPONE [|;]
     POSTPONE  ;
; IMMEDIATE

: COND._
 DUP 0xF0000000  AND
 DUP 0xE0000000 = IF DROP BREAK
\ 27 >> C" EQNECSCCHSLOMIPLVSVCHILSGELTGTLE  ??"  1+ + 2 TYPE
 27 >> C" EQNEHSLOMIPLVSVCHILSGELTGTLE  ??"  1+ + 2 TYPE
;

: COND.
  COND._
 TAB ;

: CONDS.
  COND._ DUP 0x00100000  AND IF ." S" THEN
 TAB ;

: .-  S>D (D.) TYPE ;
: H.-   BASE @ HEX SWAP U>D (D.) TYPE BASE ! ;

: BX_TP  ( [INST] INST -- [INST] )
	TAB ." BX" COND.
	." R"	DUP 0x0000000F AND .-
 [']  XMASKA> TO MASKA>
  0xFFFFFFF0 AND
  0xE1A0F000 \ MOV R15,R0
   XOR TO DMASKA
 ;

0 VALUE VTBX

: B_TP  ( [INST] INST -- [INST] )
	TAB ." B"  VTB TO VTBX
	DUP 0x01000000 AND IF ." L" VTBL TO VTBX THEN COND.
	    0x00FFFFFF AND \ ." B=" DUP H.
 DUP VTBX XOR \ DUP CR ." DM=" H.
 TO DMASKA
 0x00800000 XOR 0x00800000 - CELLS \ DUP H.
 OVER \ DUP H.
 +
[']   BMASKA> TO MASKA>

 ." 0x" 8 + ?.NAME>S \ H.
;

: LDR_TP  ( [INST] INST -- [INST] )
	TAB	DUP 0x00100000 AND IF ." LDR" ELSE ." STR" THEN
		DUP 0x00400000 AND IF ." B" THEN COND.
	." R"	DUP 0x0000F000 AND 12 >> DUP TO 1RR .- 
	." ,[R"	DUP 0x000F0000 AND 16 >> DUP TO 2RR .- 
	0x00011000 TO DMASKA
	DUP 0x01000000 AND 0= IF ." ]" THEN
	." ,#"  DUP 0x00800000 AND 0= IF ." -" THEN
		DUP 0x000000FF AND       .- 
	DUP 0x01000000 AND IF ." ]" THEN
		DUP 0x00200000 AND IF ." !" THEN
	DROP ;

: LDRH_TP  ( [INST] INST -- [INST] )
	TAB	DUP 0x00100000 AND IF ." LDR" ELSE ." STR" THEN
	COND._	DUP 0x00000040 AND IF ." S" THEN ." H" TAB
	." R"	DUP 0x0000F000 AND 12 >> DUP TO 1RR .- 
	." ,[R"	DUP 0x000F0000 AND 16 >> DUP TO 2RR .- 
	0x00011000 TO DMASKA
	DUP 0x01000000 AND 0= IF ." ]" THEN
	." ,#"  DUP 0x00800000 AND 0= IF ." -" THEN
		DUP 0x0000000F AND
		OVER 0x00000F00 AND 8 >> OR .- 
	DUP 0x01000000 AND IF ." ]" THEN
		DUP 0x00200000 AND IF ." !" THEN
	DROP ;



: #_TP ( COD -- COD )
	DUP	0x02000000 AND    
 IF ." ,#0x"	DUP	0x000000FF AND
		OVER	0x00000F00 AND	8 >> 0
			?DO DUP 2 >> SWAP 30 << +
			LOOP	H.- 
 ELSE ." ,R"	DUP	0x0000000F AND DUP TO 3RR .- 
	DMASKA 	0x00000001 OR TO DMASKA
	DUP	0x00000F80 AND
	IF	." ," DUP 0x00000060 AND 5 >> 3 * C" LSLLSRASRROR" 1+ + 3 TYPE
		DUP 0x00000010 AND
 		IF	."  R" DUP 0x00000F00 AND 8 DUP TO 3RR 
		DMASKA 	0x00000100 OR TO DMASKA
 		ELSE	."  #" DUP 0x00000F80 AND 7
		THEN	 >> H.-
	THEN
 THEN  ;        

: OP_TYPE 
	TAB OP_NAME COUNT 1- TYPE ;

: MUL_TP
	OP_TYPE CONDS.
	." R"	DUP 0x00000F00 AND 8 >>	DUP TO 1RR .- 
	." ,R"	DUP 0x0000000F AND	DUP TO 2RR .- 
	." ,R"	DUP 0x000F0000 AND 16 >>  .-
		0x00010101 TO DMASKA
	DROP
; 
                
: ALU           
	OP_TYPE CONDS.
	." R"	DUP 0x0000F000 AND 12 >> DUP TO 1RR .- 
	." ,R"	DUP 0x000F0000 AND 16 >> DUP TO 2RR .- 
		0x00011000 TO DMASKA
	#_TP
	DROP ;

: ALU2
	OP_TYPE CONDS.
	." R"	DUP 0x0000F000 AND 12 >> DUP TO 1RR .- 
		0x00001000 TO DMASKA
	#_TP
	DROP ;

: SWP_TP
	OP_TYPE COND.
	." R"	DUP 0x0000000F AND  DUP TO 1RR  .- 
	." ,R"	DUP 0x0000F000 AND  12 >> DUP TO 2RR .-
	." ,[R"  DUP 0x000F0000 AND 16 >> DUP TO 3RR .- ." ]"
		0x00011001 TO DMASKA
	DROP ;

: ALU3
	OP_TYPE COND.
	." R"	DUP 0x000F0000 AND 16 >> DUP TO 1RR  .- 
		0x00010000 TO DMASKA
	 #_TP
	DROP ;

VECT ."_R"

: .",R" ." ,R" ;
: ."R" ." R" ['] .",R" TO ."_R" ;

: STM_TP
	OP_TYPE
	DUP 0x0FFFFFFF AND \ ." B=" DUP H.
	VTSTM XOR \ DUP CR ." DM=" H.
	TO DMASKA

	DUP 0x01800000 AND 22 >> C" DAIADBIB"  1+ + 2 TYPE
	COND.	." R"	DUP 0x000F0000 AND 16 >>
 DUP TO 1RR
 DUP TO 2RR
 DUP TO 3RR  .- 
		DUP 0x00200000 AND IF ." !" THEN ['] ."R" TO ."_R"
	." ,{"	16 0	DO DUP 1 AND IF ."_R" I .-	THEN 1 >>
			LOOP
	." }"
	[']   BMASKA> TO MASKA>

 	DROP ;

: B,   0x0A000000 |;
: LDR, 0x04000000 |;
: LDRH, 0x008000B0 |;
: BX,  0x012FFF10 |;

: CMN, 0x01700000 |;
: CMP, 0x01500000 |;
: TEQ, 0x01300000 |;
: TST, 0x01100000 |;

: AND, 0x00000000 |;
: EOR, 0x00200000 |;
: SUB, 0x00400000 |;
: RSB, 0x00600000 |;
: ADD, 0x00800000 |;
: ADC, 0x00A00000 |;
: SBC, 0x00C00000 |;
: RSC, 0x00E00000 |;
: BIC, 0x01C00000 |;
: ORR, 0x01800000 |;

: MOV, 0x01A00000 |;
: MVN, 0x01E00000 |;

: SWP, 0x01000090 |;

: STM, 0x08000000 |;
: LDM, 0x08100000 |;

: MUL, 0x00000090 |;

EXPORT


: MINST_ ( [INST] [INST] -- [INST'] )
  \  F7_ED
  ['] 0MASKA> TO MASKA>
  @
  DUP 0x0E000000 AND TO OPCODE
  ['] B_TP TO OP.  B,
  ['] LDR_TP TO OP.  LDR,
\  DUP 0x008000B0 AND TO OPCODE
  DUP 0x028000B0 AND TO OPCODE
  ['] LDRH_TP TO OP.  LDRH,

  DUP 0x0FFFFFF0 AND TO OPCODE
  ['] BX_TP TO OP.  BX,
  DUP 0x0FC00090 AND TO OPCODE
  ['] MUL_TP TO OP. MUL,
  DUP 0x01F00000 AND TO OPCODE
  ['] ALU3 TO OP. CMN, CMP, TEQ, TST,
  DUP 0x09E00000 AND TO OPCODE
  ['] ALU  TO OP. ADC, ADD, AND, BIC, EOR, ORR, RSB, RSC, SBC, SUB, 
  ['] ALU2 TO OP. MOV, MVN,
  DUP 0x0F0000F0 AND TO OPCODE
  ['] SWP_TP TO OP. SWP,
  DUP 0x08100000 AND TO OPCODE
  ['] STM_TP TO OP. STM, LDM,
  DROP ;

: H.H C@ 2 H.N SPACE ;

: MINST ( [INST] -- [INST+4] )
  BASE M@ >R DECIMAL
  DUP >R  
  R@ ADDR_OFF + 8 H.R ."    "
 1
 IF	R@ @ 8	H.N
 ELSE	R@	H.H
	R@ 1+	H.H
	R@ 2+	H.H
	R@ 3 +	H.H
 THEN
  R@ MINST_  CELL+
  RDROP
  R> BASE M!
 ;

;MODULE

