REQUIRE S>NUM ~nn/lib/s2num.f

: CS-SWAP 2SWAP ;
[IFNDEF]  REPLACE

: REPLACE ( by-xt what-xt -- )
\ by Day (Yakimov D.A.)
\ Example: ' NewSPACES ' SPACES REPLACE
  0xE9 OVER C!  \ JMP ...
  1+ DUP >R
  CELL+ -
  R> !
;
[THEN]

[IFNDEF] OR!	:  OR! ( N ADDR -- )	DUP @ ROT OR	SWAP ! ; [THEN]
[IFNDEF] AND!	: AND! ( N ADDR -- )	DUP @ ROT AND	SWAP ! ; [THEN]

C" H." FIND NIP 0=
[IF] : H.  BASE M@ HEX SWAP U. BASE !  ;
[THEN]

C" BOUNDS" FIND NIP 0=
[IF] : BOUNDS OVER + SWAP ;
[THEN]

REQUIRE TH_H-	~mak\LIB\THERE\RECOM.F
\ REQUIRE <SIGN>	lib\include\float.f
\ REQUIRE MFFFFF	~mak\LIB\THERE\tcfloat.f
\ REQUIRE NUMBER? ~mak\LIB\fpcnum.f 
REQUIRE 'NOOP	~mak\ARM7\SRC\forward.f
REQUIRE #define ~af\LIB\c\define.f 
: CMOVE ( c-addr1 c-addr2 u --- )
\ Copy u bytes starting at c-addr1 to c-addr2, proceeding in ascending
\ order.

   DUP IF  >R
   BEGIN
    OVER 
 C@
 SWAP DUP >R
 C!
 R> 1+ SWAP 1+ SWAP
    R>  1- DUP  >R 0=
   UNTIL
   R>
   THEN
   2DROP DROP
;

: M_CMOVE ( c-addr1 c-addr2 u --- )
\ Copy u bytes starting at c-addr1 to c-addr2, proceeding in ascending
\ order.

   DUP IF  >R
   BEGIN
    OVER 
 MC@
 SWAP DUP >R
 C!
 R> 1+ SWAP 1+ SWAP
    R>  1- DUP  >R 0=
   UNTIL
   R>
   THEN
   2DROP DROP
;


REQUIRE TINLINE? ~mak\ARM7\quick\SRC\macroopt.f 

MODULE: TC

 VARIABLE CS-SP
 99 CS-CELLS ALLOT
 HERE CS-SP !

: CS-SP><  \  stack substitution
 CS-SP @ SP@ CELL+ CS-SP ! SP! ;

: ><DP DP M@ T-DP M@
       DP M! T-DP M! ;

: I, , ;

: T_COMPILE,
\   TC_?LIMIT
   ASMARM_MOD::BL,
 ;

: X_COMPILE,
   TC_?LIMIT
	HERE - 2- W, ;

: FOR_LIT,
	TOPT_INIT
	ALSO ASMARM_MOD
	STATE M@ >R	[COMPILE] [
	S" TOS DPUSH,"  EVALUATE TOPT
	S" TOS SWAP ##" EVALUATE
	R> STATE M!
	PREVIOUS ;

: TC-LIT, ( n -- )
\ compile code for a literal
\ DUP 0xFFFFFF00 AND
 ASMARM_MOD::8-BIT? IF FOR_LIT,
 ASMARM_MOD::MOV,
 TOPT
 TOPT_CLOSE
 BREAK INVERT
 ASMARM_MOD::8-BIT? IF FOR_LIT, ASMARM_MOD::MVN, TOPT TOPT_CLOSE BREAK INVERT
 'LIT T_COMPILE, , 
;

:  ?CONST ( cfa -- flag )
  DUP 1+  REL@ CELL+ CONSTANT-CODE  = ;

: TCOMPILE, ( tcfa -- )  
  DUP THERE? 0=
  IF  ?CONST IF EXECUTE TC-LIT, EXIT THEN
      -9 THROW
  THEN
\ F7_ED
	TINLINE? 
 IF
 TINLINE,
 :-SET
 DROP
 BREAK
\ F7_ED
	T_COMPILE, ;


: TCONSTANT
 ><DP CONSTANT   ><DP ;

0 VALUE ZZZZ
: VVOODD
 F7_ED ;

: COMPILE,  
\ ZZZZ IF F7_ED THEN
 DP M@
 THERE?
 IF
 TCOMPILE,
 EXIT THEN
 COMPILE, ;

: CONSTANT HERE THERE? IF TCONSTANT BREAK CONSTANT ;

: #define  HERE THERE? IF ><DP #define ><DP BREAK #define ;
0 [IF]

: LIT,
 DP @ THERE?
 IF   TC-LIT, BREAK
  LIT,
 ;
[THEN]
: DLIT, ( D -> )
  SWAP LIT, LIT,
;
0 [IF]

: LITERAL \ 94 CORE
\ :  .
\ : ( x -- )
\    ,  ,   .
\  : ( -- x )
\  x  .
   STATE M@ IF LIT, THEN
; IMMEDIATE

: 2LITERAL \ 94 DOUBLE
\ :  .
\ : ( x1 x2 -- )
\    ,  ,   .
\  : ( -- x1 x2 )
\    x1 x2  .
  STATE M@ IF DLIT, THEN
; IMMEDIATE

: HEX-SLITERAL ( T -> ... )
  BASE M@ >R HEX
  0 0 2SWAP 2- SWAP 2+ SWAP >NUMBER 2DROP D>S POSTPONE LITERAL
  R> BASE M!
;

: ?SLITERAL1 ( c-addr u -> ... )
  \    
  0 0 2SWAP   [F]
  OVER  C@ [CHAR] - =  
    IF
        1- SWAP 1+ SWAP TRUE 
    ELSE
         FALSE 
    THEN
          >R
  >NUMBER  
  DUP 1 > IF -2001 THROW THEN  \ ABORT" -?"
  IF C@ [CHAR] . <> IF -2002 THROW THEN \ ABORT" -??"
  [P]  R> IF DNEGATE THEN
       [COMPILE] 2LITERAL
  ELSE DROP D>S
       R> IF NEGATE THEN
       [COMPILE] LITERAL
  THEN
;

: ?SLITERAL ( c-addr u -- ... )
  (   ?SLITERAL1:
      -  ,    
        -INCLUDED)
  2DUP 2 MIN S" 0x"
 COMPARE
 0=
  IF HEX-SLITERAL EXIT THEN
  2DUP 2>R ['] ?SLITERAL1 CATCH
  IF   2DROP 2R>           [F]
       OVER C@ [CHAR] " = OVER 2 > AND
       IF 2 - SWAP 1+ SWAP THEN (  ,  )
       2DUP + 0 SWAP C!    [P]
       ['] INCLUDED CATCH
       DUP 2 = OVER 3 = OR (        )
       IF  -2003 THROW \ ABORT"  -???"
       ELSE  THROW THEN
  ELSE 2R> 2DROP
  THEN
;

[THEN]

: MLIT, ( W -> )
  ['] DUP  INLINE,
  OPT_INIT
  SetOP 0xB8 C,  , OPT  \ MOV EAX, #
  OPT_CLOSE
;

: TLIT, 
 DP M@
 THERE?
 IF  TC-LIT, BREAK
 MLIT, ;

' TLIT,  ' LIT, REPLACE

: MCREATE CREATE  ;

: DALIGN	D-DP @ 3 + -4 AND D-DP ! ;
: HDALIGNED     1+  -2 AND ;
: HDALIGN	D-DP @ HDALIGNED D-DP ! ;

: CREATE 
   D-DP M@ \ 3 + 3 INVERT AND DUP D-DP M!
  TCONSTANT ;

: LABEL        ( | name --- )  \    
   HERE TCONSTANT ;

: IALLOT ALLOT ;

: ICREATE
  MCODE
 S" LR RPUSH," EVALUATE
 S" ' DO-ICREATE BL, " EVALUATE
 S" ASM_END" EVALUATE
;

: ICR-EXEC ( cfa -- cfa+2 T | cfa F )
\ F7_ED
  DUP
 CELL+
 @
  0x00FFFFFF AND
 0x00800000 XOR
 0x00800000 -
 CELLS
  OVER CELL+ + 8 +
 'ICREATE
 =
	IF CELL+ CELL+ TRUE BREAK
	FALSE
;

' ICR-EXEC  TC_M::TO V_EXECUTE

: ALLOT  D-DP +! ;
: IHERE  HERE ;
: DHERE  D-DP @ ;

: DHEREH. DHERE H. ;

: MVARIABLE VARIABLE ;
: VARIABLE	DALIGN	CREATE 1 CELLS  ALLOT ;
: XVARIABLE	VARIABLE ;
: UVARIABLE	VARIABLE ;
: 2VARIABLE	DALIGN	CREATE 2 CELLS  ALLOT ;
: HVARIABLE	HDALIGN	CREATE 2  ALLOT ;

: MUSER USER ;

: MUSER-CREATE USER-CREATE ;
: MUSER-ALLOT ( n -- )  USER-ALLOT ;
: MUSER-HERE ( -- n )   USER-HERE  ;
: MUSER-OFFS USER-OFFS ;

MCREATE USER-OFFS 4 ,

: USER-ALLOT ( n -- )
  USER-OFFS +! ;
: USER-HERE ( -- n )
  USER-OFFS @  ;

: USER-CREATE
  MCODE
	S" TOS DPUSH,"  EVALUATE TOPT
	USER-OFFS @
	S" TOS UP ROT ## ADD," EVALUATE
	S" NEXT" EVALUATE
	S" ASM_END" EVALUATE
 ;

: USER 
  USER-CREATE  4 USER-ALLOT ;

0 VALUE V_CONUSER

: NEWTASK:    { u s r \ tid size -- }
\ F7_ED
	USER-HERE u + s + r + TO size
	size 16 + D-DP @ TO tid ALLOT
	HERE
	tid             , 
	tid size   +
	DUP CELL+	, \ _R0
	r -		, \  S0
	0		, \ ttos
        CONSTANT
;

: ?OLD
  S"  DP @ THERE? 0= IF" EVALUATE
  POSTPONE POSTPONE
  S" EXIT THEN" EVALUATE ; IMMEDIATE

: EXIT,
\	ALSO ASMARM_MOD
\	[COMPILE] [  ASMARM_MOD::PC S" RPOP," EVALUATE ]
\	PREVIOUS
	0xE49DF004 I, \	LDR	R15,[R13],#4
;
: EXIT
	?OLD EXIT	EXIT,
; IMMEDIATE

: ; 
	?OLD ;
\	F7_ED
\	S" XXXZZZ" EVALUATE
	EXIT,	SMUDGE	[COMPILE] [
; IMMEDIATE

: ?BRANCH, ( A -- )
\ F7_ED
 :-SET
 DROP
	?OLD ?BRANCH,
	STATE M@ >R
	POSTPONE [
	ALSO ASMARM_MOD
	TOPT_INIT
        S" TOS TOS tst," EVALUATE
	S" TOS DPOP," EVALUATE
	TOPT	TOPT_CLOSE
	S" EQ B," EVALUATE
	PREVIOUS
	R> STATE M!  ;

: BRANCH, ( A -- ) \ ZZZZ IF F7_ED THEN
	?OLD    BRANCH,
	ASMARM_MOD::B, ;

: T>ORESOLVE ( A, N -- )
\  F7_ED
  1 <> IF -2007 THROW THEN \ ABORT" Conditionals not paired"
  HERE OVER - 8 - CELL/ 0x00FFFFFF AND SWAP  0xFF000000 OVER AND! OR!
;

: IF
	?OLD IF
\	f7_ed
  ?COMP DP @ ?BRANCH, HERE 4 - 1
; IMMEDIATE

: AHEAD 
	?OLD AHEAD
  ?COMP HERE  BRANCH, HERE 4 - 1
; IMMEDIATE

: THEN 
	?OLD THEN 
 ?COMP   T>ORESOLVE
; IMMEDIATE

: BREAK 
 POSTPONE EXIT
 POSTPONE THEN ; IMMEDIATE


: ELSE   ( BO BI ADDR ? -- 0 0 ADDR1 ?1 )
  HERE THERE? 0= IF POSTPONE ELSE EXIT THEN
  POSTPONE  AHEAD CS-SWAP
  POSTPONE  THEN  ;  IMMEDIATE

S" ~mak\ARM7\quick\SRC\case.f" INCLUDED

: BEGIN
  HERE THERE? 0= IF POSTPONE BEGIN EXIT THEN
  ?COMP HERE 3
; IMMEDIATE


: UNTIL \ 94
  DP @ THERE? 0= IF POSTPONE UNTIL EXIT THEN
  3 <> IF -2004 THROW THEN \ ABORT" UNTIL  BEGIN !"
  ?COMP
  ?BRANCH,
; IMMEDIATE

: WHILE \ 94
  DP @ THERE? 0= IF POSTPONE WHILE EXIT THEN
  ?COMP [COMPILE] IF
  CS-SWAP
; IMMEDIATE

: AGAIN  HERE THERE? 0= IF  POSTPONE AGAIN EXIT THEN
  ?COMP 3 <> IF -2006 THROW THEN \ ABORT" AGAIN  BEGIN !"
  BRANCH,
; IMMEDIATE

: REPEAT HERE THERE? 0= IF  POSTPONE REPEAT EXIT THEN
  POSTPONE AGAIN
  POSTPONE THEN  ; IMMEDIATE

: RECURSE 
  ?COMP
\	F7_ED
  LAST-NON
  DUP 0= 
  IF
 DROP 
 LATEST NAME>
  THEN
 HERE  THERE?
 IF
  T_COMPILE,
 BREAK
  _COMPILE,
; IMMEDIATE


: A_BEGIN	CS-SP>< POSTPONE BEGIN	CS-SP>< ; IMMEDIATE

: A_AGAIN	CS-SP>< POSTPONE AGAIN 	CS-SP>< ; IMMEDIATE


: [']  \ 94
  ?COMP
	?OLD [']
  '  '(<'>)  T_COMPILE,
  HERE - 4 - ,
; IMMEDIATE

: [CHAR]
  ?COMP
  PARSE-NAME  DROP MC@  LIT,
; IMMEDIATE


: S", ( addr u -- ) \  ,  addr u,     
  DUP  C, 
 DP M@ SWAP DUP IALLOT
\  TT_? IF F7_ED THEN
   M_CMOVE ;


: ALIGNED  3 + -4 AND ;

: SLITERAL 
  HERE THERE? DROP
  HERE
 THERE? 
 STATE
 M@
 AND
  IF  '(S") COMPILE, S", 
	BEGIN HERE 3 AND
	WHILE 0xFF C,
	REPEAT
  ELSE  POSTPONE SLITERAL
  THEN   ; IMMEDIATE
1 [IF]
: S"  ( "ccc<quote>" --- )
\ Parse a string delimited by " and compile the following runtime semantics.
\ Runtime: ( --- c-addr u) Return start address and length of that string.
  [CHAR] " PARSE
  POSTPONE SLITERAL ; IMMEDIATE
[THEN]

: S'  ( 'ccc<quote>' --- )
  [CHAR] ' PARSE
  POSTPONE SLITERAL ; IMMEDIATE

: ."
\ ZZZZ IF F7_ED THEN
  ?COMP
  HERE THERE? 0= IF  POSTPONE ." EXIT THEN
  POSTPONE S" S" TYPE"
 EVALUATE

; IMMEDIATE
0 [IF]
: R@
  HERE THERE? 0= IF POSTPONE R@ EXIT THEN
  [ ALSO ASMARM_MOD ]
  [P]
; IMMEDIATE

: R>
  HERE THERE? 0= IF POSTPONE R> EXIT THEN
  [ ALSO ASMARM_MOD ]
  [P]
; IMMEDIATE

: RDROP
  HERE THERE? 0= IF POSTPONE R> EXIT THEN
  [ ALSO ASMARM_MOD ]
  [P]
; IMMEDIATE

: >R
\  F7_ED
  HERE THERE? 0= IF POSTPONE >R EXIT THEN
  [ ALSO ASMARM_MOD ]
  [P]
; IMMEDIATE
[THEN]
MVARIABLE 'LEAVE ( --- a-addr)
\ This variable is used for LEAVE address resolution.

\ \

: RESOLVE-LEAVE
\ Resolve the references to the leave addresses of the loop.
          'LEAVE @
        BEGIN DUP
	WHILE DUP @ HERE ROT !
	REPEAT DROP ;

: DO
  ?OLD DO
  S" (DO)" EVALUATE
   'LEAVE @ HERE 0 'LEAVE ! ; IMMEDIATE

: ?DO ( --- x )
  ?OLD ?DO
  S" (?DO)" EVALUATE
 'LEAVE @ HERE 'LEAVE !
 0 , HERE
 ; IMMEDIATE

: LOOP  ( x --- )
\ End a DO LOOP.
\ Runtime: Add 1 to the count and if it is equal to the limit leave the loop.
  ?OLD LOOP
  S" (LOOP)" EVALUATE
  HERE - ,
  RESOLVE-LEAVE 
 'LEAVE !
 ; IMMEDIATE

: +LOOP ( x --- )
\ End a DO +LOOP
\ Runtime: ( n ---) Add n to the count and exit if this crosses the
\ boundary between limit-1 and limit.
  ?OLD +LOOP
  S" (+LOOP)" EVALUATE
  HERE - , RESOLVE-LEAVE 'LEAVE ! ; IMMEDIATE

\ \


: TALIGN
 BEGIN HERE 3 AND
 WHILE 0xFF C,
 REPEAT

;

MVARIABLE 'LEAVE ( --- a-addr)
\ This variable is used for LEAVE address resolution.

\ OPER TlsIndex!

MVARIABLE TLAST ( --- addr)
\ This variable holds a pointer to the last definition created.

MVARIABLE TCURRENT ( --- addr)
\ This variable holds the address of the word list to which new definitions
\ are added.

: TLINK, ( wid -> ) 
  DUP
  @
\ DUP IF 0x104000 - THEN
\ OVER -
 W,
 HERE
 SWAP
 !
  HERE
 TLAST
 !
;

VECT S'', 

' S", TO  S'',

: T_S'',
\ F7_ED
\ 2DUP TYPE
  S'',
 TALIGN \ FF_ALIGN
;

0 VALUE HEAD?

: ?HEAD
 HEAD?	IF	\  F7_ED
\		LAST M@ NAME>
		TALIGN
		0 W,	\ flags
		HERE >R
		-1 W,	\ cfa
		TCURRENT
		M@ 	 TLINK,
		>IN @	PARSE-NAME
		2DUP + 1- C@ [CHAR] _ = IF 1- THEN
		T_S'',
		>IN !
		TALIGN
		HERE \ 0x104000 -
 R> W!
	THEN ;


: :
    HERE THERE? 0= IF  :  BREAK
 [DEFINED] DBG_STOP [IF] TT_? IF DBG_STOP THEN
 [THEN]
 ?HEAD
 TALIGN
 : 
 ALSO ASMARM_MOD 
  ASMARM_MOD::LR POSTPONE [
 S" RPUSH," EVALUATE ]
 PREVIOUS ;

: NEXT  
  ASMARM_MOD::LR  ASMARM_MOD::BX, ;

0 VALUE T$$

: $$,  ( ADDR -- ADDR+2 )
 COUNT  0x10 DIGIT 0= THROW >R
 COUNT  0x10 DIGIT 0= THROW R> 0x10 * OR C, ;

: $$
 PARSE-NAME 2DROP
    BASE @ >R HEX
   PARSE-NAME
  NUMBER?
0= THROW  THROW
 T$$ IF W, ELSE , THEN
   R> BASE !
	POSTPONE \
;

0 VALUE END$$
: <$$
 0 TO END$$ \ f7_ed
 0 TO T$$ \ f7_ed
  BEGIN
	END$$ 0=
\ DUP
\ IF DROP REFILL THEN
 REFILL AND
\ cr source type \ key drop
  WHILE SkipDelimiters
    PeekChar 
	CASE
		[CHAR] 0
 OF
 $$
 ENDOF
\		 BL      OF PARSE-NAME DUP
\			IF 1- SHEADER
\			ELSE 2DROP
\			THEN  ENDOF
		[CHAR] $ OF TRUE TO END$$  ENDOF
		[CHAR] T OF TRUE TO T$$  ENDOF
		[CHAR] A OF 0	TO T$$  ENDOF
	ENDCASE
  REPEAT
;

~mak\ARM7\quick\SRC\debug.f 

EXPORT

' <PRE> >BODY M@  ' NOOP  TO <PRE> \   

[DEFINED] DBG_COUNT   [IF] DBG_COUNT M@  DBG_COUNT 0! [THEN]

: TC_ERROR ( ERR-NUM -> )       \ 
  [ ' ERROR >BODY M@ COMPILE, ]  \   
  DUP  HERE THERE? AND IF ><DP THEN 
;

[DEFINED] DBG_COUNT   [IF]  DBG_COUNT ! [THEN]

TO <PRE>

: T-STOP
  PREVIOUS DEFINITIONS
  HERE THERE?    IF ><DP THEN
;

: T-GO
[DEFINED] DBG_STOP [IF]  DBG_STOP [THEN]
  ALSO TC DEFINITIONS
  HERE THERE? 0= IF ><DP THEN
;

: THERE?A
   0x40000000 U< 0= ;


: THERE?B_
 DUP  YDP M@ U< 0=
\ SWAP  IMAGE-BEGIN U< 
 SWAP 0x40000 U< 
\ DUP IF F7_ED  THEN
 OR ;


: THERE?C
\   DUP   0x300000 ['] DUP WITHIN IF F7_ED THEN
   0x300000 U<
  
 ;


: T-START  ( n -- )  \ n   
  1 TO YDP_FL
  1 ALIGN-BYTES !
  T-INIT
\ ['] TC_ERROR TO ERROR
 ['] THERE?C TO THERE?
\  HERE T-ORG U<
\  IF  ['] THERE?A TO THERE?
\  THEN
  T-GO
;

: TSAVE (  ADDR LEN -- )
  R/W CREATE-FILE THROW >R
  T-ORG HERE OVER - R@ TWRITE-FILE THROW
  R> CLOSE-FILE THROW 
;

: ATIPE ( ADDR LEN -- )
   BOUNDS
   DO  CR ." .byte  0x"  I C@  H. ." ,0x"  I 1+ C@  H. 2
  +LOOP CR
;

: ASAVE (  ADDR LEN -- )
  R/W CREATE-FILE THROW
  H-STDOUT >R
  TO H-STDOUT
  T-ORG HERE OVER -
  ['] ATIPE CATCH
  H-STDOUT CLOSE-FILE R> TO H-STDOUT THROW
  THROW
;

: CTIPE ( ADDR LEN -- )
	." const char FORTH_IMG[]={"
	>R 
	." 0x"  DUP C@  H. 1+
	." ,0x" DUP C@  H. 1+
	." ,0x" DUP C@  H. 1+
	." ,0x" DUP C@  H. 1+
	R> CELL- 0 MAX
   BOUNDS
   ?DO    CR
	." ,0x"  I C@  H.
	." ,0x"  I 1+ C@  H.
	." ,0x"  I 2+ C@  H.
	." ,0x"  I 3 + C@  H.
 4  +LOOP ." };" CR 
;

: CSAVE (  ADDR LEN -- )
  R/W CREATE-FILE THROW
  H-STDOUT >R
  TO H-STDOUT
  T-ORG HERE OVER -
  ['] CTIPE CATCH
  H-STDOUT CLOSE-FILE R> TO H-STDOUT THROW
  THROW
;


 MVARIABLE H-SUM
1 [IF]

: HEXBYTE ( BYTE FILE -- )
  >R DUP H-SUM @ + H-SUM !
  S>D <# # # #> R> WRITE-FILE THROW
;

: T-HEXLINE ( ADDR FILE -- )
  H-SUM 0!
  >R S" :" R@ WRITE-FILE THROW
  0x10 R@ HEXBYTE DUP 0x100 / R@ HEXBYTE
  DUP 0xFF AND R@ HEXBYTE 0x00 R@ HEXBYTE
  R>
  0x10 0 DO
    >R DUP C@ R@ HEXBYTE
    1+ R>
  LOOP
  >R DROP H-SUM @ NEGATE R@ HEXBYTE
  0 0 R> WRITE-LINE THROW
;

: T-SAVE ( FILENAME )
  BASE @ >R HEX
  R/W CREATE-FILE THROW
  HERE T-ORG DO
    I OVER T-HEXLINE
  0x10 +LOOP
  >R S" :00000001FF" R@ WRITE-LINE THROW
  R> CLOSE-FILE THROW

  R> BASE !
;
[THEN]

: ROM_SAVE
 DHERE D-ORG - S" &D-DP" EVALUATE !
 HERE FFFFH AND S" IMG_SIZE" EVALUATE !
 HERE 0x40000000 - 12 RSHIFT 1+ S" #ROM_SAVE" EVALUATE ;

: (FORGET)  ( cfa -- )   \ assumes count follows name
  [ ALSO FORTH ]
   DUP DP M!
   >NAME 
    DUP CDR 
    CURRENT M@ M!
   CELL- YDP M!
   [P]
;

: $FORGET ( addr len -- )
 \  F7_ED
  [ ALSO FORTH ]
   SFIND    0=
   IF -321 THROW THEN (  -? )
   (FORGET)
   [P]
;

: FORGET ( <NAME> -- )
  PARSE-NAME $FORGET
;

: ANEW ( "name" -- )( Run: -- )
\  F7_ED
  [ ALSO FORTH ]
  >IN M@ >R
     PARSE-NAME
  SFIND
   IF  DUP THERE?
       IF 
          RDROP
         (FORGET)
       BREAK (  -? )
       DROP
  ELSE    2DROP
  THEN
   R> >IN M!
   HEADER
  [P]  ;

:  ?COMP_ STATE M@ =
         IF
  COMPILE,
         ELSE
 EXECUTE
         THEN ;

: TC-INTERPRET ( -> )
\ CR SOURCE TYPE
         MAIN_S
  BEGIN   DUP 0x3292F0 = IF F7_ED THEN
    PARSE-NAME DUP
  WHILE
    SFIND ?DUP
    IF [']  ?COMP_  CATCH 
        THROW
    ELSE 
\	?_.
\        IF  F-SIZE @ >R FSINGLE ['] MFFFFF CATCH R> F-SIZE ! THROW\
\        ELSE ?SLITERAL
\        THEN
         S" NOTFOUND" SFIND 
         IF EXECUTE
         ELSE 2DROP
         ?SLITERAL
         THEN
    THEN
    ?STACK  MAIN_S
  REPEAT 2DROP 
;

 ' TC-INTERPRET  &INTERPRET !

: STT #START UEMIT #START UEMIT MAIN_S ;

MODULE: TC-MAP


MCREATE XNAME 66 IALLOT

WARNING @
WARNING 0!

VECT XHEADER

: $HEADER
  DP M@ >R
  DP M! HEADER R>
  DP M! ;

: CODE 
  ['] $HEADER TO XHEADER ;

WARNING !


: ICODE  CODE ;
: CODE_I  CODE ;
: CODE_ID  CODE ;
: DATA_C ;

: DATA_Z
  ['] CONSTANT TO XHEADER ;

: DATA_I    DATA_Z ;

: INITTAB	DATA_Z ;

: INTVEC ;
: DATA16_ID ;
: DATA_ID ;
: RESET ;
: CSTACK ;
: CSTART ;


EXPORT

: Warning[w6]:
  H-STDLOG >R
  0 TO H-STDLOG
  1 ALIGN-BYTES !
    BEGIN
      PARSE-NAME
\  2DUP ." <" TYPE ." >"
  DUP
      IF      S" INTRAMEND_REMAP" COMPARE
      ELSE 2DROP REFILL  \   SOURCE TYPE
      THEN  0=
    UNTIL

  BASE @ HEX
  ALSO TC-MAP

  BEGIN REFILL PeekChar [CHAR] S <> AND
  WHILE PeekChar      BL <>
	IF INTERPRET
	ELSE	PARSE-NAME 2DROP
		PARSE-NAME DUP 8 =
		>IN @ 44 = AND
		IF
\ F7_ED CR 2DUP TYPE
	SNUMBER
 D>S
			>IN 0!
 XHEADER
		ELSE 2DROP
		THEN POSTPONE \
	THEN
  REPEAT
       \EOF
  PREVIOUS
  BASE !
 R> TO H-STDLOG
;


: XCode  DP @ >R
 DP !  HEADER
R> DP ! ;
: XData  CONSTANT ;
: X--  CONSTANT ;

: ###############################################################################
  1 ALIGN-BYTES !
\ F7_ED
  BEGIN   REFILL DROP
     SOURCE
 DROP
 MC@
 [CHAR] ?
 =
  UNTIL
\  REFILL DROP
  BEGIN  REFILL DROP
\     SOURCE TYPE CR
    SOURCE  DUP 0= IF \EOF BREAK
 55 U>
    SWAP C@
 BL
 <>
 AND
   IF
     24 >IN ! PARSE-NAME 1+ XNAME $!
      S" X"   XNAME $+!
 PARSE-NAME 1+
 OVER C@ '0' = IF 2DROP PARSE-NAME 1+
		THEN
 XNAME $+!
     0 >IN ! PARSE-NAME XNAME $+!
    XNAME  COUNT TYPE CR
    XNAME  COUNT EVALUATE
   THEN
 AGAIN
\  KEY BL <>  UNTIL

;


: ################################################################################ 
 Warning[w6]: ;

;MODULE

;MODULE

: TTTCCC
 F7_ED
;