#define AT91C_PIO_PA30	1  30	<< \ ext wire 0 alarm
#define AT91C_PIO_PA25	1  25	<< \ CTS
#define AT91C_PIO_PA27	1  27	<< \ dtr modem
\ #define AT91C_PIO_PA7	1  7	<< \ Pin 32 output acc activation 1
#define AT91C_PIO_PA3	1  3	<< \ ext wire 2
#define AT91C_PIO_PA1	1  1	<< \ rez power
#define AT91C_PIO_PA0	1  0	<< \ sleep acc 

MODULE: ASMARM_MOD

#define TR0	R0
#define TREG	R1
#define TOS	R4
#define W	R8
#define UP	R9
#define IP	R10
#define DSTK	R11
#define RSTK	R13

[IFDEF] ><DP ><DP [THEN]

: DPUSH,  [[ DSTK ## -4  ]] !!  STR, ;
: DPOP,   [[ DSTK ]] ## 4   LDR, ;

: RPUSH,  [[ RSTK ## -4  ]] !!  STR, ;
: RPOP,   [[ RSTK ]] ## 4   LDR, ;

P: DPOP, 
P: DPUSH, 
P: RPOP, 
P: RPUSH, 

[IFDEF] ><DP ><DP [THEN]

#define U0BASE 0xe000c000

;MODULE

[IFDEF] ><DP

\  00000234  E129F001  MSR          CPSR_cf, R1
\  00000238  E10F1000  MRS          R1, CPSR
\  0000023C  E14F1000  MRS          R1, SPSR
\  00000240  E14F0000  MRS          R0, SPSR
\  00000244  E14F7000  MRS          R7, SPSR
\  00000248  E14F9000  MRS          R9, SPSR
\  0000024C  E14FE000  MRS          LR, SPSR

\  0xE0821093 ,

CODE BOOT

\ tos [[ DSTK ## 4  ]]  STR,
\	tos [[ DSTK  ]] ## 4  STR,
\	str	TOS ,[DSTK,#-4]!
\	SUB TOS, PC, #4

ASM_END

ALSO ASMARM_MOD AHEAD, [P] CS-ORG M!

[THEN]