#ifndef __ARCH_CC_H__
#define	__ARCH_CC_H__

//#include <crtdbg.h>

#pragma warning (disable: 4761)		// integral size mismatch in argument; conversion supplied
#pragma warning (disable: 4244)		// conversion from 'x' to 'y', possible loss of data
#pragma warning (disable: 4018)		// warning C4018: '>=' : signed/unsigned mismatch

typedef	unsigned int	u_int;
typedef	unsigned short	u_short;
typedef	unsigned char	u_char;

typedef	signed int		s32_t;
typedef	signed short	s16_t;
typedef	signed char		s8_t;

typedef	unsigned int	u32_t;
typedef	unsigned short	u16_t;
typedef	unsigned char	u8_t;

typedef	unsigned int	mem_ptr_t;

#define	PACK_STRUCT_FIELD(x)		x
#define	PACK_STRUCT_STRUCT
#define	PACK_STRUCT_BEGIN
#define	PACK_STRUCT_END

#define	PACK_STRUCT_USE_INCLUDES

#define	LWIP_PLATFORM_DIAG(x)	//ivv 	arch_report x		// non-fatal, print a message.
#define	xASSERTE(x)	/*	printf("~"); */ _ASSERTE(x)

#define	LWIP_PLATFORM_ASSERT(x)		_ASSERTE(x)			// fatal, print message and abandon execution.

#define	SYS_ARCH_DECL_PROTECT(x)	// declare a protection state variable.
#define	SYS_ARCH_PROTECT(x)			// enter protection mode.
#define	SYS_ARCH_UNPROTECT(x)		// leave protection mode.

#define	BYTE_ORDER	LITTLE_ENDIAN

#define	S16_F						"d"
#define	U16_F						"u"
#define	X16_F						"x"
#define	S32_F						"d"
#define	U32_F						"u"
#define	X32_F						"x"

//#include "stdio.h"
//#include "memory.h"
#include "string.h"

// ivv #define	snprintf	_snprintf

typedef	void*		HANDLE;

// void arch_report( const char*x, ...);

#endif