
: NAME>L  2 - ;
: NAME>C  2 - 2 - ;
: NAME>   NAME>C W@ ;
: NAME>F  2 - 2 - 2 - ;

: SEARCH-WORDLIST ( c-addr u wid --- 0 | xt 1 xt -1)
\ Search the wordlist with address wid for the name c-addr u.
\ Return 0 if not found, the execution token xt and -1 for non-immediate
\ words and xt and 1 for immediate words.
	@ 
	BEGIN   DUP
	WHILE
	>R 2DUP	R@ COUNT
		EUCOMPARE 0=
		IF	2DROP
			R@ NAME>
			R> NAME>F W@ 1 AND 1- 1 OR EXIT
		THEN 	R>  NAME>L W@
	REPEAT
	2DROP DROP 0 \ Not found.
;


VARIABLE CONTEXT

 0 TO HEAD?

: SFIND ( addr len --- addr len 0| xt 1|xt -1 )
\ Search all word lists in the search order for the name in the
\ counted string at c-addr. If not found return the name address and 0.
\ If found return the execution token xt and -1 if the word is non-immediate
\ and 1 if the word is immediate.
  2DUP
	CONTEXT @
     SEARCH-WORDLIST DUP
	IF  2NIP THEN
;
