
: TICS
 timecou  @ +
  \ CR ." TICS="
	BEGIN 2 GTICS	DUP timecou  @  -
\ DUP .
 0< 	UNTIL DROP ;

: SECS aseconds @ +
 CR ." SECS="
	BEGIN  DUP aseconds @  -
		11 OVER  1 = IF DROP 1 THEN TICS
		 DUP . 0< 
	UNTIL DROP ;


VARIABLE &GPS-STEP
VARIABLE PDU-TAIL
VARIABLE SMS_PERMIT

: GPS-STEP PINPUT? 0= IF 0 EXIT THEN
   &GPS-STEP PERFORM ;

0 [IF]
: GSM_SW

 POWER_GSM_ON
\ 0x2FFFFF BEGIN WDT_CHOP 1- DUP 0= UNTIL DROP
 4 SECS
 POWER_GSM_OFF
\ 0x2FFFFF BEGIN WDT_CHOP 1- DUP 0= UNTIL DROP
 4 SECS
 POWER_GSM_ON ;

[THEN]


CODE C_GOUTPUT ( c -- )
	STMDB	SP!,{LR}
	MOV	r0, TOS 
\	BL	' CGEMIT
	BL	' usart1_send
	ldr	TOS, [DSTK], #4  \ DROP
	LDMIA	SP!,{LR}
	NEXT
ASM_END

CODE GSMBAUD ( c -- )
	STMDB	SP!,{LR}
	MOV	r0, TOS 
	BL	' GSM_BAUD
	ldr	TOS, [DSTK], #4  \ DROP
	LDMIA	SP!,{LR}
	NEXT
ASM_END



CODE GINPUT?_
	STMDB	SP!,{LR}
	str	TOS, [DSTK,#-4]! \ DUP
	BL	' ComCnt1
	MOV	TOS, r0
	LDMIA	SP!,{LR}
	NEXT
ASM_END


: _GOUTPUT
 OUTMODE @ 3 <> IF OUTMODE 0! CR ." GSM<" 3 OUTMODE ! THEN
 DUP _EMIT
\ 222  1 OR BEGIN WDT_CHOP 1- DUP 0= UNTIL DROP    \ 0 DO LOOP
 C_GOUTPUT ;

: _GTYPE ( c-addr1 u --- )
\ Output the string starting at c-addr and length u to the terminal.
   OVER + SWAP BEGIN 2DUP -
 WHILE DUP C@
 _GOUTPUT CHAR+ REPEAT 2DROP ;

VARIABLE GOUTTICS
VARIABLE VCONNECT

: GOUTPUT

\ BEGIN   GINPUT?_ ComBufSize <> UNTIL
 WDT_CHOP
\ 2 GTICS
\ VCONNECT @
\ IF
\   GOUTTICS @ TICS
\  BEGIN timecou  @ GOUTTICS @ MOD 0= UNTIL

  BEGIN vCTS @
  WHILE  8 GTICS  QGSM_INT_ON
  REPEAT

\ THEN
 _GOUTPUT
;

: GEMIT ( c -- )
\ [CHAR] ^ EMIT DUP EMIT
\ 0x200000
\ BEGIN 1- DUP 0= GETCTS 0= OR UNTIL DROP
\ BEGIN  timecou  @ GOUTTICS @ MOD 0= UNTIL

 GOUTPUT

;

: GTYPE ( c-addr1 u --- )
\ Output the string starting at c-addr and length u to the terminal.
   OVER + SWAP BEGIN 2DUP -
 WHILE DUP C@
 GEMIT CHAR+ REPEAT 2DROP ;

: GCR
 0xD GEMIT
\ 0xA GEMIT
 ;

VARIABLE &TTEMIT

: TTEMIT &TTEMIT PERFORM ;

: TTCR
 0xD TTEMIT
\ 0xA GEMIT
 ;

: TTTYPE ( c-addr1 u --- )
\ Output the string starting at c-addr and length u to the terminal.
   OVER + SWAP BEGIN 2DUP -
 WHILE DUP C@
 TTEMIT CHAR+ REPEAT 2DROP ;



VARIABLE ?PPP
VARIABLE DO_PSWICH
VARIABLE DO_ALARM
VARIABLE DO_PULS
VARIABLE DO_GSM
VARIABLE DO_CTS
VARIABLE DO_ADC
VARIABLE DO_SLADC
VARIABLE DO_GPSADC
VARIABLE DO_GPSDOWN 
: GINPUT?
	2 GTICS
		DO_ADC		PERFORM
		DO_SLADC	PERFORM
		DO_GPSADC	PERFORM
	?PPP @ 1+ 1 OR 1 =  \ PPP  室 -
	IF
		GPS-STEP DROP
		DO_PULS		PERFORM
	       SMS_PERMIT @
		IF
		 	DO_PSWICH	PERFORM
			DO_ALARM	PERFORM
			DO_CTS		PERFORM
		THEN
	THEN
       GINPUT?_
	2 GTICS
 ;


CODE GC_INPUT
	STMDB	SP!,{LR}
	str	TOS, [DSTK,#-4]! \ DUP
CODL GDROPINPUT
	BL	' GetPort1
	MOV	TOS, r0
	LDMIA	SP!,{LR}
	NEXT
ASM_END

: _GINPUT	( -- c )

 GINPUT? 0=
 IF
  4  aseconds @ +
	BEGIN  DUP aseconds @  -
		0< GINPUT? OR  WDT_CHOP
	UNTIL DROP 
	GINPUT? 0= IF 0 EXIT THEN
 THEN

	GC_INPUT ;

: GINPUT	( -- c )
  _GINPUT
  OUTMODE @ 1 <> IF OUTMODE 0! CR R@ H. ." GSM>" 1 OUTMODE ! THEN
  DUP _EMIT
;

: GINPUT>	( -- c )
	5 aseconds @ +
	BEGIN
	WDT_CHOP
	DUP aseconds @  - 0<
	IF DROP [CHAR] > 
	   CR ." N>" CR  EXIT
	THEN
	DO_PULS  PERFORM
	3 TICS
	GINPUT?_
	UNTIL DROP GC_INPUT

 OUTMODE @ 1 <> IF OUTMODE 0! CR ." GSM~" 1 OUTMODE ! THEN
 DUP _EMIT
;



: -GSM
 BEGIN GINPUT?_
 WHILE GC_INPUT EMIT REPEAT ;

: -GCR
 0xD _GOUTPUT
\ 0xA GEMIT
 ;


: GWEMIT ( w -- )
            DUP  GEMIT
   8 RSHIFT      GEMIT ;

: GDEMIT ( n -- )
            DUP  GEMIT
   8 RSHIFT DUP  GEMIT
   8 RSHIFT     GWEMIT ;


: .GSM
 BEGIN GINPUT? 
 WHILE GINPUT DROP REPEAT ;



: XTYPE
   DUP PDU-TAIL -!
\ ." $<" 2DUP TYPE ." >"  PDU-TAIL @ H. CR
 GTYPE ;

: XEMIT 
  PDU-TAIL 1-!
\ ." $<" DUP EMIT ." >"  PDU-TAIL @ H.
 GEMIT ;
: XCR
 CR
 GCR ;

CODE TOPBUF
	STR	LR,[SP,#-4]!
	MOV	R1,TOS
        dpop	R0
	BL	' to_pbuf
        dpop	TOS
	LDR	PC,[SP],#4
ASM_END
   
