
CODE TST
(
)
ASM_END

  0x03A00000 ,
  0xE0821093 ,
  0xE090189A ,
  0xE09A8190 ,

QUICK 0=
[IF]

CODE NEST
	str IP, [RSTK, #-4]!
	MOV IP, LR

CODL NOOP
	ldrsh W, [IP], #2
	ADD	R7,ip,W
	BX	R7
\	ADD	pc,ip,W
		
ASM_END
' NEST TO 'NEST
' NOOP TO 'NOOP

CODE EXIT
	ldr IP, [RSTK], #4
	NEXT
	ldrsh W, [IP], #2
	ADD	pc,ip,W
ASM_END

' EXIT TO 'EXIT

CODE LIT
	str	TOS, [DSTK,#-4]!
	ldr	TOS, [IP], #4
	NEXT
ASM_END
' LIT TO 'LIT

CODE (<'>)
	str	TOS, [DSTK,#-4]!
	ldrsh	W,[IP],#2
	ADD	TOS,ip,W	
	NEXT
ASM_END
' (<'>) TO '(<'>)

CODE DUP
CODL XDUP
	str	TOS, [DSTK,#-4]!
	NEXT
ASM_END

CODE DO-ICREATE
	str	TOS, [DSTK,#-4]!
	MOV	TOS, LR
	NEXT
ASM_END
' DO-ICREATE TO 'ICREATE

CODE BRANCH
\        ldrh	W, [IP]
	ldrsh	W,[IP],#2
	ADD	ip,ip,W	
	NEXT
ASM_END
' BRANCH TO 'BRANCH

CODE ?BRANCH
	TST	TOS, TOS
        ldr	TOS, [DSTK], #4
\        ldrh	W, [IP]
        ldrsh	W, [IP], #2
        ADDEQ	IP, IP, W
	NEXT
ASM_END
' ?BRANCH TO '?BRANCH

[ELSE]

CODE LIT
	str	TOS, [DSTK,#-4]!
	ldr	TOS, [LR], #4
	NEXT
ASM_END
' LIT TO 'LIT

CODE (<'>)
	str	TOS, [DSTK,#-4]!
	ldr	W,[LR],#4
	ADD	TOS,LR,W	
	NEXT
ASM_END
' (<'>) TO '(<'>)

CODE DUP
CODL XDUP
	str	TOS ,[DSTK,#-4]!
CODL NOOP
CODL XSWAP
CODL X>S 
	NEXT
ASM_END

' NOOP TO 'NOOP

CODE DO-ICREATE
	str	TOS, [DSTK,#-4]!
	MOV	TOS, LR
	RPOP	PC
ASM_END
' DO-ICREATE TO 'ICREATE

[THEN]

CODE OVER ( n1 n2 -- n1 n2 n1 )
	str	TOS, [DSTK,#-4]!
        ldr	TOS, [DSTK, #4]
	NEXT
ASM_END

' OVER TO 'OVER

CODE TUCK ( n1 n0 --  n0 n1 n0 )
	dpop	r3
        stmdb	DSTK!, {r3,R4}
	NEXT
ASM_END


CODE ROT  ( a b c - b c a)
        ldmia	DSTK!, {r5, r6}	;  copy a to r2,  copy b to r1,   tos has c
        stmdb	DSTK!, {r4, r5}	// copy b and c back to physical stack
        mov	TOS, r6		@ copy a to TOS
	NEXT
ASM_END

CODE -ROT  ( a b c - c a b)
	MOV	R6,TOS		; copy TOS to r2
        ldmia	DSTK!, {r4,r5}	; copy a to r1,  copy b to TOS,  tos has c
        stmdb	DSTK!, {r5,r6}	// copy a and c back to physical stack
	NEXT
ASM_END

CODE 2SWAP ( a b c d - c d a b)
        ldmia	DSTK!, {r5-r7}    @ r3=a, r2=b, r1=c, r0=d
        stmdb	DSTK!, {r4,r5}    @ push c, push d
        dpush	r7                @ push a
        mov	TOS, r6             @ put b into TOS
	NEXT
ASM_END

CODE ?DUP
        tst	TOS, TOS
        strne	TOS, [DSTK, #-4]!  @ only if TOS is non-zero do we dup it
	NEXT
ASM_END

CODE 2DROP
        ldmia	DSTK!, {r3, r4}
	NEXT
ASM_END

CODE R@
CODL I
	str	TOS, [DSTK,#-4]! \ DUP
CODL DROPR@
	ldr	TOS, [RSTK,#0]
	NEXT
ASM_END

CODE R>
	str	TOS, [DSTK,#-4]! \ DUP
	ldr	TOS, [RSTK], #4
	NEXT
ASM_END
' R> TO 'R>

CODE 2RDROP
CODL UNLOOP
	add	RSTK, RSTK, #4
CODL RDROP
	add	RSTK, RSTK, #4
	NEXT
ASM_END


CODE 2>R
CODL (DO)
	swp	TOS, TOS, [DSTK]
CODL >R>R
	str	TOS, [RSTK,#-4]! 
	ldr	TOS, [DSTK], #4  \ DROP
CODL >R
	str	TOS, [RSTK,#-4]! 
CODL DROP
CODL D>S 
	ldr	TOS, [DSTK], #4
	NEXT
ASM_END
' >R	TO '>R
' DROP	TO 'DROP

CODE DUP>R
	str	TOS, [RSTK,#-4]! 
	NEXT
ASM_END

CODE 2R@
	str	TOS, [DSTK,#-4]! \ DUP
	ldr	TOS, [RSTK,#4]
\ CODL R@'
	str	TOS, [DSTK,#-4]! \ DUP
	ldr	TOS, [RSTK,#0]
	NEXT
ASM_END

CODE 2R>
	str	TOS, [DSTK,#-4]! \ DUP
	ldr	TOS, [RSTK], #4
CODL R>SWAP
	str	TOS, [DSTK,#-4]! \ DUP
	ldr	TOS, [RSTK], #4
CODL SWAP
	swp	TOS, TOS, [DSTK]
	NEXT
ASM_END

CODE CELL-
	SUB	TOS,TOS,#3
CODL 1-
CODL CHAR-
	SUB	TOS,TOS,#1
	NEXT
ASM_END

CODE 2-
	SUB	TOS,TOS,#2
	NEXT
ASM_END

CODE 3CELL+
	ADD	TOS,TOS,#4
CODL 2CELL+
	ADD	TOS,TOS,#4
CODL CELL+
	ADD	TOS,TOS,#3
CODL 1+
CODL CHAR+
	ADD	TOS,TOS,#1
	NEXT
ASM_END

CODE 2+
	ADD	TOS,TOS,#2
	NEXT
ASM_END

CODE +
        dpop	r1
        add	TOS,r1,TOS
	NEXT
ASM_END

CODE D+
        ldmia	DSTK!, {r5, r6,r7}
        adds	r5,r5,r7
        adc	TOS,TOS,r6
	str	r5, [DSTK,#-4]!
	NEXT
ASM_END

CODE -
CODL X-
        dpop	r1
        sub	TOS,r1,TOS	@ TOS=a-b
	NEXT
ASM_END

CODE AND
        dpop	r1
        AND	TOS, R1, TOS
	NEXT
ASM_END

CODE OR
        dpop	r1
        ORR	TOS, R1, TOS
	NEXT
ASM_END

CODE XOR
        dpop	r1
        EOR	TOS,R1,TOS
	NEXT
ASM_END

CODE INVERT
        MVN	TOS,TOS
	NEXT
ASM_END

CODE NEGATE ( n - -n)
        rsb	TOS,TOS,#0	@ TOS := 0 - TOS (i.e. two's  complement)
	NEXT
ASM_END

CODE DNEGATE ( n - -n)
        dpop	r1
        rsbS	TOS,TOS,#0
        rsc	R1,R1,#0
        dpush	r1
	NEXT
ASM_END

CODE NIP
	add	DSTK,DSTK,#4
	NEXT
ASM_END

CODE >
	swp	TOS,TOS,[DSTK]
CODL <
        dpop	r1
        subs	TOS,r1,TOS        @ TOS = a-b  -- msbit set if a is less than b
CODL 0<
        mov	TOS,TOS,asr #31    @ turn msbit into 0xffff or 0x0000
	NEXT
ASM_END

CODE 0>
        rsb	TOS,TOS,#0	@ TOS := 0 - TOS (i.e. two's  complement)
        mov	TOS,TOS,asr #31    @ turn msbit into 0xffff or 0x0000
	NEXT
ASM_END

CODE U>
	swp	TOS,TOS,[DSTK]
CODL U<
CODL UX<
        dpop	r1
        subs	TOS,r1,TOS      @ TOS = a-b  -- carry set if a is less than b
        sbc	TOS,TOS,TOS
	NEXT
ASM_END

CODE =  ( a b - f)
        dpop	R1
        eor	TOS, R1 TOS
CODL 0=
CODL X0=
	subs	TOS, TOS, #1
	sbc	TOS, TOS, TOS
	NEXT
ASM_END

CODE D0=
        dpop	r1
        ORR	TOS, R1, TOS
	subs	TOS, TOS, #1
	sbc	TOS, TOS, TOS
	NEXT
ASM_END

' = TO '=

CODE <>  ( a b - f)
	dpop	R1
	cmp	TOS,R1
	MOV	TOS,#0
	SUBNE	TOS,TOS,#1
	NEXT
ASM_END

CODE MIN  ( n1 n2 -- n3 )
        dpop	TREG
	CMP	TOS, TREG
	MOVGT	TOS, TREG
	NEXT
ASM_END

CODE MAX  ( n1 n2 -- n3 )
        dpop	TREG
	CMP	TOS, TREG
	MOVLT	TOS, TREG
	NEXT
ASM_END

CODE ABS  ( n1 n2 -- n3 )
	CMP	TOS, #0
        rsblt	TOS,TOS,#0
	NEXT
ASM_END

CODE UMIN  ( n1 n2 -- n3 )
        dpop	TREG
	CMP	TREG, TOS
	MOVCC	TOS, TREG
	NEXT
ASM_END

CODE UMAX  ( n1 n2 -- n3 )
        dpop	TREG
	CMP	TOS, TREG
	MOVCC	TOS, TREG
	NEXT
ASM_END

CODE DU<
        ldmia	DSTK!, {r5, r6,r7}
	CMP	R6, R4                \   00008140  E1510003
	BHI	LL0 \ 0x008154              \   00008144  8A000002
	CMPCS	R7, R5                \   00008148  21500002
	MOVCC	R4, #0x1              \   0000814C  33A00001
	BCC	LL1 \ 0x008158              \   00008150  3A000000
LL0:	MOV	R4, #0x0              \   00008154  E3A00000
LL1:	RSB	R4, R4, #0x0          \   00008158  E2600000
	NEXT
ASM_END

CODE *
        dpop	r1
        mov	r0, TOS
        mul	TOS, r1, R0
	NEXT
ASM_END

CODE UM*  ( u1 u2 - ud)
        ldr	r1, [DSTK]
        umull	r0, r3, TOS, r1	@  r3:r2 := TOS * r1
        str	r0, [DSTK]	@ store ls32bits on stack
        mov	TOS, r3		@ TOS := ms32bits
	NEXT
ASM_END

CODE M*  ( n1 n2 - d) \ We probably want a 32x32-->64 signed multiply also
        ldr	r1, [DSTK]
        smull	r0, r3, TOS, r1	@  r3:r2 := TOS * r1
        str	r0, [DSTK]	@ store ls32bits on stack
        mov	TOS, r3		@ TOS := ms32bits
	NEXT
ASM_END

CODE RSHIFT
	LDR	TREG, [DSTK], #4
	MOV	TOS, TREG, ASR TOS
	NEXT
ASM_END

CODE LSHIFT
	LDR	TREG, [DSTK], #4
	MOV	TOS, TREG, LSL TOS
	NEXT
ASM_END

CODE 2DUP ( a b - a b a b)
        ldr	r3, [DSTK]
        stmdb	DSTK!, {r3, r4}
	NEXT
ASM_END

CODE C@ ( a - c)
        ldrb	TOS, [TOS]
	NEXT
ASM_END

CODE W@ ( a - w)
        ldrh	TOS, [TOS]
	NEXT
ASM_END

 CODE PICK ( xu ... x1 x0 u -- xu ... x1 x0 xu ) \ 94 CORE EXT
 	ADD	TOS,DSTK,TOS, lsl #2
        ldr	TOS, [TOS,]
	NEXT
ASM_END

 CODE @ ( a - n)
        ldr	TOS, [TOS]
	NEXT
ASM_END

CODE 2@ ( a - n)
	LDMIA   TOS,{R4,R5}
	dpush	r5
	NEXT
ASM_END

CODE 4C@          ( A -- N )      
        MOV     TREG,   TOS
        MOV     TOS,    #0
        LDRB    R3,     [TREG], # 1         \ 㦠 0 
        LDRB    R4,     [TREG], # 1         \ 㦠 1 
        LDRB    R5,     [TREG], # 1         \ 㦠 2 
        LDRB    R6,     [TREG], # 1         \ 㦠 3 
        ADD     TOS,    R3,  R4, LSL # 8    \ ᮡࠥ ᫮  
        ADD     TOS,    TOS,  R5, LSL # 16       
        ADD     TOS,    TOS,  R6, LSL # 24      
        NEXT
ASM_END

CODE C! ( c a -)
        dpop	r1
        strb	r1, [TOS]
	ldr	TOS, [DSTK], #4  \ drop
	NEXT
ASM_END

CODE W! ( c a -)
        dpop	r1
        strh	r1, [TOS]
	ldr	TOS, [DSTK], #4  \ drop
	NEXT
ASM_END

CODE ! ( c a -)
        dpop	r1
        str	r1, [TOS]
	ldr	TOS, [DSTK], #4  \ drop
	NEXT
ASM_END

CODE 2! ( c a -)
        LDMIA   DSTK!,{R0,R1}
    	STMIA	TOS,{R0,R1}
	ldr	TOS, [DSTK], #4  \ drop
	NEXT
ASM_END

CODE 0! ( a -)
CODL OFF
	mov	r1, #0
	str	r1, [TOS]
	ldr	TOS, [DSTK], #4  \ drop
	NEXT
ASM_END

CODE 1+!        ( A -- )
CODL INCR       ( A -- )
        LDR     TREG,     [TOS]
	ADD     TREG,     TREG,    #1 
	STR		TREG,     [TOS]			    \ TREG -> [TOS]
        LDR		TOS,    [DSTK], #4		    \ drop
        NEXT
ASM_END

CODE 1-!        ( A -- )
CODL DECR       ( A -- )
        LDR     TREG,     [TOS]
	SUB     TREG,     TREG,    #1 
	STR		TREG,     [TOS]			    \ TREG -> [TOS]
        LDR		TOS,    [DSTK], #4		    \ drop
        NEXT
ASM_END

CODE SP@
	str	TOS, [DSTK,#-4]!
        MOV	TOS, DSTK
	NEXT
ASM_END

CODE SP!
        MOV	DSTK, TOS
	ldr	TOS, [DSTK], #4
	NEXT
ASM_END

CODE RP@
	str	TOS, [DSTK,#-4]!
	MOV	TOS, RSTK
	NEXT
ASM_END

CODE RP!
	MOV	RSTK, TOS
	ldr	TOS, [DSTK], #4
	NEXT
ASM_END

CODE PERFORM	( ... [tx] -- ...' )
CODL @EXECUTE
	        ldr	TOS, [TOS]
CODL EXECUTE	( ... tx -- ...' )
	swp	TOS, TOS, [DSTK]
CODL SWAPEXECUTE
	ldr	R0, [DSTK], #4
	MOV	pc, R0
ASM_END

CODE 2*		( a - 2a)
	mov	TOS, TOS, lsl #1
	NEXT
ASM_END

CODE CELLS	( a - 4a)
	mov	TOS, TOS, lsl #2
	NEXT
ASM_END

CODE 2/		( a - a/2) \ shift right one place, signed
	mov	TOS, TOS, asr #1
	NEXT
ASM_END

\     
CODE /MOD       ( dividend divisor -- reminder quotient )
        ldr	r1, [DSTK, #0]
	ANDS	R6,tos,#0x80000000
	RSBMI	tos,tos,#0
	EORS	R3,R6,r1,ASR #32
	RSBCS	r1,r1,#0
	MOVS	R8,tos
	BEQ	LL0
LL1:	CMP	R8,r1,LSR #1
	MOVLS	R8,R8,LSL #1
	BCC	LL1
LL2:	CMP	r1,R8
	ADC	R6,R6,R6
	SUBCS	r1,r1,R8
	TEQ	R8,tos
	MOVNE	R8,R8,LSR #1
	BNE	LL2
	MOV	tos,R6
	MOVS	R3,R3,LSL #1
	RSBCS	tos,tos,#0
	RSBMI	r1,r1,#0
        str	r1, [DSTK, #0]
	    NEXT
LL0:	MVN	tos,#0
	MOV	r1,#0
        str	r1, [DSTK, #0]
	    NEXT
ASM_END

CODE U/MOD ( dividend divisor - uR uQ) 
        mov	R6, #0
        ldr	r0, [DSTK]
        mov	r1, #0
        mov	r3, #32
LL0:    movs	r0, r0, lsl #1		@ msbit is now in Carry
        adc	r1, R6, r1, lsl #1	@ R6 contains zero, replacing above 2 instructions
        subs		r1, r1, TOS
        addpl	r0, r0, #1
        addmi	r1, r1, TOS
        subs		r3, r3, #1
        bne	LL0
        str	r1, [DSTK]
        mov	TOS, r0
	NEXT
ASM_END

CODE CMOVE ( c-addr1 c-addr2 u -- ) \ 94 STRING
	ldmia	DSTK!, {r0, r1}
	tst	TOS, TOS
	BEQ	LL1
LL0:	ldrb	R3, [R1],#1
	strb	R3, [R0],#1
	subs    tos, tos, #1
	BNE	LL0
LL1:
	ldr	TOS, [DSTK], #4
	NEXT
ASM_END

CODE CMOVE> ( c-addr1 c-addr2 u -- ) \ 94 STRING
	ldmia	DSTK!, {r0, r1}
	tst	TOS, TOS
	BEQ	LL1
	ADD	R0,TOS, R0
	ADD	TOS,TOS, R1
LL0:	ldrb	R3, [TOS,#-1]!
	strb	R3, [R0,#-1]!
	cmp	TOS,R1
	BNE	LL0
LL1:
	ldr	TOS, [DSTK], #4
	NEXT
ASM_END

CODE ISFLASH ( addr1 -- addr2 ) 
	STMDB	SP!,{LR}
	mov	r0,tos
	bl	' FlashWriteAddr
	mov	tos,r0
	LDMIA	SP!,{PC}
ASM_END


CODE FILL ( c-addr u char -- ) \ 94
	ldmia	DSTK!, {r0, r1}
\	tst	TOS, TOS
\	BEQ	LL1
	ADD	R0,R0, R1
LL0:	strb	TOS, [R1],#1
	cmp	r1, r0
	BNE	LL0
\ LL1:
	ldr	TOS, [DSTK], #4
	NEXT
ASM_END


CODE WFILL ( c-addr u char -- )
	ldmia	DSTK!, {r0, r1}
	ADD	R0,R1, R0, lsl #1
LL0:	strh	TOS, [R1],#2
	cmp	r1, r0
	BNE	LL0
	ldr	TOS, [DSTK], #4
	NEXT
ASM_END

CODE QFILL ( c-addr u char -- )
	ldmia	DSTK!, {r0, r1}
	ADD	R0,R0, R1
LL0:	str	TOS, [R1],#4
	cmp	r1, r0
	BNE	LL0
	ldr	TOS, [DSTK], #4
	NEXT
ASM_END


CODE C_STATUS
	str	TOS, [DSTK,#-4]! \ DUP
	MOV	TOS, UP
	NEXT
ASM_END

CODE UP!
	MOV	UP, TOS
	ldr	TOS, [DSTK], #4
	NEXT
ASM_END

CODE XXXZZZ
	NEXT
	ASM_END

CODE 2W@         ( A -- N )     
CODL X@ ( a - n)
        MOV     TREG,   TOS
        LDRH    R3,     [TREG], # 2         \ 㦠 0 
        LDRH    R2,     [TREG], # 2         \ 㦠 1 
        ADD     TOS,    R3,  R2, LSL # 16   \ ᮡࠥ  
        NEXT
ASM_END



CODE 2W! ( c a -)
CODL X! ( c a -)
        dpop	TREG
        STRH    TREG,   [TOS],  # 2         \ 0 word 뢠 
        MOV     TREG,   TREG,   LSR # 16
        STRH    TREG,   [TOS],  # 2         \ 1 word 뢠 
	ldr	TOS, [DSTK], #4  \ drop
	NEXT
ASM_END


CODE -1! ( A -- )       
CODL ON
	LDR	TREG,     = 0xFFFFFFFF

	STR	TREG,     [TOS]			    \ TREG -> [TOS]
	LDR	TOS,    [DSTK], #4		    \ drop
        NEXT
ASM_END

CODE W0! ( a -)
CODL WOFF
	mov	TREG, #0
	strh	TREG, [TOS]
	ldr	TOS, [DSTK], #4  \ drop

	NEXT
ASM_END

CODE C0! ( a -)
CODL COFF
	mov	TREG, #0
	strb	TREG, [TOS]
	ldr	TOS, [DSTK], #4  \ drop
	NEXT
ASM_END

CODE W-1! ( A -- )       
CODL WON
	LDR	TREG,     = 0xFFFFFFFF
	STRh	TREG,     [TOS]			    \ TREG -> [TOS]
	LDR	TOS,    [DSTK], #4		    \ drop
        NEXT
ASM_END

\EOF

STMDB        SP!, {R4,R5,LR}                      
\ CDPCS        p0, 2, C2, C12, C4, 0                
MRCCS        p2, 1, R3, C2, C0, 1                 
\ CDPCS        p0, 5, C5, C3, C3, 0                 
LDMCCDA      R6!, {R1,R2,R4,R5,R9,R12,SP}         
LDMCCDB      R2!, {R1,R2,R3,R5,R8,R12,SP}         
LDMCCDB      R9!, {R4,R5,R9,R10,R11,SP}           
\ CDPCC        p5, 5, C4, C0, C5, 2                 
\ CDPCC        p11, 5, C4, C3, C3, 0                
STMMIDA      R3, {R0,R6,R10,R12,LR}^              
LDMMIDA      R4, {R0,R1,R8,LR}^                   
LDMMIDA      R4, {R2,R8,LR}^                      
STMMIDB      R1, {R2,R8,R10,R11,LR}^              
STMMIDB      R1, {R0,R3,R8,R10,R11,LR}^           
STMMIDB      R4, {R0,R1,R2,R8,R9,R11,LR}^         
STMMIDB      R6, {R0,R2,R6,R8,R9,R10,R11,R12,LR}^ 
STMMIDB      R6, {R4,R6,R8,R9,R10,R11,R12,LR}^    
STMMIDB      R7, {R2,R6,R8,R9,R10,R11,LR}^        
	MVN	R1, #0xF
	MVN	R1, #0xFF
\	STRSH	R1,[R0,#15]!   \ !!!!!!!!!!!
	str	TOS ,[DSTK,#4]!
	ldr tos, = 0x77777777
	ldr tos, = 0x33334444
	ldrsh W, [IP], #2
	ADD	pc,ip,W		
	MOV	R2,#0x3 
\	MOV	R2,#0x30 
	MOV	R2,#0x300000 

\	ADD	R2,R2,#0x3 
\	ADD	R2,R2,#0x30 
	ADD	R2,R2,#0x300000 
