
REQUIRE ASMARM_MOD ~mak\ARM7\SRC\retarm.f
REQUIRE MTOKEN ~mak\CinF\MTOKEN.F
REQUIRE NUMBER? ~mak\LIB\fpcnum.f 


MODULE: ASMARM_MOD

VECT LEX_EXECUTE
' EXECUTE TO LEX_EXECUTE

0 VALUE ?LEX

CREATE -ASMARM_TABL HERE
  S"  =,#[]{}-!"  S",
  0x9 C, CHAR " C,
HERE OVER - 1- SWAP C!

CREATE ASMARM_TABL HERE
  S"  =,#[]{}!"  S",
  0x9 C, CHAR " C,
HERE OVER - 1- SWAP C!

0 VALUE tail_LEN
S" MLAL" DROP @
S" MULL" DROP @ XOR INVERT CONSTANT $MXXL
S" MULL" DROP @ $MXXL AND   CONSTANT #MXXL

[IFNDEF]  M@ :  M@  @ ; [THEN]
[IFNDEF] MC@ : MC@ C@ ; [THEN]

: TAIL_SET ( addr n1 n2 -- addr n2 )
\ F7_ED
 DUP >R - TO tail_LEN
 DUP R@ +
 SOURCE DROP
 -
 >IN M!
 R> ;


: ASM_INTERPRET ( -> ) \ INTERPRET  ⮩  ⢥ ࠧ⥫
  TRUE  TO ?LEX
  BEGIN \ PARSE-NAME
      SkipDelimiters  EndOfChunk
     IF 0 0 
     ELSE PeekChar [CHAR] - =
 IF ASMARM_TABL ELSE
 -ASMARM_TABL
 THEN
 MTOKEN
     THEN  DUP
  WHILE
[IFDEF] VV_CR
 2DUP CR TYPE
\ F7_ED
[THEN]
	tail_LEN IF tail_LEN 2 > IF 2 TAIL_SET  THEN 0 TO tail_LEN THEN
	SFIND ?DUP
    IF
         STATE M@ =
        IF COMPILE, ELSE LEX_EXECUTE THEN
    ELSE
\ 2DUP CR TYPE

\         S" NOTFOUND" SFIND 
\         IF EXECUTE
\         ELSE 2DROP
 ?SLITERAL
\ THEN
    THEN
    ?STACK
  REPEAT 2DROP
  FALSE  TO ?LEX ;

: tail_INTERPRET ( -> )   \ ⤥ ᨬ ᫮ 믮
  BEGIN  PARSE-NAME DUP
  WHILE
\ 2DUP CR TYPE F7_ED

	0 TO tail_LEN
	DUP 5 U>
	IF OVER 1+ M@ $MXXL AND #MXXL =
		IF	5 TAIL_SET
		THEN
	THEN
	2DUP + 1- MC@ [CHAR] : <> tail_LEN 0= AND \    ⪨
	IF	
		DUP 3 >
		IF	3 TAIL_SET
		THEN   
	THEN
	BEGIN
	SFIND DUP 0= tail_LEN AND	\ ᫨  墮   ᫮
	WHILE DROP			\   ᫥  ?
		tail_LEN DUP >IN M+! +
		0 TO tail_LEN
	REPEAT ?DUP
    IF
         STATE M@ =
        IF COMPILE, ELSE LEX_EXECUTE THEN
    ELSE
         S" NOTFOUND" SFIND 
         IF EXECUTE
         ELSE 2DROP ?SLITERAL THEN
    THEN
    ?STACK
  REPEAT 2DROP
;

0 VALUE ?DOADSP

: DOADSP ( -- )
  TRUE TO ?DOADSP
  BEGIN  REFILL ?DOADSP AND
  WHILE  tail_INTERPRET
  REPEAT ;

: ASM_LEX
   ['] DOADSP  CATCH
 FALSE TO ?LEX ?DUP
 IF THROW THEN ;

: H HH ;
: S S! ;
: { {{ ;
0 VALUE ?MCR
: }  ?MCR IF NIP 0 TO ?MCR BREAK }} ;
: ;  ?LEX 0=  IF	POSTPONE ;	BREAK POSTPONE	\ ; IMMEDIATE
: [  ?LEX 0=  IF POSTPONE	[	BREAK [[ ; IMMEDIATE
: ]  ?LEX 0=  IF		]	BREAK ]] ;
(
: [  ?LEX 0=  IF POSTPONE	[	BREAK
[ ALSO ASMARM_MOD ] [[ [ PREVIOUS ] ; IMMEDIATE
: ]  ?LEX 0=  IF		]	BREAK
[ ALSO ASMARM_MOD ] [[ [ PREVIOUS ] ; )
: !  ?LEX 0=  IF		!	BREAK !! ;
: #  ?LEX 0=  IF		#	BREAK ## ;
: ,  ?LEX 0=  IF		,	THEN ;
: @  ?LEX 0=  IF		@ 	THEN POSTPONE	\ ;
: =  ?LEX 0=  IF 		=	THEN := ;
: //  POSTPONE	\ ; IMMEDIATE

: ASM_END
  ASM_END
\   0xAAAA THROW
  FALSE TO ?DOADSP ;

EXPORT

: MASM_BIG ASM_BIG  ;
: MCODE             CODE  ;

: ASM_BIG ASM_BIG ASM_LEX ;

: CODE             CODE ASM_LEX ;

;MODULE
