
CREATE GPGSV_BUFF 36 2* ALLOT

: MAX_TST MAX_layer 32 UMIN ;

: #CSQlayer ( n1 n2 -- n1 n )
\ DUP U.
\ WDT_CHOP
	DUP TOlayer
	layer_NAME W@ 0xFFFF <> IF EXIT THEN	

 DUP 1 AND          \ / 
 IF  USER_OUT_ON
 ELSE USER_OUT_OFF
 THEN
 CR ." LAYER=" H.

  DUP layer_NAME W!
  GPGSV_BUFF layer_latitude1 16 CMOVE
 DOADC5 ADC5@  9 2*  layer_latitude1 + W!
 DOADC6 ADC6@ 10 2*  layer_latitude1 + W!

  layer_BUFF layer_BLOCK @ 0x100 FLCLR FCMOVE
  MAX_TST ;

: >CSQBUF  ( n -- )
	0
	BEGIN #CSQlayer 1+ DUP MAX_TST 1+ =
	UNTIL DROP DROP ;

: TST_STEP2
  1 ?STT !
 MAX_TST 1+ TOlayer

 6 SECS

 CR ." GPS_SLEEP"  GPS_SLEEP   USER_OUT_ON  7 SECS

  0  layer_latitude1
CR ." Z0=" 2DUP H. H.
 C!

  S" AT+CPOWD=1" 2DUP GTYPE GCR
		    CR TYPE  USER_OUT_OFF  15 SECS
 .GSM
     ?OK OFF
  S" AT" 2DUP GTYPE GCR

  2 TIMEOKERR

		?OK @  1 AND
		ERROR? @ 2 AND  OR  
  layer_latitude1 1+
CR ." Z1=" 2DUP H. H.
 C!

 .GPS
 CR ." GPS_SW"       GPS_INIT  USER_OUT_ON  7 SECS
  PINPUT? 1 SECS PINPUT? OR
 layer_latitude1 2+
CR ." Z2=" 2DUP H. H.
 C!


 CR ." GSM_SW"       GSM_SW  USER_OUT_OFF  7 SECS

 .GSM
     ?OK OFF
  S" AT" GTYPE GCR

  2 TIMEOKERR

		?OK @  1 AND
		ERROR? @ 2 AND  OR 
   layer_latitude1 3 +
CR ." Z3=" 2DUP H. H.
 C!

  layer_BUFF layer_BLOCK @ 0x100 FLCLR FCMOVE

CR ." Z4=" layer_BLOCK @ layer_latitude1 layer_BUFF - +
 DUP H. DUP W@ H. 2+
 DUP H.     W@ H.

;
:   TST_STEP1
  0 TOlayer S" AT+CMGF=1" GTYPE GCR
CR ." <TST>"
 1 ?STT !
 FTST W@ 0= IF EXIT THEN
\ ?OK OFF
 BEGIN
 CSQ    5 aseconds @ + >R
	BEGIN  GQUIT

	INPUT? IF   INPUT #START =
		IF	-1 ?STT +!
		ELSE	1 ?STT !
		THEN
	  THEN ?STT  @ 0< IF RDROP EXIT THEN

  GQUIT
	       R@ aseconds @ - 0< \ ?OK @ OR
	UNTIL RDROP


   MAX_TST  TOlayer layer_latitude1 W@ 0xFFFF <>
 UNTIL ;

: DO-TEST

  TST_STEP1
?STT  @ 0< IF EXIT THEN
  TST_STEP2

?STT  @ 0< IF EXIT THEN

 0
 BEGIN

 1 XOR DUP           \ / 
 IF  USER_OUT_ON
 ELSE USER_OUT_OFF
 THEN
 2 TICS \ 200 FDELAY
 AGAIN

;


: OUTS ( c-addr1 u --- )
\ Output the string starting at c-addr and length u to the terminal.
   OVER + SWAP BEGIN 2DUP -
 WHILE DUP C@ OUTPUT CHAR+ REPEAT 2DROP ;

: DIGIT> ( c -- c1 )
 DUP 10 < 0= IF 7 + THEN 48 + ;

: HHUU
  2*  layer_latitude1 + W@  WOUTPUT ;


: CRPUT 0xD OUTPUT  0xA OUTPUT ;

: TYPE-TEST
 BEGIN  
 S" AT+GSN" GTYPE GCR
 2 SECS \ WDT_CHOP
\	6 aseconds @ +
S" BEGTST" OUTS 0xD OUTPUT  0xA OUTPUT

\    BEGIN
	BEGIN GINPUT?_ 
        WHILE GC_INPUT OUTPUT
        REPEAT
\          DUP aseconds @ - 0<
\    UNTIL DROP

 0xD OUTPUT  0xA OUTPUT

  0
  BEGIN

 GETALARM
 IF      0 VTST W! FL_SAVE
	erase_all
	BEGIN 1 SECS  USER_OUT_ON 1 SECS USER_OUT_OFF AGAIN
 THEN

    DUP TOlayer
	0 HHUU
	1 HHUU
	2 HHUU
	3 HHUU
	4 HHUU
	5 HHUU
	6 HHUU
	7 HHUU
       layer_NAME C@ OUTPUT

	9  HHUU
	10 HHUU
    1+ DUP MAX_TST U>
  UNTIL  TOlayer
	0 HHUU
	1 HHUU
 S" ENDTST" OUTS 0xD OUTPUT  0xA OUTPUT

 AGAIN
;

VARIABLE TNM
