VARIABLE &ROT_N

: TRACKEND &TRACKEND @ ;

: W><  DUP  16 LSHIFT  SWAP 16 RSHIFT OR ;

[IFNDEF] ROT_BUFF
layer_BUFF 0x10 + CONSTANT  ROT_BUFF
[THEN]

: >ROTBUF ( ⨯ buff -- )
 CR ." RB="
 layer_addr ! 
  latitude    W><  layer_latitude1     X!
  longtitude  W><  layer_latitude1 4 + X!
  GTIME 	2 2DUP TYPE ."  "	S>NUM 60 * 30 * DUP H.
  SGTIME	2 2DUP TYPE ."  "	S>NUM 30 * +  DUP H.
  SGTIME 2+	2 2DUP TYPE ."  "	S>NUM 2/ +  DUP H. layer_latitude1  8 + W!
  G_SPEED_ @ 9 2* /   layer_latitude1 10 + C!
  CUR_ANGLE @   2/   layer_latitude1 11 + C!
layer_latitude1 12 + C!
;

: TTBLANK BL TTEMIT ;

: .SEND_TRACK ( n -- )

 TTCR S" BB= " TTTYPE 0 (D.) TTTYPE TTBLANK
 layer_BLOCK @  8 + W@ 0 (D.) TTTYPE TTBLANK
                      
 layer_BLOCK @ 12 + C@ 0 (D.) TTTYPE TTBLANK
 layer_BLOCK @      X@ 0 (D.) TTTYPE TTBLANK
 layer_BLOCK @ 4 +  X@ 0 (D.) TTTYPE TTBLANK
 layer_BLOCK @ 10 + C@ 0 (D.) TTTYPE TTBLANK
 layer_BLOCK @ 11 + C@ 0 (D.) TTTYPE TTBLANK

;

: SEND_TRACK ( n -- )
 CR ." SENDt" 
 0xBB GEMIT
DUP \ KS
  GWEMIT DUP 8 RSHIFT +
  layer_BLOCK @  8 + W@ DUP GWEMIT  2KS+           \ GTIME 2@ DROP 4 S>NUM

  layer_BLOCK @ 12 + C@ DUP GEMIT  +        \   TIP
  layer_BLOCK @      X@ XDUP GDEMIT 4KS+    \ latitude
  layer_BLOCK @ 4 +  X@ XDUP GDEMIT 4KS+    \ longtitude
  layer_BLOCK @ 10 + C@ DUP GEMIT +        \ 
  layer_BLOCK @ 11 + C@ DUP GEMIT +        \ 
  GEMIT

;

: TOlayer1
	WDT_CHOP 0x10 * layer_BLOCK0 + layer_BLOCK ! ;

: #TSTlayer ( n -- n )
 layer_addr @  layer_BLOCK @ 0x10  FCMOVE

\ ⪠ ᫥饣 
\  layer_BLOCK @ 0x10 +
\ 0x1FF AND 0=
\ IF
	FLCLR  -1 layer_BLOCK @ 0x10 + DUP TRACKEND =
	IF DROP layer_BLOCK0 THEN
	IW!
\ THEN
;

: UDPTYPE ( addr len -- ) 
 ['] CCPAUSE C_EXEC
 BEGIN TOPBUF ['] UDPSEND C_EXEC>
 WHILE  1 ?PPP ! PPPLINK  -1 ?PPP !
 REPEAT
 ['] CCPAUSE C_EXEC
;


: ROTBUF>
	?PPP @
	IF
		ROT2PPP
		PPPBUFF COUNT	 UDPTYPE
	ELSE
		ROT_BUFF layer_addr !
		0
		BEGIN	DUP TOlayer1
			layer_BLOCK @  W@ 0xFFFF <>
		WHILE 1+
		REPEAT  CR ." LAYER=" H.
	        #TSTlayer
	THEN ;

: >ROTBUF>

	&ROT_N @ 0x7 AND 5 =
	IF   ROTBUF> CUR_ANGLE @ L_ANGLE_ROTATE ! 0 &ROT_N !
	ELSE &ROT_N @ 0= IF 3 ROT_BUFF >ROTBUF THEN
		 1 &ROT_N +!
	THEN ;


: BEGIN_TRACK
	0
	BEGIN	DUP TOlayer1
		layer_BLOCK @  W@ 0xFFFF <>
	WHILE 1+
	REPEAT

	DUP TOlayer1
	layer_BLOCK @ TRACKEND = IF DROP 0 0 TOlayer1 THEN
	layer_BLOCK @  W@ 0xFFFF =
	IF 1+
	THEN
	
	BEGIN	DUP TOlayer1
		layer_BLOCK @ TRACKEND = IF DROP 0 0 TOlayer1 THEN
		DUP layer_BLOCK @  W@ 0xFFFF = AND
	WHILE 1+
	REPEAT
;

: TRKSEND ( n -- )
  ROT_BUFF >ROTBUF  ROTBUF> ;

