
REQUIRE LPDCB ~mak\COMM4.f
REQUIRE T-C@  ~mak\LIB\THERE\ctheret.f 

: T_C@ (  addr -- c )     
    C@_BUFF 1+   ! 
    C@_BUFF 5 TWRITE
    ['] T-C@ PWAIT ;


: KTWRITE { addr len -- }
   0  addr len + addr
   DO I C@ - LOOP
   addr len + C!
   addr len 1+ TWRITE 
;

: P_C! ;

: T_C! ( c addr -- ) 
    C!_BUFF 2+  ! 
    C!_BUFF 1+ C!
    C!_BUFF 6 KTWRITE 
    ['] P_C! PWAIT ;

: P_W! ;

: T_W! ( c addr -- ) 
    W!_BUFF 3 +   ! 
    W!_BUFF 1+ W!
    W!_BUFF 7 KTWRITE
    ['] P_W! PWAIT ;

: T-W@  ( -- w )
       T-C@
       T-C@    8 LSHIFT OR ;

: T_W@ (  addr -- W )     
    W@_BUFF 1+   ! 
    W@_BUFF 5 TWRITE
    ['] T-W@ PWAIT ;

: P_! ;

: T_! ( c addr -- ) 
\  F7_ED
    !_BUFF 5 + ! 
    !_BUFF 1+  !
    !_BUFF 9 KTWRITE
    ['] P_!
 PWAIT
 ;


: T-@  ( -- c )
    T-W@
    T-C@ 0x10 LSHIFT OR
    T-C@ 0x18 LSHIFT OR ;

: T_@ (  addr -- W )     
\   F7_ED
    @_BUFF 1+   ! 
    @_BUFF 5 TWRITE
    ['] T-@ PWAIT
 ;

: S_INPUT
 ?DUP
    IF T-@ >R 1- RECURSE R>
    THEN ;

: PEXECUTE  T-@ S_INPUT
 ;

: S_OUT
  DEPTH 
    IF >R RECURSE R> 
         EXEC_BUFF 1+ ! EXEC_BUFF 1+ 4 TWRITE
    THEN ;

: TEXECUTE
\   F7_ED
    DEPTH
    EXEC_BUFF 1+   ! 
    EXEC_BUFF 5 TWRITE
    S_OUT
    ['] PEXECUTE PWAIT
 ;

:  PEXECUTE.  ." PEXE" ;
:  T-C@.  ." T-C@" ;
:  T-W@.  ." T-W@" ;
:  T-@.   ." T-@"  ;
:  P_H..  ." PH."  ;
:  P_E.  ." PE."  ;

: P_H.  T-@ H. FJB ;

' P_H.  EXE_TAB #H. CELLS + !

: P_E    T-C@
 DUP 0xA =
 IF
 DROP
 CR
 EXIT THEN  EMIT FJB ;

' P_E  EXE_TAB #E CELLS + !

: P_KEY
  KEY?_BUFF @ 0=
  IF   KEY KEY_BUFF C! 
  THEN
  KEY_BUFF 1 TWRITE \ RDROP 
  KEY?_BUFF 0!
 ;

' P_KEY  EXE_TAB #KEY CELLS + !

: P_KEY?
  KEY?_BUFF @ 0=
  IF   KEY? KEY?_BUFF C! 
  THEN
  KEY?_BUFF 1 TWRITE \ RDROP 
 ;

' P_KEY?  EXE_TAB #KEY? CELLS + !

' CR  EXE_TAB #CR CELLS + !

' T-C@  EXE_TAB #C@ CELLS + !
' T-W@  EXE_TAB #W@ CELLS + !
' T-@   EXE_TAB #@  CELLS + !

' PEXECUTE  EXE_TAB #EXEC CELLS + !

0 VALUE V_START

: P_START  CR ." START" FJB TRUE TO V_START ;

' P_START  EXE_TAB #START CELLS + !

: P_ERROR  ." FROM IPC " FJB ER-U 0! T-@ THROW ;

' P_ERROR  EXE_TAB #ERROR CELLS + !

: P_KS  TRUE ABORT" KS ERROR" ;

' P_KS  EXE_TAB #KS CELLS + !

' P_KS  EXE_TAB #KS CELLS + !

' P_C!  EXE_TAB #C! CELLS + !
' P_W!  EXE_TAB #W! CELLS + !
' P_!   EXE_TAB #!  CELLS + !

: P_HERE  HERE >R RP@ 4 TWRITE RDROP  ;

' P_HERE	EXE_TAB #HERE CELLS + !
' NOOP		EXE_TAB #WDOG CELLS + !

