\ REQUIRE ADD-CONST-VOC ~mak\~day\wincons\wc.f
WINAPI: SetCommState           KERNEL32.DLL
WINAPI: GetCommState           KERNEL32.DLL
WINAPI: SetCommTimeouts        KERNEL32.DLL

0
 CELL FIELD DCBlength            \ sizeof(DCB)                 
 CELL FIELD BaudRate             \ current baud rate           
 CELL FIELD BinaryBits          \ a 32bit cell of bit fields
 \ fBinary              \ binary mode, no EOF check   
 \ fParity              \ enable parity checking      
 \ fOutxCtsFlow         \ CTS output flow control     
 \ fOutxDsrFlow         \ DSR output flow control     
 \ fDtrControl          \ DTR flow control type       
 \ fDsrSensitivity      \ DSR sensitivity             

 \ fTXContinueOnXoff  \ XOFF continues Tx           
 \ fOutX            \ XON/XOFF out flow control       
 \ fInX             \ XON/XOFF in flow control        
 \ fErrorChar       \ enable error replacement        
 \ fNull            \ enable null stripping           
 \ fRtsControl      \ RTS flow control                
 \ fAbortOnError    \ abort reads/writes on error     
 \ CELL FIELD fDummy2          \ reserved                        

    2 FIELD wReserved         \ not currently used              
    2 FIELD XonLim            \ transmit XON threshold          
    2 FIELD XoffLim           \ transmit XOFF threshold         
    1 FIELD ByteSize          \ number of bits/byte, 4-8        
    1 FIELD Parity            \ 0-4=no,odd,even,mark,space      
    1 FIELD StopBits          \ 0,1,2 = 1, 1.5, 2               
    1 FIELD XonChar           \ Tx and Rx XON character         
    1 FIELD XoffChar          \ Tx and Rx XOFF character        
  
    1 FIELD ErrorChar         \ error replacement character     
    1 FIELD EofChar           \ end of input character          
    1 FIELD EvtChar           \ received event character        
    2 FIELD wReserved1        \ reserved  do not use
CONSTANT \DCB


0
CELL FIELD  ReadIntervalTimeout
CELL FIELD  ReadTotalTimeoutMultiplier
CELL FIELD  ReadTotalTimeoutConstant
CELL FIELD  WriteTotalTimeoutMultiplier
CELL FIELD  WriteTotalTimeoutConstant
CONSTANT \COMMTIMEOUTS


CREATE CommTimeOuts \COMMTIMEOUTS ALLOT

10 CommTimeOuts ReadIntervalTimeout !
 1 CommTimeOuts ReadTotalTimeoutMultiplier !
\ 祭  ⠩ - ⮢  墠⠥  㢥७ ਥ 
\   ᪮ 110  
100 CommTimeOuts ReadTotalTimeoutConstant !
\ ᯮ   砥  ६  뫪 
0 CommTimeOuts WriteTotalTimeoutMultiplier !
0 CommTimeOuts WriteTotalTimeoutConstant !
\ TEST

CREATE LPDCB \DCB ALLOT

\ [IFNDEF]  COMMid

0 VALUE COMMid

0x40000000 CONSTANT FILE_FLAG_OVERLAPPED

: COMM_OPEN
  DROP >R
  0
\ FILE_FLAG_OVERLAPPED 
  FILE_ATTRIBUTE_ARCHIVE ( template attrs )
  OPEN_EXISTING
  0 ( secur )
  0 ( share )  
  R/W ( access=fam )
  R> ( filename )
  CreateFileA DUP -1 = IF GetLastError ELSE 0 THEN
  THROW TO COMMid ;


\ S" COM1:" R/W CREATE-FILE THROW VALUE COMMid
(
 S" COM.LOG" R/W CREATE-FILE THROW VALUE COMM_LOGid

LPDCB COMMid  GetCommState 0=  THROW
CommTimeOuts COMMid  SetCommTimeouts  0=  THROW

\ DCB       LPDCB DCBlength !
\ 153600       LPDCB BaudRate  !
\  115000       LPDCB BaudRate  !
\   76800       LPDCB BaudRate  !
\  38400       LPDCB BaudRate  !
  19200       LPDCB BaudRate  !
\   9600       LPDCB BaudRate  !
\   4800       LPDCB BaudRate  !
8          LPDCB ByteSize C!
1          LPDCB StopBits C!
0          LPDCB   Parity C!

LPDCB COMMid  SetCommState 0=  THROW
)
REQUIRE { ~mak\locals2.f
(
: tst { \ bb -- }
 BEGIN ^ bb 1 COMMid READ-FILE 2DROP  bb EMIT
       ^ bb 1 COMMid WRITE-FILE DROP
      KEY?
 UNTIL ; )

: TO_COM  ( ADDR LEN -- )
           COMMid WRITE-FILE DROP ;

: TO_COMN ( ADDR LEN -- )
   TO_COM LT 1 TO_COM ;

: COMM-SET
         LPDCB COMMid  SetCommState	0=  THROW
  CommTimeOuts COMMid  SetCommTimeouts	0=  THROW
\ ័     ( ) 64
\	0x10000 0x10000  COMMid SetupComm 0= THROW
\  PURGE_TXABORT PURGE_RXABORT OR PURGE_RXCLEAR OR PURGE_TXCLEAR OR 
\  COMMid  PurgeComm  0= THROW
;

\ EOF

CREATE SSS 42 ALLOT

(
: FROM_COM
       SSS 1 COMMid READ-FILE DROP
       SSS SWAP  2DUP COMM_LOGid WRITE-FILE DROP  TYPE
 [DEFINED] GUI-CONSOLE   [IF]  GUI-CONSOLE::FlushJetBuf [THEN]      
;
  )

VARIABLE COMBUFIN
VARIABLE COMBUFOUT

  COMBUFOUT 0!
  COMBUFIN  0!
1 0xA LSHIFT CONSTANT COM-BUF-SAZE
CREATE COM-BUF COM-BUF-SAZE ALLOT

: COM-GET  ( -- char )   \  get a character from the buffer
      COMBUFOUT @  COM-BUF-SAZE 1- AND

      COM-BUF +   C@           \ get the byte
      01 COMBUFOUT +!             \ and increment the pointer
      ;

: COM-LAST  ( -- char )   \  get a character from the buffer
      COMBUFOUT @ 1- COM-BUF-SAZE 1- AND
      COM-BUF +   C@           \ get the byte
      ;

: COM-PUT       ( char -- )   \  get a character from the buffer
     COMBUFIN  @  COM-BUF-SAZE 1-  AND
     COM-BUF  +   C!     \ put the byte
      01   COMBUFIN   +!         \ increment the pointer
;

: TASK_COM
 0
 BEGIN   SSS 1 COMMid READ-FILE DROP  IF   SSS C@  COM-PUT THEN
 AGAIN ;

'  TASK_COM TASK:  START_COM

CREATE VFFFF 0 ,

: IPC_INIT VFFFF 1 TO_COM  200 PAUSE ;

: DO_COM
    0 START_COM START DROP ;

: COM-CNT       ( -- count )  \  get how many bytes are in the buffer
     COMBUFIN @  COMBUFOUT @ - COM-BUF-SAZE 1- AND  ;

: COM.
 BEGIN
    COM-CNT  KEY? 0= AND
 WHILE
     COM-GET H.
 REPEAT ;

 CREATE UTTT   0  , 0 ,

: TO_COM_  ( ADDR LEN -- )
\ 1 \  EV_RXCHAR 
\ 4 \ EV_TXEMPTY
\  COMMid SetCommMask 0= THROW
           COMMid
 WRITE-FILE
 DROP ;


: UEMIT ( ." U=" DUP H. ) UTTT C! UTTT 1 TO_COM_ \ 1 PAUSE
;

 DO_COM 
\ S" HELP"  TO_COMN
\ [THEN]
