
REQUIRE OpenDialog ~day\joop\win\filedialogs.f
 lib\win\const.f
REQUIRE [UNDEFINED] lib\include\tools.f
REQUIRE { lib\ext\locals.f
REQUIRE CASE lib\ext\case.f
REQUIRE cmdBYE samples\win\SPFWC\define.h 
REQUIRE $! ~mak\place.f

FILTER: fTest

  NAME" all files" EXT" *.*"
  NAME" FORTH files" EXT" *.F"

;FILTER

OpenDialog :new VALUE tt

: title1
     S" Put on FPauk"
;

 fTest tt :setFilter
title1 tt :setTitle

#define cmdSave cmdDbgInclude
#define cmdSaveAs cmdRunScript

MODULE: GUI-EDIT \ -------------------------------------------

[UNDEFINED] /MSG
[IF]

0
4 -- MSG.hwnd
4 -- MSG.message
4 -- MSG.wParam
4 -- MSG.lParam
4 -- MSG.time
4 -- MSG.pt
4 -- MSG.ex
CONSTANT /MSG
[THEN]

[UNDEFINED] /LOGFONT
[IF]

0
  4 --  lfHeight
  4 --  lfWidth
  4 --  lfEscapement
  4 --  lfOrientation
  4 --  lfWeight
  1 --  lfItalic
  1 --  lfUnderline
  1 --  lfStrikeOut
  1 --  lfCharSet
  1 --  lfOutPrecision
  1 --  lfClipPrecision
  1 --  lfQuality
  1 --  lfPitchAndFamily
 48 --  lfFaceName
CONSTANT  /LOGFONT
[THEN]

[UNDEFINED] /WNDCLASS
[IF]

0
4 -- .style
4 -- .lpfnWndProc
4 -- .cbClsExtra
4 -- .cbWndExtra
4 -- .hInstance
4 -- .hIcon
4 -- .hCursor
4 -- .hbrBackground
4 -- .lpszMenuName
4 -- .lpszClassName
CONSTANT /WNDCLASS
[THEN]


DECIMAL
 TRUE VALUE JetOut
 0 VALUE EdWndProc
 0 VALUE EdHWnd
 0 VALUE Myhwnd
 0 VALUE StatusHwnd
 0 VALUE MAINHWND
 0 VALUE MainMenu
 0 VALUE JetBuf
 0 VALUE *JetBuf
TRUE VALUE ?in
 0 VALUE hFont
-12 VALUE console_font_height
 0  VALUE console_font_width  \ 0-proportional to console_font_height
 0x64 CONSTANT OBSIZE
0x100 VALUE    MAXLIN
 0 VALUE tib
 0 VALUE >in
 0 VALUE KEY_EVENT_GUI       \ event  KEY
 0 VALUE LastKey

  0 VALUE LruBuf              \  history (last recently used)
  8 VALUE LruNum              \    lru
255 VALUE LruLen              \     lru
0 VALUE EDIT-END

VARIABLE  CurrFromLru

: OBJECT_HA  ( length  -- begin addr )
  HERE DUP  0xF + 0xFFFFFFF0 AND SWAP - ALLOT
  HERE \ len here
  OVER \ len here len
  ALLOT \ len here
  DUP ROT  ERASE CONSTANT ;

 /MSG        OBJECT_HA MSG1
 /LOGFONT    OBJECT_HA logfont


204 logfont lfCharSet C!          \ RUSSIAN_CHARSET
console_font_height ( -14) logfont lfHeight !
console_font_width  ( -10) logfont lfWidth  !
0x11 logfont lfPitchAndFamily C!   \ FF_MODERN+FixedPitch
S" Courier" logfont lfFaceName  SWAP CMOVE \ Face Name


: LruAddr ( n -- addr )
  LruLen * LruBuf +
;

: NextLru
  CurrFromLru @
  LruNum 1- = IF CurrFromLru 0!
           ELSE CurrFromLru 1+!
           THEN
;
: PrevLru
  CurrFromLru @
  0  =     IF LruNum 1- CurrFromLru !
           ELSE -1 CurrFromLru +!
           THEN
;

: AddToLru ( addr u )
\ Most recently used
  DUP 0= IF 2DROP EXIT THEN
  CurrFromLru @
  LruAddr 2DUP C!
  1+ 2DUP 2>R
  SWAP CMOVE
  2R> + 0 SWAP C!
  NextLru
;

: UpLru ( -- addr u )
   PrevLru
   CurrFromLru @
   LruAddr COUNT
;

: LruList
  LruNum 0
  DO
     I LruAddr ?DUP IF COUNT TYPE CR THEN
  LOOP
;

: DownLru ( -- addr u )
   NextLru
   CurrFromLru @
   LruAddr COUNT
;

: LOWORD ( lpar -- loword ) 0x0FFFF AND ;
: HIWORD ( lpar -- hiword ) 0x10000 /  ;

: SendToEd
  0 0 ROT EdHWnd SendMessageA DROP
;

CREATE EditFileName  100 ALLOT 

: EDIT_Load  ( <filename> -- )
 {  \ SizeEd Content fid -- }
    2DUP EditFileName $!
         EditFileName COUNT + 0!
    R/O OPEN-FILE 0= IF ." FILE OK"
    DUP TO fid
    FILE-SIZE THROW DROP ?DUP IF
      1+ DUP TO SizeEd
      ALLOCATE THROW DUP TO Content
      SizeEd 1- fid READ-FILE 2DROP
      Content 0 WM_SETTEXT EdHWnd SendMessage DROP
   SP@ >R  0 0 WM_GETTEXTLENGTH SendToEd ." GTX=" .   R> SP!
       GUI-CONSOLE::GetClTextLength      ." GTC=" .

      Content FREE THROW
    THEN
    fid CLOSE-FILE THROW
  ELSE ." FILE ERROR"
    DROP
  THEN
;

: EDIT_Save  ( <filename> -- )
  { fna fnl \ SizeEd Content fid -- }
  \    Script
   SP@ >R
  0 0 WM_GETTEXTLENGTH SendToEd ." GT=" . 1+ DUP TO SizeEd

  ALLOCATE THROW DUP TO Content
  SizeEd WM_GETTEXT SendToEd DROP
  \  
   fna fnl W/O CREATE-FILE THROW TO fid
  \    
  Content SizeEd 1- fid WRITE-FILE THROW
  \    
  Content FREE THROW
  fid CLOSE-FILE THROW 
  R> SP!
;

: DoCommand
    CASE
      cmdInclude  OF    tt :execute DROP tt :fileName DUP
                        IF   EDIT_Load
                        ELSE DROP
                        THEN 
                  ENDOF

      cmdSaveAs   OF  tt :execute DROP tt :fileName DUP
                        IF   EDIT_Save
                        ELSE DROP
                        THEN 
                  ENDOF

      cmdSave     OF   EditFileName COUNT ['] EDIT_Save CATCH ." S=" .
                  ENDOF

      cmdBYE      OF 0 0 WM_CLOSE   Myhwnd SendMessageA DROP
                  ENDOF
      cmdCUT      OF WM_CUT   SendToEd ENDOF
      cmdCOPY     OF WM_COPY  SendToEd ENDOF
      cmdPASTE    OF WM_PASTE SendToEd ENDOF
    ENDCASE
;

: LastLineChange ( addr -- )
   0    0 EM_GETLINECOUNT EdHWnd SendMessageA 1-
   0 SWAP EM_LINEINDEX    EdHWnd SendMessageA DUP
   0 SWAP EM_LINELENGTH   EdHWnd SendMessageA
   OVER + SWAP EM_SETSEL  EdHWnd SendMessageA DROP
       0  EM_REPLACESEL   EdHWnd SendMessageA DROP
;

\ *\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\***
\ **\\\\\   \\\\\\\\\\\\\**
\ ***\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*

:NONAME   { lpar wpar msg hwnd -- }
lpar wpar msg hwnd EdWndProc CallWindowProcA
;

WNDPROC: MyEdWndProc

IMAGE-BASE CONSTANT HINST  \ Instance  

  3 CONSTANT EdID

:NONAME    { lpar wpar msg hwnd \ hdc -- }

   msg CASE

   WM_CREATE OF

(      0
      HINST
      1
      hwnd
      0 0 0 0
      WS_CHILD WS_VISIBLE OR WS_VSCROLL OR WS_HSCROLL OR WS_BORDER OR
      ES_MULTILINE OR
      0
      S" EDIT" DROP
      0
      CreateWindowExA TO EdHWnd )
  (( CreateWindowEx 0 , HINST , EdID , hwnd , 0 , 0 , 0 , 0 ,
   WS_CHILD WS_VISIBLE OR WS_VSCROLL OR ES_AUTOHSCROLL OR
   WS_HSCROLL OR  ES_MULTILINE OR ,
   0 , Z" EDIT" , WS_EX_CLIENTEDGE ) TO EdHWnd

  (( SetWindowLong ['] MyEdWndProc , GWL_WNDPROC , EdHWnd ) TO EdWndProc

      EdHWnd UpdateWindow  DROP
      SW_SHOW EdHWnd ShowWindow  DROP

(      ['] MyEdWndProc
      GWL_WNDPROC
      EdHWnd
      SetWindowLongA
      TO EdWndProc  )

      hwnd GetDC -> hdc
      logfont CreateFontIndirectA TO hFont
      1 hFont WM_SETFONT EdHWnd SendMessageA DROP
      hdc hwnd ReleaseDC DROP
      0
   ENDOF \ 1

   WM_SIZE OF
       1
       lpar HIWORD
       lpar LOWORD
       0 0
       EdHWnd
       MoveWindow DROP
    \   Myhwnd UpdateWindow  DROP
      0
   ENDOF    \ 2

   WM_SETFOCUS OF
      EdHWnd SetFocus DROP
      0
   ENDOF   \ 3

(   WM_PAINT  OF
    EdHWnd UpdateWindow  DROP
    0
   ENDOF)

   WM_COMMAND  OF
      wpar DoCommand
      0
   ENDOF
(
   WM_DESTROY OF
      hwnd GetDC -> hdc
      hFont hdc DeleteObject  DROP
      hdc hwnd ReleaseDC DROP
      0 PostQuitMessage
\      BYE
   ENDOF )
    DUP WM_DESTROY = IF TRUE TO EDIT-END  THEN
     \ default
     lpar wpar msg hwnd DefWindowProcA

     \ need for swap with case parameter
     \ and defwinproc parameter
     SWAP
 ENDCASE
;

WNDPROC: EditWndProc


: MessageLoop
  BEGIN

    0 0 0 MSG1 GetMessageA

  WHILE

    MSG1 TranslateMessage DROP
    MSG1 DispatchMessageA DROP
    EDIT-END IF EXIT THEN

  REPEAT
;

: CreateMainMenu ( -- hmenu )
  CreatePopupMenu >R
  S" &Open"        DROP cmdInclude  MF_STRING R@ AppendMenuA DROP
  S" &Save"        DROP cmdSave     MF_STRING R@ AppendMenuA DROP
  S" Save &As"     DROP cmdSaveAs   MF_STRING R@ AppendMenuA DROP
  S" E&xit"        DROP cmdBYE      MF_STRING R@ AppendMenuA DROP
  S" &File" DROP R> MF_POPUP CreateMenu DUP   >R AppendMenuA DROP

  CreatePopupMenu >R
  S" C&ut"         DROP cmdCUT      MF_STRING R@ AppendMenuA DROP
  S" &Copy"        DROP cmdCOPY     MF_STRING R@ AppendMenuA DROP
  S" &Paste"       DROP cmdPASTE    MF_STRING R@ AppendMenuA DROP

  S" &Edit" DROP R> MF_POPUP R@ AppendMenuA DROP
  R>
;

EXPORT \ ---------------------------------------

:  EditClassName   S" SP-FORTH EDIT" DROP ;

: EditRegisterClass
 \ fill the class structure

HERE   /WNDCLASS ALLOT

    CS_HREDRAW CS_VREDRAW OR    OVER .style         !
    ['] EditWndProc             OVER .lpfnWndProc   !
    0                           OVER .cbClsExtra    !
    0                           OVER .cbWndExtra    !
    HINST                       OVER .hInstance     !
    1 HINST LoadIconA           OVER .hIcon         !
    IDC_ARROW 0 LoadCursorA     OVER .hCursor       !
    WHITE_BRUSH GetStockObject  OVER .hbrBackground !
    0                           OVER .lpszMenuName  !
    EditClassName               OVER .lpszClassName !
    RegisterClassA
  0= ABORT" #Class was not registered!"

     /WNDCLASS NEGATE ALLOT
;

     EditRegisterClass

: EDITED

  CreateMainMenu TO MainMenu
  MainMenu 0= ABORT" #Can't Create Menu!"

  0                             \ pointer to window-creation data
  HINST                         \ handle to application instance
  MainMenu                      \ handle to menu, or child-window identifier
  0                             \ handle to parent or owner window
  0 0                           \ window height, width
  0 0                           \ vertical, horizontal position
  WS_CAPTION  WS_SYSMENU OR WS_THICKFRAME OR WS_MINIMIZEBOX OR
  WS_MAXIMIZEBOX OR  WS_POPUP OR \ style
                                \ address of window name
  EditClassName  DUP            \ address of registered class name
  0                             \ extended window style

  CreateWindowExA
  DUP 0= ABORT" Window not created..."
  TO Myhwnd

  0 400 640 0 0 Myhwnd MoveWindow DROP

  Myhwnd UpdateWindow  DROP
  5 Myhwnd ShowWindow  DROP

  EdHWnd TO MAINHWND

  EDIT_Load

  FALSE TO  EDIT-END
  MessageLoop

\  EdHWnd DestroyWindow DROP

;

;MODULE \ ---------------------------

